Tac       = 0;  % Acausal time delays
Tc        = 20; % Causal time delays
Tar       = 10; % Autoregressive time delays

% x(t) = a(0) + a(1)x(t-1) + a(2)x(t-2) + ... + a(T)x(t-Tar) +
%        b(-Tac+1)S(t+Tac-1) + b(0)S(t-0) + ... + b(1)S(t-1) + ... b(Tc)S(t-Tc)

Names = {'Interplanetary plasma (bulk) speed near Earth',...
	 'Ap index'};

[x,Npd,Time] = ts_slice(Names,[1963 1 1],[2005 12 32],'day');

t = x(:,2); % t = target
x = x(:,1); % x = exogenous input

%t = [1:length(t)]'; % Uncomment these to see where things show up
%x = [1:length(t)]'; % in Xin and T that is input to basic_linear.

for Ts=0:0%6

  [Time1,Xin1] = time_delay2(Time,t,Tx,Ts); % Time delay the target vector
  [Time2,Xin2] = time_delay2(Time,x,Tc,Ts); % Time delay the driver variable

  break
  
  % Align the first timestep 
  [Xin1,Xin2,Time] = time_union([Time1 Xin1],[Time2 Xin2]);
  
  Xin = [Xin1 Xin2];
  I   = find(max([Xin Time],[],2) < 9999); % Remove any rows with one or
					   % more flagged values.
  T   = T(I);
  Xin = Xin(I,:);
  LIN = basic_linear(Xin,T);
  W   = LIN.Weights; % W is "the model".
  Tpr = basic_linear(Xin,W,'predict');
  % sum(LIN.Ttest - Tpr) This should be zero

  Wc{Ts+1} = W;
  
end

save create_arx.mat Wc Tac Tc Tar