% Write parameters of an autoregressive model to a file for arx to read 
%clear

Tac       = 0;
Tc        = 10;
Tx        = 10;
Ts        = 0;
Nin       = 1;
Nx        = 1;
Verbosity = 0;

if (0)
CISM_DX_DATA_DIR = ...
    [CISM_DX_DATA_ROOT,'measurements/uniform_time_series/matfiles/'];

FNAME    = [CISM_DX_DATA_DIR,'OMNIWeb_B_V_Np_1_day_1963_2002.mat'];
           load(FNAME);

FNAME    = [CISM_DX_DATA_DIR,'SEC_Ap_1_day_1963_2002.mat'];
           load(FNAME);
end

Names = {'Plasma (Bulk) speed from OMNIWeb',...
	 'Bz from OMNIWeb',...
	 'Ap index (USAF,v1)'};

Names = {'Plasma (Bulk) speed from OMNIWeb',...
	 'Bz from OMNIWeb',...
	 'ap'};

addpath('/home/cism/weigel/Programs/mymfiles');


arv_nonflag(block_mean_nonflag(T,24,CISM_DX_FLAG,1),...
	    block_mean_nonflag(LIN.Ttrain,24,CISM_DX_FLAG,1));


if (0)
x        = uniform_time_series_slice(Names,[],[],'hour');
save x.mat x
end
load x.mat
t        = x(:,3);

CISM_DX_GLOBALS;
x        = prod_nonflag(x(:,1),rectify_nonflag(-x(:,2),CISM_DX_FLAG,1),...
			CISM_DX_FLAG,1);

d = 3;

for Ts=0:0%6

[T1,Xin1] = time_delay2(t(d+1:end),t(1:end-d),Tx);
[T2,Xin2] = time_delay2(t(d+1:end),x(1:end-d),Tc);

if (Tc-Tx>0)
  Xin1     = Xin1(Tc-Tx+1:end,:);
  T        = T1(Tc-Tx+1:end,:);
end
if (Tc-Tx<=0)
  Xin2     = Xin2(Tx-Tc+1:end,:);
  T        = T2(Tx-Tc+1:end,:);
end

Xin      = [Xin1 Xin2];
I        = find(max([Xin T],[],2) < 9999);
T        = T(I);
Xin      = Xin(I,:);
LIN      = basic_linear(Xin,T)
P        = LIN.Weights;

if (0)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make first element the offset term as required by arx.c
P        = [P(end);P(1:end-1)];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Write model parameter file required by arx.c
fid = fopen(sprintf('P%d.dat',Ts),'w');
fprintf(fid,'%f\n',P');
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Write Po.dat file
TFILE = sprintf('T%d.dat    #\n',Ts);
PFILE = sprintf('P%d.dat    #\n',Ts);
fid = fopen(sprintf('P%do.dat',Ts),'w');
fprintf(fid,TFILE);
fprintf(fid,'X.dat   # The name of the data to read in\n');
fprintf(fid,PFILE);
fprintf(fid,'%d      # Tac\n',Tac);
fprintf(fid,'%d      # Tc\n',Tc);
fprintf(fid,'%d      # T\n',Tx);
fprintf(fid,'%d      # Ts\n',Ts);
fprintf(fid,'%d      # Nin\n',Nin);
fprintf(fid,'%d      # Nx\n',Nx);
fprintf(fid,'%d      # CISM_DX_FLAG\n',CISM_DX_FLAG);
fprintf(fid,'%d      # The level of verbosity',Verbosity);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end
end
