% Write parameters of an autoregressive model to a file for arx to read 
clear
cwd = pwd;cd('../../../mfiles');startup;cd(cwd);

CISM_DX_FLAG      = 99999;
Tac       = 0;
Tc        = 0;
Tx        = 30;
Ts        = 0;
Nin       = 0;
Nx        = 1;
N         = Tx;
Verbosity = 0;

CISM_DX_DATA_DIR = [CISM_DX_DATA_ROOT,'measurements/uniform_time_series/matfiles/'];
FNAME    = [CISM_DX_DATA_DIR,'SEC_Ap_1_day_1963_2002.mat'];
           load(FNAME);
ap       = Ap;

if (0)

% Load the historical Ap data from SEC
eval(sprintf('load %s/Ap_SEC/AP3296.DAT',datadir('nester')))

ap       = DATA_Ap_SEC_AP3296;

% Use Ap data from 1964 to end of 1996 to create 30 day AR model
Io       = find(ap(:,1) == 64);
If       = find(ap(:,1) == 97);
Ap       = ap(Io(1):If(1)-1,:);
% The sixth column is the daily ap.
ap       = ap(:,6);
end

for Ts=0:6

[T,Xin]  = time_delay2(ap,ap,N,Ts);
I        = find(max([Xin T],[],2) < 9999);
T        = T(I);
Xin      = Xin(I,:);
LIN      = basic_linear(Xin,T)
P        = LIN.Weights;

if (0)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make first element the offset term as required by arx.c
P        = [P(end);P(1:end-1)];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Write model parameter file required by arx.c
fid = fopen(sprintf('P%d.dat',Ts),'w');
fprintf(fid,'%f\n',P');
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Write Po.dat file
TFILE = sprintf('T%d.dat    #\n',Ts);
PFILE = sprintf('P%d.dat    #\n',Ts);
fid = fopen(sprintf('P%do.dat',Ts),'w');
fprintf(fid,TFILE);
fprintf(fid,'X.dat   # The name of the data to read in\n');
fprintf(fid,PFILE);
fprintf(fid,'%d      # Tac\n',Tac);
fprintf(fid,'%d      # Tc\n',Tc);
fprintf(fid,'%d      # T\n',Tx);
fprintf(fid,'%d      # Ts\n',Ts);
fprintf(fid,'%d      # Nin\n',Nin);
fprintf(fid,'%d      # Nx\n',Nx);
fprintf(fid,'%d      # CISM_DX_FLAG\n',CISM_DX_FLAG);
fprintf(fid,'%d      # The level of verbosity',Verbosity);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end
end