% Main function to execute Ap models

clear; % Clear memory

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load the startup file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cwd = pwd;
CISM_DX_GLOBALS;

fprintf('___________________________________________________________________\n');
fprintf('Entering main program for running Ap models.\n');
fprintf('___________________________________________________________________\n');
fprintf('\n');fflush(stdout);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get latest Ap and ACE data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if (1)
fprintf('--Start getting new data.\n');fflush(stdout);
clear get_real_time_data
      get_real_time_data('Ap');
      get_real_time_data('ace');
cd(cwd);
fprintf('--Finished getting new data.\n');fflush(stdout);
fprintf('\n');fflush(stdout);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Run the models
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('--Start running models.\n');fflush(stdout);
if (1)
clear run_* pre_* post_* create_*
cd('./Persistence');
  pre_persistence([CISM_DX_DATA_DIR_Ap,'YYYY_MM_DD_HH_MM_SS_Ap.daily.dat'])
  run_persistence
 post_persistence
cd('..');
end

if (1)
clear run_* pre_* post_* create_*
cd('./Autoregressive')
  pre_autoregressive([CISM_DX_DATA_DIR_Ap,'YYYY_MM_DD_HH_MM_SS_Ap.daily.dat'])
  run_autoregressive
 post_autoregressive
cd('..')
end

if (1)
cd('./ARX')
  pre_arx([CISM_DX_DATA_DIR_Ap,'YYYY_MM_DD_HH_MM_SS_Ap.daily.dat'],...
  	  [CISM_DX_DATA_DIR_ACE,'YYYY_MM_DD_HH_MM_SS_V.daily.dat']);
  run_arx
 post_arx
cd('..')
end
fprintf('--Finished running models.\n');fflush(stdout);
fprintf('\n');fflush(stdout);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot the results to .eps files using Octave epsTK
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('--Start plotting data.\n');fflush(stdout);
clear plot_output
      plot_output;
clear plot_output1
%      plot_output1;
clear plot_output2
%      plot_output2;
fprintf('--Finished plotting data.\n');fflush(stdout);
fprintf('\n');fflush(stdout);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Convert the .eps files to .jpg
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('--Start converting .eps file to .jpg ...\n');fflush(stdout);
cd('./web_page');
system([CISM_DX_CONVERT_PATH,...
	' -density  72 -quality 100  Ap_current.eps     Ap_current.jpg']);
system([CISM_DX_CONVERT_PATH,...
	' -density 144 -quality 100  Ap_current.eps  Ap_current_lg.jpg']);
cd('..')
fprintf('--Done converting plots.\n');fflush(stdout);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf('__________________________________________________________________\n');
fprintf('Exiting main program for running Ap models.\n');
fprintf('__________________________________________________________________\n');

