function abs1, x, choice = choice, flag = flag

; returns ABS(X), except if some elements of X are 0, in which case they are
; replaced either by a small positive number, or a flag, or 1.
; If X is filled with 0s, ABS1 prints a warning.

; Speed: 
; When there are no 0 elements, ABS1 is about 2 times slower than ABS.
; When half of the elements are 0, ABS1 is 12 times slower.


index = where(x eq 0, count)
if count eq 0 then begin
	return, abs(x) 
endif else begin
	; default parameter values
	if n_elements(choice) eq 0 then choice = 1
	if n_elements(flag) eq 0 then flag = 1.d-12
	y = abs(x)
	temp = max(y)
	if temp eq 0 then print, 'WARNING: Argument of ABS1 is zero.'
	case choice of
		1: begin
			y(index) = temp+1.d0
			y(index) = min(y)
			; Note: if Y is all zeros, this sets
			; it to 1!
			; Also note: the MIN cannot be
			; taken in a previous step.
		end
		2: y(index) = flag
		3: y(index) = 1.d0
	endcase
	return, y
endelse


end
