function avern, a, ia, $
	singlecolumn = sc


; The function averages some of the M COLUMNS OVER the N ROWS of the
; rectangular matrix A = A(M,N). Usually N>=M.
; If the matrix is a delay matrix from one of more time series of length N,
; then the averaging of the columns corresponds to averaging selected 
; dimensions of the time series.
; The averaging is performed only on the COLUMNS indicated by the nonzero 
; elements of the index array IA = IA(M). IA is a vector of dimension M.

; Notes:
; 1. The rest of the return array B is set to zero.
; 2. If SINGLECOLUMN is on, the function returns a vector rather than an array.
; 3. Reminder: in IDL the ROWS are designated as the SECOND index,
;    the COLUMNS as the second index: array(nrows, ncolumns)


; derived variables
b = a*0.
c = where(ia ne 0)


for i = 0, n_elements(c)-1 do b(c(i),*) = average(a(c(i),*))


; If SC (single column) is 1 then reduce array B into a column.
if n_elements(sc) ne 0 then b = b(*,0)


return, b
end
