pro printprep, printout, charsize, $
	device = device1, $
	window = window1


; printout:
;	0: output is screen or the Z buffer
;	1: output is printer
; window: only for 'X' device.
;	Default is zero.


; default parameters
if n_elements(window1) eq 0 then window1 = 0


; define constants
aspect_ratio = 1.3


!p.charsize = charsize
if printout eq 1 then begin
	if n_elements(device1) eq 0 then device1 = 'PS'
	set_plot, device1, /interpolate
	device, $
		/inches, ysize = 9., yoffset = 1.0, $
		/color, $
		bits_per_pixel = 8
	; red   = [255,0,255,0  ,0  ,255,255,181]
	; green = [255,0,0  ,255,0  ,255,200,216]
	; blue  = [255,0,0  ,0  ,255,118,200,219]
	; tvlct, red, green, blue
	!p.thick = 3.
	!p.charthick = 3.
endif else begin
	if n_elements(device1) eq 0 then device1 = 'X'
	set_plot, device1, /interpolate
	;xsize1 = 636
	xsize1 = 570
	ysize1 = xsize1*aspect_ratio
	case device1 of
		'x': window, window1, xsize = xsize1, ysize = ysize1, retain = 2
		'X': window, window1, xsize = xsize1, ysize = ysize1, retain = 2
		'z': device, set_resolution = [xsize1, ysize1]
		'Z': device, set_resolution = [xsize1, ysize1]
	endcase
	!p.color = 1
	!p.thick = 1.
	!p.charthick = 1.
endelse


return
end
