% Main function to execute Electron models

clear; % Clear memory

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load the startup file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cwd = pwd;
CISM_DX_GLOBALS;

fprintf('__________________________________________________________________\n');
fprintf('Entering main program for running Electron models.\n');
fprintf('__________________________________________________________________\n');
fprintf('\n');fflush(stdout);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get latest ACE data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if (1)
fprintf('--Start getting new data.\n');fflush(stdout);
clear get_real_time_data
get_real_time_data('ace');
cd(cwd);
fprintf('--Finished getting new data.\n');fflush(stdout);
fprintf('\n');fflush(stdout);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Run the models
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('--Start running models.\n');fflush(stdout);
if (1)
clear run_* pre_* post_* create_*
cd('je_fir');
   pre_fir([CISM_DX_DATA_DIR_ACE,'YYYY_MM_DD_HH_MM_SS_V.daily.dat']);
   run_fir;
  post_fir;
cd('..');
end

fprintf('--Finished running models.\n');fflush(stdout);
fprintf('\n');fflush(stdout);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot the results to .eps files
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('--Start plotting data.\n');fflush(stdout);
clear plot_output
      plot_output;
fprintf('--Finished plotting data.\n');fflush(stdout);
fprintf('\n');fflush(stdout);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Convert the .eps files to .jpg
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('--Start converting .eps file to .jpg ...\n');fflush(stdout);
cd('web_page');
system([CISM_DX_CONVERT_PATH,...
	' -density  72 -quality 100 je_current.eps je_current.jpg']);
system([CISM_DX_CONVERT_PATH,...
	' -density 144 -quality 100 je_current.eps je_current_lg.jpg']);
cd('..')
fprintf('--Done converting plots.\n');fflush(stdout);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('__________________________________________________________________\n');
fprintf('Exiting main program for running Electron models.\n');
fprintf('____________________________________________________________________\n');

