% Write parameters of an autoregressive model to a file for arx to read 
clear

CISM_DX_FLAG      = 99999;
Tac       = 0;
Tc        = 0;
Tx        = 30;
Ts        = 0;
Nin       = 0;
Nx        = 1;
N         = 30;
Verbosity = 0;

% Load the historical Ap data from SEC
fname    = sprintf('OMNIWeb_B_V_Np_Position_1_day_1963-2002.dat');
x        = load(fname);
x        = x(:,4);

for Ts=0:6

[T,Xin]  = time_delay2(x,x,N,Ts);
I        = find(max([T Xin],[],2) < 9999);
T        = T(I);
Xin      = Xin(I,:);
LIN      = basic_linear(Xin,T)
P        = LIN.Weights;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make first element the offset term as required by arx.c
P        = [P(end);P(1:end-1)];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Write model parameter file required by arx.c
fid = fopen(sprintf('P%d.dat',Ts),'w');
fprintf(fid,'%f\n',P');
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Write Po.dat file
TFILE = sprintf('T%d.dat    #\n',Ts);
PFILE = sprintf('P%d.dat    #\n',Ts);
fid = fopen(sprintf('P%do.dat',Ts),'w');
fprintf(fid,TFILE);
fprintf(fid,'X.dat   # The name of the data to read in\n');
fprintf(fid,PFILE);
fprintf(fid,'%d      # Tac\n',Tac);
fprintf(fid,'%d      # Tc\n',Tc);
fprintf(fid,'%d      # T\n',Tx);
fprintf(fid,'%d      # Ts\n',Ts);
fprintf(fid,'%d      # Nin\n',Nin);
fprintf(fid,'%d      # Nx\n',Nx);
fprintf(fid,'%d      # CISM_DX_FLAG\n',CISM_DX_FLAG);
fprintf(fid,'%d      # The level of verbosity',Verbosity);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end