function pre_autoregressive(FILENAME)
% Prepares input files for run_autoregressive

CISM_DX_GLOBALS; % Load global variables

fprintf('Program pre_autoregressive.m is preparing input files ...\n');fflush(stdout);

X     = load(FILENAME);  
LAST  = datenum(X(end,1),X(end,2),X(end,3));
TODAY = floor(now);

if (TODAY-LAST == 0)
  fprintf('   (Last real time data available today.)\n',TODAY-LAST);fflush(stdout);
end
if (TODAY-LAST > 1)
  fprintf('   (Last real time data available %d day(s) ago.)\n',TODAY-LAST);fflush(stdout);
end

if (0)
for i = 1:TODAY-LAST
DAY   = datestr(LAST+i,29);
x1    = [str2num(DAY(1:4)),str2num(DAY(5:6)),str2num(DAY(7:8)),23,59,59,99999];
X     = [X ; x1];
end
end


for i = 1:7
x1    = [ymd(LAST+i),23,59,59,99999];
X     = [X ; x1];
end

% Write input file with timestamp
fid = fopen('T_full.dat','w');
for i = 1:size(X,1)
  fprintf(fid,'%4d %2d %2d %2d %2d %2d %8.2f\n',X(i,:));
end
fclose(fid);

% Write input file with timestamp
fid = fopen('X_full.dat','w');
for i = 1:size(X,1)
  fprintf(fid,'%4d %2d %2d %2d %2d %2d %8.2f\n',X(i,:));
end
fclose(fid);

% Write input file for arx.c
fid = fopen('X.dat','w');
fprintf(fid,'%f\n',X(:,7));
fclose(fid);

fprintf('... done preparing input files.\n');fflush(stdout);