%CISM_DX_GLOBALS Loads the .mat file CISM_DX_GLOBALS-Octave[Matlab].mat
%
%   Usage: CISM_DX_GLOBALS
%
%   See also CISM_DX_startup.

global CISM_DX_GLOBALS_FILE

if isempty(whos('CISM_DX_GLOBALS_FILE'))
  if (is_octave)
    CISM_DX_GLOBALS_FILE = 'CISM_DX_GLOBALS-Octave.mat';
  else
    CISM_DX_GLOBALS_FILE = 'CISM_DX_GLOBALS-Matlab.mat';
  end
end

if ~exist(CISM_DX_GLOBALS_FILE)

  warnstr = sprintf('Could not find file %s in your path.\n',...
		    CISM_DX_GLOBALS_FILE);
  warnstr = sprintf('%sCalling CISM_DX_startup, which creates this file.\n',...
		    warnstr);
  warning(warnstr)

  CISM_DX_startup;
  global CISM_DX_GLOBALS_FILE

  if ~exist(CISM_DX_GLOBALS_FILE) % If it still does not exist
    errstr = sprintf('Attempt to create file %s failed.\n',CISM_DX_GLOBALS_FILE);
    errstr = sprintf('Try exiting Octave/Matlab and restarting.\n');
    error(errstr);
  end
end

if (is_octave)
  eval(sprintf('load -force %s',...
	       file_in_path(LOADPATH,CISM_DX_GLOBALS_FILE)));
else
  eval(sprintf('load %s',CISM_DX_GLOBALS_FILE));
end

