%%NAME
%%  etitle2 - print title of plot
%%
%%SYNOPSIS
%%  etitle2 ([text[,distance[,fontSize]]])
%%
%%PARAMETER(S)
%%  text     title text
%%  distance distance from plot area
%%  fontSize fontsize of text
%%
%%GLOBAL PARAMETER(S)
%%  ePlotTitleText
%%  ePlotTitleDistance
%%  ePlotTitleFontSize
%%  ePlotTitleTextFont
%%  ePlotAreaPos
%%  ePlotAreaWidth
%%  ePlotAreaHeight
% written by Stefan Mueller stefan.mueller@fgan.de 2002

function etitle2(text,distance,fontSize)
  if  nargin >3
    usage('etitle([text[,distance[,fontSize]]])');
  end
  eglobpar2;
  if nargin>0
    ePlotTitleText=text;
  end
  if nargin>1
    ePlotTitleDistance=distance;
  end
  if nargin>2
    ePlotTitleFontSize=fontSize;
  end
  if strcmp(ePlotTitleText,'')~=1
    etext2(ePlotTitleText,ePlotAreaPos(1)+ePlotAreaWidth/2,...
       ePlotAreaPos(2)+ePlotAreaHeight+ePlotTitleDistance,...
       ePlotTitleFontSize,0,ePlotTitleTextFont,0);
  end
