fprintf('\n\n\n\n\n');
fprintf('%s\n',repmat('_',1,78));
fprintf('Tutorial of Octave/Matlab functions in CISM_DX package\n');
fprintf('%s\n',repmat('_',1,78));
fprintf('Select tutorial to run.\n');
%fprintf('1.  Run forecast models.\n');
fprintf('2.  List all data available through TSDS.\n');
fprintf('3.  Get a time series from the TSDS time series data set.\n');
fprintf('4.  Get selected time series in a date range.\n');
%fprintf('5.  List all CISM_DX global variables.\n');

fflush(stdout);
value = input('\nEnter number (1-5) or return to exit: ','s');

if (isempty(value))
  return;
end

if (strmatch(value,'1'))
  fprintf('\nExecuting command: run_forecast_models;\n\n');fflush(stdout);
  input('Hit Enter to Continue');
  run_forecast_models;
  value = '1'; % Kludge because above clears memory.
end

if (strmatch(value,'2'))
  fprintf('\nExecuting command: ts_list;\n\n');fflush(stdout);
  input('Hit Enter to Continue');
  ts_list;
end

if (strmatch(value,'3'))
  fprintf('\nExecuting command: \n')
  fprintf('[I,Data] = ts_get(''Bz IMF near Earth (OMNIWeb1 1-hour)'');\n');
  input('Hit Enter to Continue');
  [I,Data] = ts_get('Bz near Earth (GSM) (OMNIWeb1 1-hour)');
end

if (strmatch(value,'4'))
  fprintf('\nExecuting command: ts_slice_demo;\n');
  fprintf('Hint: \"which ts_slice_demo\" prints where the file is located.\n');
  fprintf('Hint: \"type ts_slice_demo\" prints the file to screen.\n\n');
  input('Hit Enter to Continue');
  ts_slice_demo
end

if (strmatch(value,'5'))
  fprintf('\nGlobal variables are set upon startup, when the file\n');
  fprintf('CISM_DX_startup.m is read and the file CISM_DX_GLOBALS.mat\n');
  fprintf('is created.  To access these variables, execute the script\n');
  fprintf('CISM_DX_GLOBALS which loads CISM_DX_GLOBALS.mat.  All global\n');
  fprintf('variables are prefixed with CISM_DX_\n');
  fprintf('\n Executing command: CISM_DX_GLOBALS ; whos CISM_DX_*\n');
  CISM_DX_GLOBALS ; whos CISM_DX_*;  
end
