fprintf('\n\n\n\n\n');
fprintf('%s\n',repmat('_',1,78));
fprintf('Tutorial of Octave/Matlab functions in CISM_DX package\n');
fprintf('%s\n',repmat('_',1,78));
fprintf('Select tutorial to run.\n');
fprintf('1.  Run forecast models.\n');
fprintf('2.  Query the CISM_DX uniform time series data set.\n');
fprintf('3.  Get a time series from the CISM_DX uniform time series data set.\n');
%fprintf('4.  Plot data from the CISM_DX uniform time series data set.\n');
fprintf('5.  Get selected time series in a date range.\n');
fprintf('6.  List all demo programs.\n');
fprintf('7.  List all CISM_DX global variables.\n');

fflush(stdout);
value = input('\nEnter number (1-7) or return to exit: ','s');

if (isempty(value))
  return;
end

if (strmatch(value,'1'))
  fprintf('\nExecuting command: run_forecast_models;\n\n');fflush(stdout);
  input('Hit Enter to Continue');
  run_forecast_models;
  value = '1'; % Kludge because above clears memory.
end

if (strmatch(value,'2'))
  fprintf('\nExecuting command: ts_list;\n\n');fflush(stdout);
  input('Hit Enter to Continue');
  ts_list;
end

if (strmatch(value,'3'))
  fprintf('\nExecuting command: \n')
  fprintf('[I,Data] = ts_get(''Bz IMF near Earth (OMNIWeb 1-hour)'');\n');
  [I,Data] = ts_get('Bz IMF near Earth (OMNIWeb 1-hour)');
end

if (0)
if (strmatch(value,'4'))
  fprintf('\nExecuting command: make_plots_1_day;\n\n');fflush(stdout);
  input('Hit Enter to Continue');
  make_plots_1_day;
  fprintf('\nYou can view the above-listed .eps file with ');
  fprintf('gsview \nor gimp (all platforms), or Adobe Illustrator (Windows).\n');
  fprintf('\n*** Hint: If your postscript viewer does not render the time\n');
  fprintf('*** series but renders the Axes, turn off antialiasing in your\n');
  fprintf('***  viewer preferences.\n');
  value = '4'; % Kludge because above clears memory
end
end

if (strmatch(value,'5'))
  fprintf('\nExecuting command: ts_get_demo;\n');
  fprintf('Hint: \"which ts_get_demo\" prints where the file is located.\n');
  fprintf('Hint: \"type ts_get_demo\" prints the file to screen.\n\n');
  input('Hit Enter to Continue');
  ts_get_demo
  fflush(stdout);  
  value = '5'; % Kludge because above clears memory
end

if (strmatch(value,'6'))

temp =   {'mfiles/matlab_only/perlop_demo.m',...
	  'mfiles/matlab_only/remove_lines_demo.m',...
	  'mfiles/data_analysis_functions/diff_nonflag_demo.m',...
	  'mfiles/data_analysis_functions/mean_nonflag_demo.m',...
	  'mfiles/data_analysis_functions/moving_mean_nonflag_demo.m',...
	  'mfiles/data_analysis_functions/nonflag_demo.m',...
	  'mfiles/data_analysis_functions/scale_demo.m',...
	  'mfiles/data_analysis_functions/unscale_demo.m',...
	  'mfiles/datafile_load_functions/uniform_time_series_get_demo.m',...
	  'mfiles/physical_functions/coupling_function_demo.m',...
	  'mfiles/plot_functions/esubplot2_demo.m',...
	  'mfiles/plot_functions/plot_1d_demo.m',...
	  'mfiles/plot_functions/plot_2d_demo.m',...
	  'mfiles/plot_functions/plot_contour_demo.m',...
	  'mfiles/time_functions/date_labels_demo.m',...
	  'mfiles/time_functions/month_labels_demo.m',...
	  'mfiles/time_functions/time_union_demo.m',...
	  'mfiles/time_functions/ut_doy_ave_demo.m',...
	  'mfiles/time_functions/ut_doy_labels_demo.m',...
	  'mfiles/time_functions/year_labels_demo.m',...
	  'mfiles/time_functions/ymd_demo.m',...
	  'required_packages/read_hdf_sd_octave/load_hdf_demo.m',...
	  'required_packages/read_hdf_sd_octave/hdfread_demo.m',...
	  'required_packages/libflag_matlab/moving_mean_nonflag_demo.m',...
	  'required_packages/libflag_octave/moving_mean_nonflag_demo.m',...
	  'required_packages/cxform_octave/cxform_demo.m'};

str2mat(temp)

end

if (strmatch(value,'7'))
  fprintf('\nGlobal variables are set upon startup, when the file\n');
  fprintf('CISM_DX_startup.m is read and the file CISM_DX_GLOBALS.mat\n');
  fprintf('is created.  To access these variables, execute the script\n');
  fprintf('CISM_DX_GLOBALS which loads CISM_DX_GLOBALS.mat.  All global\n');
  fprintf('variables are prefixed with CISM_DX_\n');
  fprintf('\n Executing command: CISM_DX_GLOBALS ; whos CISM_DX_*\n');
  CISM_DX_GLOBALS ; whos CISM_DX_*;  
end
