#include <stdio.h>
#include <dx/dx.h>
#define MAX_NAME_SIZE 256

Error
m_UnitConvert1(Object *in, Object *out)
{
  /*Declarations*/
  Field converted;
  Array mas_arrayd, mas_arrayp, mas_conn; //array from input field
  Array temp_array, temp_array2;
  float *position, *mas_pos, *mas_data,*data;//arrays from input used for calculations
  Type data_type,pos_type;
  int ndata, npos, data_shape, data_rank, pos_rank, pos_shape, i; //position and data array attributes
  Category data_cat, pos_cat;
  char *sel=NULL;

  

  //Getting the inputs:0 is the data Field; 1 is the select module for which unit type

  if (!in[0]){DXSetError(ERROR_BAD_PARAMETER,"missing field");
     goto error;}
  else{
    
    mas_arrayd=(Array)DXGetComponentValue((Field)in[0],"data");
    mas_data=DXGetArrayData(mas_arrayd);
    mas_arrayp=(Array)DXGetComponentValue((Field)in[0],"positions");
    mas_pos=DXGetArrayData(mas_arrayp);
    mas_conn=(Array)DXGetComponentValue((Field)in[0],"connections");
    DXGetArrayInfo(mas_arrayd, &ndata,&data_type, &data_cat, &data_rank,
		   &data_shape);
    DXGetArrayInfo(mas_arrayp,&npos, &pos_type, &pos_cat, &pos_rank,
		   &pos_shape);
   
  }

   if (!in[1]){DXSetError(ERROR_BAD_PARAMETER,"missing field");
     goto error;}
   else{
     DXExtractString((Object)in[1],&sel);
     
     
     //For Enlil Units this is the conversion
     if(strcmp(sel,"a.0")==0)
       {


  temp_array= DXNewArray(pos_type, pos_cat, pos_rank, pos_shape);
  DXAddArrayData(temp_array,0, npos, NULL);
  position=DXGetArrayData(temp_array);

  temp_array2=DXNewArray(data_type, data_cat, data_rank, data_shape);
  DXAddArrayData(temp_array2, 0, ndata, NULL);
  data=DXGetArrayData(temp_array2);

 
 

  //Position Conversion
  for( i=0;i<3*npos;i++)
    {
      position[i]=6.98e6*mas_pos[i];
    }
  



  
  //Density
  for(i=0;i<20*ndata;i=i+20)
    {
      data[i]=1.0e8*mas_data[i];
    }
  
  //Pressure
  for(i=1; i<20*ndata; i=i+20)
    {
      data[i]=0.387*mas_data[i];
    }
  //Br
  for(i=2; i<20*ndata; i=i+20)
    {
      data[i]=2.205e5*mas_data[i];
    }
  //Bthe
  for(i=3; i<20*ndata; i=i+20)
    {
      data[i]=2.205e5*mas_data[i];
    }
  //Bphi
  for(i=4; i<20*ndata; i=i+20)
    {
      data[i]=2.205e5*mas_data[i];
    }
  //Vr
  for(i=5; i<20*ndata; i=i+20)
    {
      data[i]=481.37*mas_data[i];
    }
  //Vthe
  for(i=6; i<20*ndata; i=i+20)
    {
      data[i]=481.37*mas_data[i];
    }
  //Vphi
  for(i=7; i<20*ndata; i=i+20)
    {
      data[i]=481.37*mas_data[i];
    }
  //Jr
   for(i=8; i<20*ndata; i=i+20)
    {
      data[i]= 0.0753806*mas_data[i];
    }
   //Jthe
    for(i=9; i<20*ndata; i=i+20)
    {
      data[i]= 0.0753806*mas_data[i];
    }
    //Jphi
     for(i=10; i<20*ndata; i=i+20)
    {
      data[i]= 0.0753806*mas_data[i];
    }
  
     //Bx
    for(i=11; i<20*ndata; i=i+20)
    {
      data[i]=2.205e5*mas_data[i];
    }
    //By
    for(i=12; i<20*ndata; i=i+20)
    {
      data[i]=2.205e5*mas_data[i];
    }
    //Bz
    for(i=13; i<20*ndata; i=i+20)
    {
      data[i]=2.205e5*mas_data[i];
    }
    //Vx
    for(i=14; i<20*ndata; i=i+20)
    {
      data[i]=481.37*mas_data[i];
    }
    //Vy
    for(i=15; i<20*ndata; i=i+20)
    {
      data[i]=481.37*mas_data[i];
    }
    //Vz
    for(i=16; i<20*ndata; i=i+20)
    {
      data[i]=481.37*mas_data[i];
    }
    //Jx
   for(i=17; i<20*ndata; i=i+20)
    {
      data[i]= 0.0753806*mas_data[i];
    }
   //Jy
   for(i=18; i<20*ndata; i=i+20)
    {
      data[i]= 0.0753806*mas_data[i];
    }
   //Jz
   for(i=19; i<20*ndata; i=i+20)
    {
      data[i]= 0.0753806*mas_data[i];
    }

  

 
  converted=DXNewField();
  
 if(!DXSetStringAttribute((Object)temp_array2, "dep", "positions"))
   {
     DXSetError(ERROR_INTERNAL,"cant set dep");
     DXMessage("got this far(10)");  
     goto error;}

 if(!DXSetComponentValue(converted, "data",(Object)temp_array2))
    {
      DXSetError(ERROR_INTERNAL,"cant set data");
      goto error;}


  if(!DXSetComponentValue(converted, "positions",(Object)temp_array))
   {
     DXSetError(ERROR_INTERNAL,"cant get pos");
     goto error;}
 

 if(!DXSetComponentValue(converted,"connections",(Object)mas_conn))
    {
      DXSetError(ERROR_INTERNAL,"cant set conn");
      goto error;}

  if(!DXEndField(converted))
    {
      DXSetError(ERROR_INTERNAL,"cant set dep");
      goto error;}


  out[0]=(Object)converted;
  return OK;
       }

     //This keeps MAS code units
     else{
       out[0]=in[0];
       return OK;
          }




 error:
  return ERROR;
       
   }
}
