#include <stdio.h>
#include <math.h>
#include <dx/dx.h>

#define MAX_LENGTH 256

Error m_FileLoop(Object *in, Object *out)
{
  int i, j, iNumFiles, iNumSteps, iStart, iStop, iIntrvl, iStep; 
  int iLen, iBaseLen, iTiffLen;
  int *ipStart, *ipStop, *ipDelta;
  int iInputExtLen, iOutputExtLen;
  char *cpAnimateFile, caBaseDir[MAX_LENGTH], caTiffDir[MAX_LENGTH];
  char *cpInputExt, *cpOutputExt;
  char caFileName[MAX_LENGTH], **cppInFiles, **cppOutFiles,  *cpPtr;
  char **cppInSteps;
  Array AInFiles, AOutFiles;
  FILE *FpAnimateFile;

  /* Extract animate.txt file name */

  if(!in[0]) {
    DXSetError(ERROR_BAD_PARAMETER,"Missing Input Filename");
    goto error;
  } 
  if (!DXExtractString(in[0], &cpAnimateFile)) {
    DXSetError(ERROR_BAD_PARAMETER, "Animate File must be a string");
    goto error;
  }
  if(!in[1]) {
    cpInputExt = ".hdf";
  } else if (!DXExtractString(in[1], &cpInputExt)) {
    DXSetError(ERROR_BAD_PARAMETER, "Input Ext must be a string");
    goto error;
  }
    iInputExtLen = strlen(cpInputExt);
  if(!in[2]) {
   cpOutputExt = ".tiff";
  } else  if (!DXExtractString(in[2], &cpOutputExt)) {
    DXSetError(ERROR_BAD_PARAMETER, "Output Ext must be a string");
    goto error;
  }
    iOutputExtLen = strlen(cpOutputExt);
  /* Now we open the animate.txt file and read the files to be processed */
  FpAnimateFile = fopen(cpAnimateFile,"r");
  if(!FpAnimateFile) {
    DXSetError(ERROR_DATA_INVALID,"Cannot open animte file");
    goto error;
  }
  fscanf(FpAnimateFile,"%d",&iNumFiles);
  fscanf(FpAnimateFile,"%s",caBaseDir);
  iBaseLen = strlen(caBaseDir);
  fscanf(FpAnimateFile,"%s",caTiffDir);
  iTiffLen = strlen(caTiffDir);
  /* DXMessage("%d %s %s",iNumFiles,caBaseDir,caTiffDir);*/
  cppInFiles = (char *)DXAllocate(iNumFiles*sizeof(char*));
  cppOutFiles = (char *)DXAllocate(iNumFiles*sizeof(char*));
  ipStart = (int*)DXAllocate(iNumFiles*sizeof(int));
  ipStop = (int*)DXAllocate(iNumFiles*sizeof(int));
  ipDelta = (int*)DXAllocate(iNumFiles*sizeof(int));
  iNumSteps = 0;
   for(i=0;i<iNumFiles;i++) {
    fscanf(FpAnimateFile,"%s %d %d %d",caFileName,&iStart,&iStop,&iIntrvl);
    ipStart[i] = iStart;
    ipStop[i] = iStop;
    ipDelta[i] = iIntrvl;
    iNumSteps += (iStop-iStart)/iIntrvl + 1;
    /* DXMessage("%s %d %d %d",caFileName,iStart,iStop,iIntrvl);*/
    iLen = strlen(caFileName);
    /* DXMessage("%d %d %d %s",iTiffLen,iLen,iInputExtLen,cpInputExt);*/
    cpPtr = (char *) DXAllocate((iBaseLen+iLen+iInputExtLen+1)*sizeof(char));
    strcpy(cpPtr,caBaseDir);
    strcat(cpPtr,caFileName);
    strcat(cpPtr,cpInputExt);
    cppInFiles[i] = cpPtr;
    /*DXMessage("%d %d %d %s",iTiffLen,iLen,iOutputExtLen,cpOutputExt);*/
    cpPtr = (char *) DXAllocate((iTiffLen+iLen+iOutputExtLen+1)*sizeof(char));
    strcpy(cpPtr,caTiffDir);
    strcat(cpPtr,caFileName);
    strcat(cpPtr,cpOutputExt);
    cppOutFiles[i] = cpPtr;
   }
   /* Now we create the output array and put the string list into it*/
   /* DXMessage("Animate.txt file read %d",iNumSteps);*/
   AInFiles = DXMakeStringListV(iNumFiles,cppInFiles);

   /* Now we loop over each file and create the complete list of files and steps*/
   /* to be proccessed*/
   iStep = 0;
   cppInSteps = (char *)DXAllocate(iNumSteps*sizeof(char*));
   for(i=0;i<iNumFiles;i++) {
      if ( ipDelta[i] > 0) {
         for(j=ipStart[i];j<=ipStop[i];j+=ipDelta[i]) {
           iLen = strlen(cppInFiles[i]);
           cpPtr = (char *) DXAllocate((iLen+11)*sizeof(char));
           sprintf(cpPtr,"%s %d",cppInFiles[i], j);
           cppInSteps[iStep++] = cpPtr;
           /* DXMessage("%s %d",cpPtr,iStep);*/
         }
      } else {
          for(j=ipStart[i];j>=ipStop[i];j+=ipDelta[i]) {
            iLen = strlen(cppInFiles[i]);
            cpPtr = (char *) DXAllocate((iLen+11)*sizeof(char));
            sprintf(cpPtr,"%s %d",cppInFiles[i], j);
            cppInSteps[iStep++] = cpPtr;
            /* DXMessage("%s %d",cpPtr,iStep);*/
          }
      }
   }

   AOutFiles = DXMakeStringListV(iNumSteps,cppInSteps);
  
   out[0] = (Object) AInFiles;
   out[1] = (Object) AOutFiles;

   /*  Cleanup*/
   return OK;
 error:
  return ERROR;
}
