#include <stdio.h>
#include <math.h>
#include <dx/dx.h>

Error m_AppendFile(Object *in, Object *out)
{
  int i,j;
  char *cpFileName;
  Array AData;
  float *fpData;
  int iItems,iRank,*ipDims, iShape, iaDims[3];
  FILE *FpOut;

  if (!in[0]) {
     DXSetError(ERROR_BAD_PARAMETER,"Need input field");
     goto error;
  }

  if (!in[1]) {
     DXSetError(ERROR_BAD_PARAMETER,"Needs output file name");
     goto error;
  }
  if (!DXExtractString(in[1], &cpFileName)) {
     DXSetError(ERROR_BAD_PARAMETER,"Filename must be string");
     goto error;
  }

  DXMessage("Filename %s",cpFileName);
  FpOut = fopen(cpFileName,"a");
  if (NULL == FpOut) {
    DXSetError(ERROR_INTERNAL,"Unable to open file");
    goto error;
  }
  DXMessage("File Pointer %d",FpOut);
  AData = (Array)DXGetComponentValue((Field)in[0],"data");
  DXGetArrayInfo(AData,&iItems,NULL,NULL,&iRank,iaDims);
  fpData = (float *)DXGetArrayData(AData);
  DXMessage("%s Info %d %d %d",cpFileName,iItems,iRank,iaDims[0]);
  if(0 == iRank) {
   for(i=0;i<iItems;i++) {
    fprintf(FpOut,"%f ",fpData[i]);
   }
   fprintf(FpOut,"\n");
  } else {
    for(i=0;i<iItems;i++) {
      for(j=0;j<iaDims[0];j++) {
        fprintf(FpOut,"%f ",fpData[j+i*iaDims[0]]);
      }
      fprintf(FpOut,"\n");
    }
  }
  fclose(FpOut);
  
  return OK;

  error:
   return ERROR;
}
