function Field = OctaveOpDemoField(Field,astring)
%OctaveOp_demoField Demo of passing a field to/from OpenDX.
%
%   Field = OCTAVEOP_DEMOFIELD(Field, String)
%  
%   Field is an OpenDX field object.  The number of items is treated
%   as the number of rows, and the number of values in each item is
%   treated as the number of columns.  
%
%   Field can have components "data", "positions", "connections", and
%   optionally "colors".  Only components of rank 0, 1, or 2 are allowed.
%
%   Input and output variable names *must* be Field.
%
%   String is an arbitrary string.
%
%   See also OctaveOp_demoValueList.

Field

Field.data    = Field.positions;

I             = find(Field.positions == 0);
Field.data(I) = 1.0;

Field