#!/usr/bin/perl
#  
#  Usage: perl cat_mdf_files.pl
#
#  Recursively searches for any *.mdf file associated with user*.c
#  files in ./src and concatanates them after
#  inserting newline at end of each mdf file.
#
#  R.S. Weigel 11/15/2004.
###############################################################################

use File::Find;

#print "OSNAME = $^O\n";
$dir1 = "./src";

@directory = ($dir1);

open(DATA_out,">spdx.mdf");
find(\&wanted, @directory);
close(DATA_out);

sub wanted {

    if ( $_ =~ m/user.*\.c$/ ) {

	print $_."\n";

	$base    = $_;
	$base    =~ s/user(.*)\.c/$1/; 	 	
	$mdffile = $_;
	$mdffile =~ s/user(.*)\.c/$1\.mdf/; 	 
	#print "Reading $mdffile\n";
        #print "OSNAME = $^O\n";
	open(DATA_in,"$mdffile") or die "Could not open $mdffile\n";

	while ($line = <DATA_in>){

	    if ( ($^O =~ m/cygwin/) & ($line =~ LOADABLE) ){
		# In cygwin, LOADABLE in mdf must have .dll extension
		$line =~ s/;//;
		$line =~ s/LOADABLE (.*)/LOADABLE $1.dll/;
		# Compiler creates loadables with .exe extension.  
		# but should be .dll
		system("ln -s $base.exe $base.dll");
	    }
	    
	    print DATA_out "$line";
	    #print "$line";

	}
	print DATA_out "\n";
	#print "\n";
	 
	close(DATA_in);
    }
    
}



