#include <mfhdf.h>
#include <stdio.h>

int main() {
   char *cpFile;
   int32 liFileId, liIndex,liSdsId, liAtrId, liErr; /* HDF Access Vars */
   int32 liRank, liNumType, liAttr;
   int32 liaDimSize[MAX_VAR_DIMS], liStart, liEdge, liStride;
   int32 liaDim3d[3], liaStart3d[3], liaStride3d[3];
   char caDataName[MAX_NC_NAME];
   float *fpXC1,*fpD;
   int i,iNx, iNy, iNz;

   //cpFile = "/home/wiltbemj/tmp/64x30x1.h30a1wt.0016.tim.nc";
   cpFile = "/home/wiltbemj/tmp/64x30x45.g30a1wt.0016.tim.nc";

   liFileId = SDstart(cpFile,DFACC_RDONLY);
   printf("FileId %d\n",liFileId);

   liIndex = SDnametoindex(liFileId,"XC1");
   printf("liIndex %d\n",liIndex);
   liSdsId = SDselect(liFileId,liIndex);
   printf("liSdsId %d\n",liSdsId);

   liErr = SDgetinfo(liSdsId,caDataName,&liRank,liaDimSize,&liNumType,&liAttr);
   printf("%s Rank %d %d\n",caDataName,liRank,liaDimSize[0]);

   fpXC1 = (float*)malloc(sizeof(float)*liaDimSize[0]);
   liStart = 0;
   liEdge = liaDimSize[0];
   liStride = 1;

   liErr = SDreaddata(liSdsId,&liStart,&liStride,&liEdge,fpXC1);

   printf("liErr %d fpXC1[10] %g\n",liErr,fpXC1[10]);

   liErr = SDendaccess(liSdsId);

   liIndex = SDnametoindex(liFileId,"D");
   printf("liIndex %d\n",liIndex);
   liSdsId = SDselect(liFileId,liIndex);
   printf("liSdsId %d\n",liSdsId);

   liErr = SDgetinfo(liSdsId,caDataName,&liRank,liaDimSize,&liNumType,&liAttr);
   printf("%s Rank %d %d\n",caDataName,liRank,liaDimSize[0]);

   fpD =(float*)malloc(sizeof(float)*liaDimSize[0]*liaDimSize[1]*liaDimSize[2]);
   for(i=0;i<3;i++) {
     liaStart3d[i] = 0;
     liaStride3d[i] = 1;
   }
   liaDim3d[0] = liaDimSize[0];
   liaDim3d[1] = liaDimSize[1];
   liaDim3d[2] = liaDimSize[2];

   liErr = SDreaddata(liSdsId,liaStart3d,liaStride3d,liaDim3d,fpD);

   printf("liErr %d fpD[10] %g\n",liErr,fpD[10]);
   liErr = SDendaccess(liSdsId);

  
   return 1;

}

  
