#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "debug.h"
#include "funcs.h"
#include "fpointers.h"

int mfCalcIonCur(int nip1, int njp1, int nk2p3, 
               float *fpEthetCoef, float *fpEphiCoef)

{
  int j,k, nj, nk2p2, nk2p1,nk2;
  float *fpXa2, *fpYa2, *fpZa2, *fpRoutr, *fpS2thet, *fpTeta2, *fpPhi2;
  float *fpX2ion, *fpY2ion, *fpThetIon, *fpXmidIon, *fpYmidIon, *fpAreaIon;
  float fAzero, fR0, fRionm, fXbar, fYbar, fDxj, fDxk, fDyj, fDyk;
  float fAaa, fRbar, fAng, fThfac,fXu,fYu;

  fpXa2 = malloc(sizeof(float)*njp1*nk2p3);
  fpYa2 = malloc(sizeof(float)*njp1*nk2p3);
  fpZa2 = malloc(sizeof(float)*njp1*nk2p3);
  fpRoutr = malloc(sizeof(float)*njp1*nk2p3);
  fpS2thet = malloc(sizeof(float)*njp1*nk2p3);
  fpTeta2 = malloc(sizeof(float)*njp1*nk2p3);
  fpPhi2 = malloc(sizeof(float)*njp1*nk2p3);
  fpX2ion = malloc(sizeof(float)*njp1*nk2p3);
  fpY2ion = malloc(sizeof(float)*njp1*nk2p3);
  fpThetIon = malloc(sizeof(float)*njp1*nk2p3);
  fpXmidIon = malloc(sizeof(float)*njp1*nk2p3);
  fpYmidIon = malloc(sizeof(float)*njp1*nk2p3);
  fpAreaIon = malloc(sizeof(float)*njp1*nk2p3);
  nj = njp1 -1;
  nk2p2 = nk2p3 -1;
  nk2p1 = nk2p2 -1;
  nk2 = nk2p1 -1;
  for(j=0;j<nj;j++) {
    for(k=0;k<nk2;k++) { 
       fpXa2[jk(j,k)] = fpX[ijk1(1,j,0)]*1.0e-2;
       fpYa2[jk(j,k)] = fpY[ijk1(1,j,k)]*1.0e-2;
       fpZa2[jk(j,k)] = fpZ[ijk1(1,j,k)]*1.0e-2;
    }
  }
  for(k=0;k<nk2;k++) {
    fpXa2[jk(0,k+1)] = fpX[ijk1(1,0,nk2/2)]*1.0e-2;
    fpYa2[jk(0,k+1)] = fpY[ijk1(1,0,nk2/2)]*1.0e-2;
    fpZa2[jk(0,k+1)] = fpZ[ijk1(1,0,nk2/2)]*1.0e-2;
    fpXa2[jk(nj,k+1)] = fpX[ijk1(1,nj,nk2/2)]*1.0e-2;
    fpYa2[jk(nj,k+1)] = fpY[ijk1(1,nj,nk2/2)]*1.0e-2;
    fpZa2[jk(nj,k+1)] = fpZ[ijk1(1,nj,nk2/2)]*1.0e-2;
  }
  for(j=0;j<nj;j++) {
    fpXa2[jk(j,0)] = fpX[ijk1(0,j,0)]*1.0e-2;
    fpXa2[jk(j,nk2p2)] = fpX[ijk1(0,j,nk2)]*1.0e-2;
    fpYa2[jk(j,0)] = fpY[ijk1(0,j,0)]*1.0e-2;
    fpYa2[jk(j,nk2p2)] = fpY[ijk1(0,j,nk2)]*1.0e-2;
    fpZa2[jk(j,0)] = fpZ[ijk1(0,j,0)]*1.0e-2;
    fpZa2[jk(j,nk2p2)] = fpZ[ijk1(0,j,nk2)]*1.0e-2;
  }
  fR0 = 6.38e6;
  for(k=0;k<nk2p2;k++) {
    for(j=0;j<nj;j++)  {
       fpRoutr[jk(j,k)] = sqrt(fpXa2[jk(j,k)]*fpXa2[jk(j,k)] + 
                          fpYa2[jk(j,k)]*fpYa2[jk(j,k)] +
                          fpZa2[jk(j,k)]*fpZa2[jk(j,k)]); 
    }
  }
  for(k=0;k<nk2p2;k++) {
    for(j=0;j<nj;j++)  {
      fpS2thet[jk(j,k)] = (fR0/fpRoutr[jk(j,k)])*
                      (1.0-fpZa2[jk(j,k)]/(fpRoutr[jk(j,k)]*fpRoutr[jk(j,k)]));
      fpTeta2[jk(j,k)] = asin(sqrt(fpS2thet[jk(j,k)]));
      fpPhi2[jk(j,k)] = atan2(fpYa2[jk(j,k)],fpXa2[jk(j,k)]);
    }
  }
  for(k=0;k<nk2p2;k++) {
    for(j=0;j<nj;j++)  {
      fpX2ion[jk(j,k)] = fpTeta2[jk(j,k)]*cos(fpPhi2[jk(j,k)]);
      fpY2ion[jk(j,k)] = fpTeta2[jk(j,k)]*sin(fpPhi2[jk(j,k)]);
    }
  }
  fRionm = 6.5e6;
  fAzero = fRionm*fRionm;
  for(k=0;k<nk2p1;k++) {
    for(j=0;j<nj-1;j++)  {
      fXbar = 0.25*(fpX2ion[jk(j,k)]+fpX2ion[jk(j+1,k)]+
                    fpX2ion[jk(j,k+1)]+fpX2ion[jk(j+1,k+1)]);
      fYbar = 0.25*(fpY2ion[jk(j,k)]+fpY2ion[jk(j+1,k)]+
                    fpY2ion[jk(j,k+1)]+fpY2ion[jk(j+1,k+1)]);
      fDxj = 0.5*(fpX2ion[jk(j+1,k)]+fpX2ion[jk(j+1,k+1)]-
                  fpX2ion[jk(j,k)]-fpX2ion[jk(j,k+1)]);
      fDxk = 0.5*(fpX2ion[jk(j,k+1)]+fpX2ion[jk(j+1,k+1)]-
                  fpX2ion[jk(j,k)]-fpX2ion[jk(j+1,k)]);
      fDyj = 0.5*(fpY2ion[jk(j+1,k)]+fpY2ion[jk(j+1,k+1)]-
                  fpY2ion[jk(j,k)]-fpY2ion[jk(j,k+1)]);
      fDyk = 0.5*(fpY2ion[jk(j,k+1)]+fpY2ion[jk(j+1,k+1)]-
                  fpY2ion[jk(j,k)]-fpY2ion[jk(j+1,k)]);
      fAaa = fDxj*fDyk-fDxk*fDyj;
      fRbar = sqrt(fXbar*fXbar+fYbar*fYbar);
      fAng = atan2(fYbar,fXbar);
      if ( fRbar < 1.0e-3) {
         fThfac = 1.0;
         fXu = cos(fAng);
         fYu = sin(fAng);
      } else {
         fThfac = sin(fRbar)/fRbar;
         fXu = fXbar/fRbar;
         fYu = fYbar/fRbar;
      }

      faDdj[0][0] = -1.0;
      faDdj[0][1] = -1.0;
      faDdj[1][0] = 1.0;
      faDdj[1][1] = 1.0;
      faDdk[0][0] = -1.0;
      faDdk[0][1] = 1.0;
      faDdk[1][0] = -1.0;
      faDdk[1][1] = 1.0;
      for(l=0;l<2;l++) {
        for(m=0;m<2;m++) {
          lm = m+2*l;
          fpEthetCoef[jklm(j,k,lm)] = 0.5*(faDdj[m][l]*(fXu*fDyk-fYu*fDxk) +
                                           faDDk[m][l]*(fYu*fDxj-fXu*fDyj))/
                                           fAaa/fRionm;
          fpEphiCoef[jklm(j,k,lm)] = 0.5*(-faDdj[m][l]*(fYu*fDyk-fXu*fDxk) +
                                           faDDk[m][l]*(fYu*fDyj-fXu*fDxj))/
                                           fAaa/fRionm;
        }
      }
    }
   }
                                        

  free(fpXa2);
  free(fpYa2);
  free(fpZa2);
  free(fpRoutr);
  free(fpS2thet);
  free(fpTeta2);
  free(fpPhi2);
  free(fpX2ion);
  free(fpY2ion);
  free(fpThetIon);
  free(fpXmidIon);
  free(fpYmidIon);
  free(fpAreaIon);
  
  return 1;

}

