#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mfhdf.h>
#include "debug.h"
#include "funcs.h"

int mfGetIonData(int32 liFileId, int iStepFix, int njp1, int nk2p3, 
               float *fpIonData)
{
  int32 iErr;
  int i,j,k,nv,iSize;
  char *cpDum,caSec[MAX_NC_NAME];
  float *fpCurN, *fpPotN, *fpSigPedN, *fpSigHallN, *fpFluxN, *fpEngN;
  float *fpCurS, *fpPotS, *fpSigPedS, *fpSigHallS, *fpFluxS, *fpEngS;
  float *fpReadVar, *fpNwfac,*fpSwfac;

  iSize = njp1*nk2p3;
  /*Get the data */
  sprintf(caSec,"ion_time_step_%d",iStepFix);
  fpReadVar = mffpGetData(liFileId,caSec);
  DXMessage("ion pointers %x %x %x\n", fpReadVar, fpNwfac, fpSwfac);
  sprintf(caSec,"wfac_n_%d",iStepFix);
  DXMessage("ion pointers %x %x %x\n", fpReadVar, fpNwfac, fpSwfac);
  /*  fpNwfac = mffpGetData(liFileId,caSec); */
  fpNwfac = NULL;
  DXMessage("ion pointers %x %x %x\n", fpReadVar, fpNwfac, fpSwfac);
  sprintf(caSec,"wfac_s_%d",iStepFix);
  /*  fpSwfac = mffpGetData(liFileId,caSec); */
  fpSwfac = NULL;
  DXMessage("ion pointers %x %x %x\n", fpReadVar, fpNwfac, fpSwfac);
  nv = 18;
  for(k=0;k<nk2p3;k++) {
    for(j=0;j<njp1;j++) {
      if (fpReadVar != NULL) {
	fpIonData[vionij(0,j,k)] = fpReadVar[ionij(0,j,k)];
	fpIonData[vionij(1,j,k)] = fpReadVar[ionij(1,j,k)];
	fpIonData[vionij(2,j,k)] = fpReadVar[ionij(2,j,k)];
	fpIonData[vionij(3,j,k)] = fpReadVar[ionij(3,j,k)];
	fpIonData[vionij(4,j,k)] = fpReadVar[ionij(4,j,k)];
	fpIonData[vionij(5,j,k)] = fpReadVar[ionij(5,j,k)];
	fpIonData[vionij(6,j,k)] = 0.0; /* N Jns */
	fpIonData[vionij(7,j,k)] = 0.0; /* N Jew */
	fpIonData[vionij(8,j,k)] = fpReadVar[ionij(6,j,k)];
	fpIonData[vionij(9,j,k)] = fpReadVar[ionij(7,j,k)];
	fpIonData[vionij(10,j,k)] = fpReadVar[ionij(8,j,k)];
	fpIonData[vionij(11,j,k)] = fpReadVar[ionij(9,j,k)];
	fpIonData[vionij(12,j,k)] = fpReadVar[ionij(10,j,k)];
	fpIonData[vionij(13,j,k)] = fpReadVar[ionij(11,j,k)];
        fpIonData[vionij(14,j,k)] = 0.0; /* S Jns */
        fpIonData[vionij(15,j,k)] = 0.0; /* S Jew */
      } 
      else {
	for (i=0;i<14;i++)
	  fpIonData[vionij(i,j,k)] = 0.0; /* Failed to get fpReadVar */
      }
      /* Check if failed to get fpNwfac/fpSwfac */
      fpIonData[vionij(16,j,k)] = (fpNwfac!=NULL ? fpNwfac[jk(j,k)] : 0.0);
      fpIonData[vionij(17,j,k)] = (fpSwfac!=NULL ? fpSwfac[jk(j,k)] : 0.0);

    }
  }
  
  /* Clean up */
  free(fpReadVar);
  /*
  free(fpNwfac);
  free(fpSwfac);
  */
  return 1;
}
