#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mfhdf.h>
#include "debug.h"
#include "funcs.h"
#include "fpointers.h"

float *mffpGetData(int32 liFileId, char *cpName)
{
   int32 iErr, liSdsId, liIndex, liNumType, liAttr, liRank, liSize;
   int32 liaDimSize[MAX_VAR_DIMS],liaStart[MAX_VAR_DIMS],liaEnd[MAX_VAR_DIMS]; 
   int i, iNi, iNj,iNk;
   char caDataName[MAX_NC_NAME];
   float *fpData;

   for(i=0;i<MAX_VAR_DIMS;i++) {
     liaDimSize[i] = 0;
     liaStart[i] = 0;
     liaEnd[i] = 0;
   }
   /*Get the info about thie dataset */
   liIndex = SDnametoindex(liFileId,cpName);
   if (-1 == liIndex) {
      fpData = NULL;
      DXMessage("Unable to open %s %x\n",cpName,fpData);
   } else {
     liSdsId = SDselect(liFileId,liIndex);
     iErr = SDgetinfo(liSdsId,caDataName,&liRank,liaDimSize,&liNumType,&liAttr);
     /* Create reterival information arrays and allocate space */
     liSize=1;
     for(i=0;i<liRank;i++) {
       liSize*=liaDimSize[i];
       liaStart[i]=0;
       liaEnd[i]=liaDimSize[liRank-i-1];
       liaEnd[i]=liaDimSize[i];
     }
     fpData = malloc(liSize*sizeof(float));
     /* Get dataset */
     iErr = SDreaddata(liSdsId,liaStart,NULL,liaEnd,fpData);
     SDendaccess(liSdsId);
   }
     
   /* Cleanup */
   return fpData;
}

  
int mfGetIntAtr(int32 liId, char *cpName) 
{
  int32 iErr, liAtrId, iVal;
  liAtrId = SDfindattr(liId,cpName);
  iErr = SDreadattr(liId,liAtrId,&iVal); 
  return iVal;
}
  
int min(int a, int b) {
  if(a < b) return a;
  else return b;
}

int max(int a, int b) {
  if(a > b) return a;
  else return b;
}
 
int32 mfgetFileId(char *cpName) 
{
  int32 iFileId;
  FILE *FpOut;
  FpOut=fopen("info.txt","w");
  iFileId = SDstart(cpName,DFACC_RDONLY);
#ifdef DEBUG
  fprintf(FpOut,"FileName %s Status %d \n",cpName,iFileId);
#endif
  fclose(FpOut);
  return iFileId;
}

float dot(float *x,float *y) {
  return x[0]*y[0] + x[1]*y[1] + x[2]*y[2]; }

void cross3(float *x, float *y, float *z) {
  z[0] = x[1]*y[2] - x[2]*y[1];
  z[1] = x[2]*y[0] - x[0]*y[2];
  z[2] = x[0]*y[1] - x[1]*y[0];
}

float triple(float *x, float *y, float *z) {
  float dum[3];
  cross3(y,z,dum);
  return dot(x,dum);
}
 
