/* Function prototypes and common defines for lfm-parallel */

#ifndef FUNCS_H
#define FUNCS_H

#define ij(i,j) ((i)+ni*(j))
#define ij1(i,j) ((i)+nip1*(j))
#define i1j(i,j) ((i)+nip1*(j))
#define ijk(i,j,k) ((i)+ni*((j)+nj*(k)))
#define i1jk(i,j,k) ((i)+nip1*((j)+nj*(k)))
#define ij1k(i,j,k) ((i)+ni*((j)+njp1*(k)))
#define ijk1(i,j,k) ((i)+nip1*((j)+njp1*(k)))
#define ijkei(i,j,k) ((i)+ni*((j)+njp1*(k)))
#define ijkej(i,j,k) ((i)+nip1*((j)+nj*(k)))
#define ijkek(i,j,k) ((i)+nip1*((j)+njp1*(k)))
#define ijkc(i,j,k) ((i)+ni*((j)+njp2*(k)))
#define vijk(v,i,j,k) ((v)+nv*((i)+ni*((j)+njp2*((k)))))
#define vi1j1k(v,i,j,k) ((v)+nv*((i)+nip1*((j)+njp1*((k)))))
#define vi0j0k(v,i,j,k) ((v)+nv*((i)+ni*((j)+nj*((k)))))
//#define vijk1(v,i,j,k) ((v)+8*((i)+ni*((j)+nj*((k)))))
#define vijk1(v,i,j,k) ((i)+ni*((j)+nj*((k)+nk*((v)))))
#define vijkps(v,i,j,k) ((k)+nkp1*((j)+njp2*((i)+ni*((v)))))
//#define ionij(v,i,j) ((v)+12*((i)+njp1*(j)))
#define ionij(v,i,j) ((i)+njp1*((j)+nk2p3*(v)))
#define vionij(v,i,j) ((v)+nv*((i)+njp1*((j))))
#define cionij(v,i,j) ((v)+4*((i)+njp1*((j))))
#define jk(j,k) ((j)+njp1*(k))
#define jkl(j,k,l) ((j)+nj*((k)+nk2p2*(l)))

int mfGetGrid(int32 liFileId, float fNorm, int ni, int nj, int nk,
   	    float *fpMHDPts, float *fpFluxPts, float *fpDivBPts);
int mfGetMHDData(int32 liFileId, int iStepfix, int ni, int nj, int nk, 
	       float *fpMHDData, float*fpMF_MHDData,  float *fpFluxData, 
               float *fpDivBData,float *fpTubeData);
int mfCalcIonGrid(float fNorm, int nip1, int njp2, int nk2p3, float *fpIonPts);
int mfGetIonData(int32 liFileId, int iStepFix, int njp1, int nk2p3, 
               float *fpIonData);
int mfGetIntAtr(int32 liId, char *cpName);
int mfChkStep(int iTimeStep, int iInital, int iFinal, int iInterval);
float *mffpGetData(int32 liFileId, char *cpName);
int mfGetTubes(float *fpTubeData, int ni, int nj, int nk);
void mfinterpline(float *fpOut, float *fpIn, 
                float *fpILine, float *fpJLine, float *fpKLine,
                int iLineLen, int ni, int nj, int nk);
void mfinterpline2(float *fpOut, float *fpIn, 
                float *fpILine, float *fpJLine, float *fpKLine,
                int iLineLen, int ni, int nj, int nk);

int min(int a, int b);
int max(int a, int b);
float dot(float *x, float *y);
void cross3(float *x, float *y, float *z);
float triple(float *x, float *y, float *z);


#endif
