#define SMALL   1.e-15

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mfhdf.h>
#include <dx/dx.h>
#include "debug.h"
#include "funcs.h"
#include "fpointers.h"

FILE *FpDebug;

float *fpPGetData(int32 liFileId, char *cpName)
{
   int32 iErr, liSdsId, liIndex, liNumType, liAttr, liRank, liSize;
   int32 liaDimSize[MAX_VAR_DIMS],liaStart[MAX_VAR_DIMS],liaEnd[MAX_VAR_DIMS];
   int i, iNi, iNj,iNk;
   char caDataName[MAX_NC_NAME];
   float *fpData;

   for(i=0;i<MAX_VAR_DIMS;i++) {
     liaDimSize[i] = 0;
     liaStart[i] = 0;
     liaEnd[i] = 0;
   }
   /*Get the info about thie dataset */
   liIndex = SDnametoindex(liFileId,cpName);
   if (-1 == liIndex) {
      fpData = NULL;
      DXMessage("Unable to open %s %x\n",cpName,fpData);
   } else {
     liSdsId = SDselect(liFileId,liIndex);
     iErr = SDgetinfo(liSdsId,caDataName,&liRank,liaDimSize,&liNumType,&liAttr);
     /* Create reterival information arrays and allocate space */
     liSize=1;
     for(i=0;i<liRank;i++) {
       liSize*=liaDimSize[i];
       liaStart[i]=0;
       liaEnd[i]=liaDimSize[liRank-i-1];
       liaEnd[i]=liaDimSize[i];
     }
     fpData = malloc(liSize*sizeof(float));
     /* Get dataset */
     iErr = SDreaddata(liSdsId,liaStart,NULL,liaEnd,fpData);
     SDendaccess(liSdsId);
   }

   /* Cleanup */
   return fpData;
}
