#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mfhdf.h>
#include "debug.h"
#include "funcs.h"
#include "fpointers.h"

int GetIonData(int32 liFileId, int iStepFix, int nip1, int njp1, int nk2p3, 
               float *fpIonData)
{
  int32 iErr;
  int i,j,k,nv,nj,nk2p2,iSize;
  char *cpDum,caSec[MAX_NC_NAME];
  float *fpCurN, *fpPotN, *fpSigPedN, *fpSigHallN, *fpFluxN, *fpEngN;
  float *fpCurS, *fpPotS, *fpSigPedS, *fpSigHallS, *fpFluxS, *fpEngS;
  float *fpReadVar, *fpNwfac,*fpSwfac;
  float fEThet,fEPhi,fSp,fSh;

  iSize = njp1*nk2p3;
  nj = njp1 -1;
  nk2p2=nk2p3-1;
  /*Get the data */
  sprintf(caSec,"ion_time_step_%d",iStepFix);
  fpReadVar = fpGetData(liFileId,caSec);
  sprintf(caSec,"wfac_n_%d",iStepFix);
  fpNwfac = fpGetData(liFileId,caSec);
  sprintf(caSec,"wfac_s_%d",iStepFix);
  fpSwfac = fpGetData(liFileId,caSec);
  
  nv = 18;
  for(k=0;k<nk2p3;k++) {
    for(j=0;j<njp1;j++) {
      if (fpReadVar != NULL) {
	fpIonData[vionij(0,j,k)] = fpReadVar[ionij(0,j,k)];
	fpIonData[vionij(1,j,k)] = fpReadVar[ionij(1,j,k)];
	fpIonData[vionij(2,j,k)] = fpReadVar[ionij(2,j,k)];
	fpIonData[vionij(3,j,k)] = fpReadVar[ionij(3,j,k)];
	fpIonData[vionij(4,j,k)] = fpReadVar[ionij(4,j,k)];
	fpIonData[vionij(5,j,k)] = fpReadVar[ionij(5,j,k)];
	fpIonData[vionij(8,j,k)] = fpReadVar[ionij(6,j,k)];
	fpIonData[vionij(9,j,k)] = fpReadVar[ionij(7,j,k)];
	fpIonData[vionij(10,j,k)] = fpReadVar[ionij(8,j,k)];
	fpIonData[vionij(11,j,k)] = fpReadVar[ionij(9,j,k)];
	fpIonData[vionij(12,j,k)] = fpReadVar[ionij(10,j,k)];
	fpIonData[vionij(13,j,k)] = fpReadVar[ionij(11,j,k)];
      } 
      else
	for (i=0;i<16;i++)
	  fpIonData[vionij(i,j,k)] = 0.0; /* Failed to get fpReadVar */
      

      /* Check if failed to get fpNwfac/fpSwfac */
      fpIonData[vionij(16,j,k)] = (fpNwfac!=NULL ? fpNwfac[jk(j,k)] : 0.0);
      fpIonData[vionij(17,j,k)] = (fpSwfac!=NULL ? fpSwfac[jk(j,k)] : 0.0);

    }
  }

  /* Compute Horizontal Ionspheric currents */
  
  if (fpReadVar != NULL) {
    for(k=0;k<nk2p2;k++) {
      for(j=0;j<nj;j++) {
       fEThet=fpEthCoef[jkl(j,k,0)]*fpIonData[vionij(0,j,k)]+
              fpEthCoef[jkl(j,k,1)]*fpIonData[vionij(0,j+1,k)]+
              fpEthCoef[jkl(j,k,2)]*fpIonData[vionij(0,j,k+1)]+
              fpEthCoef[jkl(j,k,3)]*fpIonData[vionij(0,j+1,k+1)];
       fEPhi=fpEphiCoef[jkl(j,k,0)]*fpIonData[vionij(0,j,k)]+
             fpEphiCoef[jkl(j,k,1)]*fpIonData[vionij(0,j+1,k)]+
             fpEphiCoef[jkl(j,k,2)]*fpIonData[vionij(0,j,k+1)]+
             fpEphiCoef[jkl(j,k,3)]*fpIonData[vionij(0,j+1,k+1)];
       fSp=0.25*(fpIonData[vionij(2,j,k)]+fpIonData[vionij(2,j+1,k)]+
                 fpIonData[vionij(2,j,k+1)]+fpIonData[vionij(2,j+1,k+1)]);
       fSh=0.25*(fpIonData[vionij(3,j,k)]+fpIonData[vionij(3,j+1,k)]+
                 fpIonData[vionij(3,j,k+1)]+fpIonData[vionij(3,j+1,k+1)]);
       //fpIonData[vionij(6,j,k)] = fSp*fEThet+fSh*fEPhi; /* N Jns */
       //fpIonData[vionij(7,j,k)] = fSp*fEPhi-fSh*fEThet; /* N Jew */
       fpIonData[vionij(6,j,k)] = fSh*fEPhi; /* N Hns */
       fpIonData[vionij(7,j,k)] = -fSh*fEThet; /* N Hew */
       fEThet=fpEthCoef[jkl(j,k,0)]*fpIonData[vionij(8,j,k)]+
              fpEthCoef[jkl(j,k,1)]*fpIonData[vionij(8,j+1,k)]+
              fpEthCoef[jkl(j,k,2)]*fpIonData[vionij(8,j,k+1)]+
              fpEthCoef[jkl(j,k,3)]*fpIonData[vionij(8,j+1,k+1)];
       fEPhi=fpEphiCoef[jkl(j,k,0)]*fpIonData[vionij(8,j,k)]+
             fpEphiCoef[jkl(j,k,1)]*fpIonData[vionij(8,j+1,k)]+
             fpEphiCoef[jkl(j,k,2)]*fpIonData[vionij(8,j,k+1)]+
             fpEphiCoef[jkl(j,k,3)]*fpIonData[vionij(8,j+1,k+1)];
       fSp=0.25*(fpIonData[vionij(10,j,k)]+fpIonData[vionij(10,j+1,k)]+
                 fpIonData[vionij(10,j,k+1)]+fpIonData[vionij(10,j+1,k+1)]);
       fSh=0.25*(fpIonData[vionij(11,j,k)]+fpIonData[vionij(11,j+1,k)]+
                 fpIonData[vionij(11,j,k+1)]+fpIonData[vionij(11,j+1,k+1)]);
       //fpIonData[vionij(14,j,k)] = fSp*fEThet+fSh*fEPhi; /* S Jns */
       //fpIonData[vionij(15,j,k)] = fSp*fEPhi-fSh*fEThet; /* S Jew */
       fpIonData[vionij(14,j,k)] = fSh*fEPhi; /* S Jns */
       fpIonData[vionij(15,j,k)] = -fSh*fEThet; /* S Jew */
     }
   }
  }
  
  /* Clean up */
  free(fpReadVar);
  free(fpNwfac);
  free(fpSwfac);
  free(fpEthCoef);
  free(fpEphiCoef);

  return 1;
}
