#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mfhdf.h>
#include "debug.h"
#include "funcs.h"
#include "fpointers.h"

FILE *FpDebug;

int GetPwrSpctrm(int32 liFileId, int nv, int ni, int nj, int nk,
	       float *fpMHDData)
{
  int32 iErr, liIndex,liSecId,liStart,liStride,liEdge,liStat,liBzeroSize;
   int32 liSdsId, liNumType, liAttr, liRank, liSize;
   int32 liaDimSize[MAX_VAR_DIMS],liaStart[MAX_VAR_DIMS],liaEnd[MAX_VAR_DIMS]; 
  char *cpDum, caSec[MAX_NC_NAME],caStep[10];
   char caDataName[MAX_NC_NAME];
  int i,j,k,v;
  int nip1, njp1, nkp1, njp2, iSize;
  double *dpReadVar;

  /*set some useful parameters */
  nip1 = ni+1;
  njp1 = nj+1;
  nkp1 = nk+1;
  njp2 = nj+2;
  iSize = nv*ni*njp2*nkp1;
  
  /*Get the data */
  liIndex = SDnametoindex(liFileId,"powerspec");
  liSdsId = SDselect(liFileId,liIndex);
  iErr = SDgetinfo(liSdsId,caDataName,&liRank,liaDimSize,&liNumType,&liAttr);
  dpReadVar = malloc(iSize*sizeof(double));
   for(i=0;i<liRank;i++) {
     liaStart[i]=0;
     liaEnd[i]=liaDimSize[i];
   }
  iErr = SDreaddata(liSdsId,liaStart,NULL,liaEnd,dpReadVar);
  
  

  /* Now we construct the OpenDX field */
  
  for(k=0;k<nkp1;k++) {
    for(j=0;j<njp2;j++) {
      for(i=0;i<ni;i++) {
        for(v=0;v<nv;v++) {
          fpMHDData[vijk(v,i,j,k)]=dpReadVar[vijkps(v,i,j,k)];
        }
      }
    }
  }

  /* Clean up data pointers */
  free(dpReadVar);
  
  /* We leave the grid pointers existence since they are used in the CalcIonGrid
   * function.
   */

  return 1;
}

