/* Function prototypes and common defines for lfm-parallel */

#ifndef FUNCS_H
#define FUNCS_H

#define ij(i,j) ((i)+ni*(j))
#define ij1(i,j) ((i)+nip1*(j))
#define i1j(i,j) ((i)+nip1*(j))
#define ijk(i,j,k) ((i)+ni*((j)+nj*(k)))
#define i1jk(i,j,k) ((i)+nip1*((j)+nj*(k)))
#define ij1k(i,j,k) ((i)+ni*((j)+njp1*(k)))
#define ijk1(i,j,k) ((i)+nip1*((j)+njp1*(k)))
#define ijkei(i,j,k) ((i)+ni*((j)+njp1*(k)))
#define ijkej(i,j,k) ((i)+nip1*((j)+nj*(k)))
#define ijkek(i,j,k) ((i)+nip1*((j)+njp1*(k)))
#define ijkc(i,j,k) ((i)+ni*((j)+njp2*(k)))
#define vijk(v,i,j,k) ((v)+nv*((i)+ni*((j)+njp2*((k)))))
#define vi1j1k(v,i,j,k) ((v)+nv*((i)+nip1*((j)+njp1*((k)))))
#define vi0j0k(v,i,j,k) ((v)+nv*((i)+ni*((j)+nj*((k)))))
//#define vijk1(v,i,j,k) ((v)+8*((i)+ni*((j)+nj*((k)))))
#define vijk1(v,i,j,k) ((i)+ni*((j)+nj*((k)+nk*((v)))))
#define vijkps(v,i,j,k) ((k)+nkp1*((j)+njp2*((i)+ni*((v)))))
//#define ionij(v,i,j) ((v)+12*((i)+njp1*(j)))
#define ionij(v,i,j) ((i)+njp1*((j)+nk2p3*(v)))
#define vionij(v,i,j) ((v)+nv*((i)+njp1*((j))))
#define cionij(v,i,j) ((v)+4*((i)+njp1*((j))))
#define jk(j,k) ((j)+njp1*(k))
#define jkl(j,k,l) ((j)+nj*((k)+nk2p2*(l)))

int GetGrid(int32 liFileId, float fNorm, int ni, int nj, int nk,
   	    float *fpMHDPts, float *fpFluxPts, float *fpDivBPts);
int GetMHDData(int32 liFileId, int iStepfix, int ni, int nj, int nk,
               int iComputeTubes, 
	       float *fpMHDDdata, float *fpFluxData, float *fpDivBData,
               float *fpTubeData);
int CalcIonGrid(float fNorm, int nip1, int njp2, int nk2p3, float *fpIonPts);
int GetIonData(int32 liFileId, int iStepFix, int nip1, int njp1, int nk2p3, 
               float *fpIonData);
int GetIntAtr(int32 liId, char *cpName);
int ChkStep(int iTimeStep, int iInital, int iFinal, int iInterval);
float *fpGetData(int32 liFileId, char *cpName);
int GetTubes(float *fpTubeData, int ni, int nj, int nk);
void btrace(float fX, float fY, float fZ, int ni, int nj, int nk,
            int *ipLineLen, char *cpLineType,
            float *fpXLine, float *fpYLine, float *fpZLine,
            float *fpXN, float *fpYN, float *fpZN,
            float *fpXS, float *fpYS, float *fpZS);
void interpline(float *fpOut, float *fpIn, 
                float *fpILine, float *fpJLine, float *fpKLine,
                int iLineLen, int ni, int nj, int nk);
void interpline2(float *fpOut, float *fpIn, 
                float *fpILine, float *fpJLine, float *fpKLine,
                int iLineLen, int ni, int nj, int nk, int flag);

int min(int a, int b);
int max(int a, int b);
float dmin(float a, float b);
float dmax(float a, float b);
float dot(float *x, float *y);
void cross3(float *x, float *y, float *z);
float triple(float *x, float *y, float *z);
float exp1(float X,float Y);
float alog1(float X, float Y);
int inchng(float X, float Y, float Z);
float sign(float X, float Y);

#endif
