#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mfhdf.h>
#include "debug.h"
#include "funcs.h"

int GetIonData(int32 liFileId, int njp1, int nk2p3, float *fpIonData)
{
   int32 iErr;
   int i,j,k,nv,iSize;
   char *cpDum,caSec[MAX_NC_NAME];
   float *fpCurN, *fpPotN, *fpSigPedN, *fpSigHallN, *fpFluxN, *fpEngN;
   float *fpCurS, *fpPotS, *fpSigPedS, *fpSigHallS, *fpFluxS, *fpEngS;
   float *fpIon;

   iSize = njp1*nk2p3;
#ifdef DEBUG
   printf("njp1 %d nk2p3 %d iSize %d\n",njp1,nk2p3,iSize);
#endif
   fpCurN = malloc(sizeof(float)*iSize);
   fpPotN = malloc(sizeof(float)*iSize);
   fpSigPedN = malloc(sizeof(float)*iSize);
   fpSigHallN = malloc(sizeof(float)*iSize);
   fpFluxN = malloc(sizeof(float)*iSize);
   fpEngN = malloc(sizeof(float)*iSize);
   fpCurS = malloc(sizeof(float)*iSize);
   fpPotS = malloc(sizeof(float)*iSize);
   fpSigPedS = malloc(sizeof(float)*iSize);
   fpSigHallS = malloc(sizeof(float)*iSize);
   fpFluxS = malloc(sizeof(float)*iSize);
   fpEngS = malloc(sizeof(float)*iSize);

   fpCurN = fpGetData(liFileId,"curnorth");
   fpPotN = fpGetData(liFileId,"potnorth");
   fpSigPedN = fpGetData(liFileId,"SigmaP_north");
   fpSigHallN = fpGetData(liFileId,"SigmaH_north");
   fpFluxN = fpGetData(liFileId,"fluxnorth");
   fpEngN = fpGetData(liFileId,"avE_north");
   fpCurS = fpGetData(liFileId,"cursouth");
   fpPotS = fpGetData(liFileId,"potsouth");
   fpSigPedS = fpGetData(liFileId,"SigmaP_south");
   fpSigHallS = fpGetData(liFileId,"SigmaH_south");
   fpFluxS = fpGetData(liFileId,"fluxsouth");
   fpEngS = fpGetData(liFileId,"avE_south");

   nv = 16;
   fpIon = malloc(sizeof(float)*iSize*nv);
   for(k=0;k<nk2p3;k++) {
      for(j=0;j<njp1;j++) {
	 fpIonData[vionij(0,j,k)] = fpPotN[ionij(j,k)];
	 fpIonData[vionij(1,j,k)] = fpCurN[ionij(j,k)];
	 fpIonData[vionij(2,j,k)] = fpSigPedN[ionij(j,k)];
	 fpIonData[vionij(3,j,k)] = fpSigHallN[ionij(j,k)];
	 fpIonData[vionij(4,j,k)] = fpFluxN[ionij(j,k)];
	 fpIonData[vionij(5,j,k)] = fpEngN[ionij(j,k)];
	 fpIonData[vionij(6,j,k)] = fpEngN[ionij(j,k)];
	 fpIonData[vionij(7,j,k)] = fpEngN[ionij(j,k)];
	 fpIonData[vionij(8,j,k)] = fpPotS[ionij(j,k)];
	 fpIonData[vionij(9,j,k)] = fpCurS[ionij(j,k)];
	 fpIonData[vionij(10,j,k)] = fpSigPedS[ionij(j,k)];
	 fpIonData[vionij(11,j,k)] = fpSigHallS[ionij(j,k)];
	 fpIonData[vionij(12,j,k)] = fpFluxS[ionij(j,k)];
	 fpIonData[vionij(13,j,k)] = fpEngS[ionij(j,k)];
	 fpIonData[vionij(14,j,k)] = fpFluxS[ionij(j,k)];
	 fpIonData[vionij(15,j,k)] = fpFluxS[ionij(j,k)];
      }
   }

   /* Clean up */
   free(fpPotN);
   free(fpCurN);
   free(fpSigPedN);
   free(fpSigHallN);
   free(fpFluxN);
   free(fpEngN);
   free(fpPotS);
   free(fpCurS);
   free(fpSigPedS);
   free(fpSigHallS);
   free(fpFluxS);
   free(fpEngS);



   return 1;
}
