#include "hdf.h"
#include <stdio.h>

void rdhdf(char *cpFname, int *ipMaxDim, int *ipNDim, int *ipDim,
           float **fppData, int *ipIFScale, float ***fpppScales, int *ipErr)

{

    int i,j,iRet;
    int iSize, iNumScales;
    *ipErr = 0;

    /* printf("Filename %s\n",cpFname); */
    printf("Reading %s %d %d %d %d\n",cpFname, *ipNDim, ipDim[0], ipDim[1], ipDim[2]);fflush(stdout);
    iRet=DFSDgetdims(cpFname,ipNDim,ipDim,*ipMaxDim);
    if (0 != iRet) {
       printf("DFSDgetdims failed\n");
       *ipErr = 1;
       return; /* Abort futher read on error */
    }

    /* Get size needed for read and allocate space for it*/
    iSize=ipDim[0];
    for(i=1;i<*ipNDim;i++) iSize*=ipDim[i];
    *fppData = malloc(sizeof(float)*iSize);

    /* Chk if scales are present */
    iNumScales = 0;
    for(i=0;i<(*ipNDim);i++) {
      iRet = DFSDgetdimscale(i+1,ipDim[i],*fppData);
      if (0 == iRet) iNumScales++;
         if (0 != iRet) {
          printf("DFSDgetdimscale failed\n");
          *ipErr = 1;
          return; /* Abort futher read on error */
         }
    }
    if (iNumScales == *ipNDim) {
       *ipIFScale = 1;
    } else {
       *ipIFScale = 0;
    }

    /* Allocate memory and get scales */
    *fpppScales = malloc(sizeof(float*)*(*ipNDim));
    if (1 == *ipIFScale) {
       for(i=0;i<(*ipNDim);i++) {
         (*fpppScales)[i] = malloc(sizeof(float)*ipDim[i]);
         iRet = DFSDgetdimscale(i+1,ipDim[i],(*fpppScales)[i]);
         if (0 != iRet) {
          printf("DFSDgetdimscale failed\n");
          *ipErr = 1;
          return; /* Abort futher read on error */
         }
       }
      /* Output scales check 
      for(i=0;i<(*ipNDim);i++) {
        for(j=0;j<ipDim[i];j++) {
           printf("%f\n",(*fpppScales)[i][j]);
        }
        printf("=============\n");
      }
      */
    }

   /* Read the data array */
   iRet = DFSDgetdata(cpFname,*ipNDim,ipDim,*fppData);
   if (0 != iRet) {
    printf("DFSDgetdata failed\n");
    *ipErr = 1;
    return; /* Abort futher read on error */
   }
        
   if (*ipErr != 1) *ipErr = 0;
   return;
}

  
