#include "hdf.h"
#include <dx/dx.h>
#include <stdio.h>
#include <math.h>

#define SIZE 256
#define MAXDIMS 3

int main(int argc, char** argv) {
  char *cpDirName=NULL;
  int iTimeStep;
  int iaDimSizes[MAXDIMS], iNumDims;  /* Number of Dims and their sizes */
  int iIfScale;                     /* Flag if scales are present */
  float *fpData, **fppScales;       /* Ptrs for data and Scales */
  int iErr;                         /* Error flag */
  char caFileName[SIZE];                    /* Array for file name */
  int iMaxDims;                     /* Max Number of Dims */
  int i;


  cpDirName = "/usr/local/CISM_DX_DATA/model_output/mas-data/";
  iTimeStep = 1;

  sprintf(caFileName,"%sbp%3.3d.hdf",cpDirName,iTimeStep);
  printf("Filename %s\n",caFileName);
  iMaxDims = MAXDIMS;
 
  rdhdf(caFileName,&iMaxDims,&iNumDims,iaDimSizes,&fpData,&iIfScale,
         &fppScales,&iErr);

  printf("Num Dims %d Nx %d Ny %d Nz %d\n",iNumDims,iaDimSizes[0],
            iaDimSizes[1],iaDimSizes[2]);
  printf("Scales %d Err %d \n",iIfScale,iErr);
  printf("data %f\n",fpData[0]);

  return 0;
}
