#include <stdio.h>
#include <math.h>
#include <dx/dx.h>
#define MAX_NAME_SIZE 256

Error
m_OpenClose(Object *in, Object *out)
{
   /***********************/
   /*  Declare variables  */
   /***********************/
   Field in_line;
   Array in_carray,a;
   float *in_coords;
   float r;
   Type     in_coord_type;
   int      in_coord_items;
   Category in_coord_cat;
   int      in_coord_rank,in_coord_shape;
   int so,sc,nlines,i;
   Group gopen,gclosed;
   float xl,yl,zl,rl;

   /***********************/
   /*  Get input values   */
   /***********************/
   if(!in[0]){
     r=10.0;
   }
   else {
     DXExtractFloat(in[0],&r);
   }

   /* Get Slines Field Group */
   /* Get mesh id */
   if (!in[1]) {
     /*DXSetError(ERROR_BAD_PARAMETER,"missing SM Field");
     goto error;*/
     return OK;
   }
   else if(DXGetObjectClass(in[1])== CLASS_GROUP){
     Class groupClass = DXGetGroupClass((Group)in[1]);
     DXGetMemberCount((Group)in[1],&nlines);
     /* Create Output Groups */
     gopen = DXNewGroup();
     gclosed = DXNewGroup();
     so=0;
     sc=0;
     
     for(i=0;i<nlines;i++){
       in_line = (Field) DXGetEnumeratedMember((Group)in[1],i,NULL);
       in_carray = (Array)DXGetComponentValue((Field)in_line,"positions");
       in_coords = DXGetArrayData(in_carray);
       DXGetArrayInfo(in_carray,&in_coord_items,&in_coord_type,
		      &in_coord_cat,&in_coord_rank,&in_coord_shape);
       xl=in_coords[(in_coord_items-1)*3];
       yl=in_coords[(in_coord_items-1)*3+1];
       zl=in_coords[(in_coord_items-1)*3+2];
       rl=sqrt((double)(xl*xl+yl*yl+zl*zl));
       DXMessage("xl=%f,yl=%f,zl=%f,rl=%f,r=%f",xl,yl,zl,rl,r);
       if(rl>r)
	 DXSetEnumeratedMember(gopen,so++,(Object)in_line);
       else 
	 DXSetEnumeratedMember(gclosed,sc++,(Object)in_line);
     }
     out[0]=(Object)gopen;
     out[1]=(Object)gclosed;

     return OK;
   }
error:
     return ERROR;
}
