SHELL = /bin/sh
BASE = /usr/local/dx

# need arch set, e.g. by
# setenv DXARCH `dx -whicharch`
DXARCH=linux
#DXARCH=sgi
include $(BASE)/lib_$(DXARCH)/arch.mak

FILES_readmhdhdf = userreadmhdhdf.$(OBJEXT) read_mhd_hdf.$(OBJEXT)
BIN = $(BASE)/bin

#windows BIN = $(BASE)\bin
CFLAGS = -I./ -I$(BASE)/include $(DX_CFLAGS)
LDFLAGS = -L$(BASE)/lib_$(DXARCH)
LIBS = -lDX $(DX_GL_LINK_LIBS) $(DXEXECLINKLIBS)
OLIBS = -lDXlite -lm
BIN = $(BASE)/bin
HDF = /usr/local/hdf

FFLAGS = -static -finit-local-zero -fugly-logint -I$(HDF)/include 
#FFLAGS = -static -n32 -I$(HDF)/include 
FOBJS = ionosphere.o ionset.o ion-cur.o grid.o cord.o cart-int.o \
        interp-all.o intcoef1d.o bzz.o flux2ave.o jcalc2.o hdftake-j-JB.o


# create the necessary executable
readmhdhdf: $(FILES_readmhdhdf) $(FOBJS)
	$(F77) $(DXABI) $(LDFLAGS) -o readmhdhdf userreadmhdhdf.$(OBJEXT) read_mhd_hdf.$(OBJEXT) $(FOBJS) $(DX_RTL_LDFLAGS) $(SYSLIBS) $(HDF)/lib/libdf.a

.c.o: ; cc -c $(DXABI) $(DX_RTL_CFLAGS) $(CFLAGS) $*.c 

.C.o: ; cc -c $(DXABI) $(DX_RTL_CFLAGS) $(CFLAGS) $*.C 

.F.o: ; $(F77) $(FFLAGS) -c $*.F

# a command to run the user module
run: readmhdhdf 
	dx -edit -mdf readmhdhdf.mdf &

# make the user files
userreadmhdhdf.c: readmhdhdf.mdf
	$(BIN)/mdf2c -m readmhdhdf.mdf > userreadmhdhdf.c
# kluge for when DXARCH isn't set
$(BASE)/lib_/arch.mak:
	(export DXARCH=`dx -whicharch` ; $(MAKE) -f readmhdhdf.make )
	echo YOU NEED TO SET DXARCH via dx -whicharch
