#################################################################################
#  
#  Usage: perl rename_common.pl FILE EXT
#
#  Modifies COMMON and SUBROUTINE names in Tsyganenko Fortran codes
#  so there is not a conflict when they are linked.
#
#  R.S. Weigel 2/04/2005.
#################################################################################

#################################################################################
$num = scalar(@ARGV);
if ($num != 2) {
    die "Incorrect number of arguments.\nUsage: rename_common.pl FILE EXT\n";
}
#################################################################################

open(INFILE,"$ARGV[0]");
open(OUTFILE,">$ARGV[0].modified");

while ($line = <INFILE>) {

    
    if ($ARGV[0] =~ m/T03/) {
	if ($line =~ m/CALL\s.*[A-Z]/)  {
	    printf("Old line: %s", $line);
	    if (($line !~ m/CALL T03/) && ($line !~ m/CALL DIP\(/))  {
		$line =~ s/CALL [A-Z](.*)\(/CALL $ARGV[1]$1\(/;
	    }
	    printf("New line: %s", $line);
	}

	if ($line =~ m/SUBROUTINE\s.*[A-Z]/)  {
	    printf("Old line: %s", $line);
	    if (($line !~ m/SUBROUTINE T03/))  {
		$line =~ s/SUBROUTINE [A-Z](.*)\(/SUBROUTINE $ARGV[1]$1\(/;
		$line =~ s/SUBROUTINE  [A-Z](.*)\(/SUBROUTINE  $ARGV[1]$1\(/;
	    }
	    printf("New line: %s", $line);
	}
    }

    if ($ARGV[0] =~ m/T96/) {
	if ($line =~ m/CALL\s.*[A-Z]/)  {
	    printf("Old line: %s", $line);
	    if (($line !~ m/CALL T96/))  {
		$line =~ s/CALL [A-Z](.*)\(/CALL $ARGV[1]$1\(/;
		$line =~ s/CALL  [A-Z](.*)\(/CALL  $ARGV[1]$1\(/;
	    }
	    printf("New line: %s", $line);
	}

	if ($line =~ m/SUBROUTINE\s.*[A-Z]/)  {
	    printf("Old line: %s", $line);
	    if (($line !~ m/SUBROUTINE T96/))  {
		$line =~ s/SUBROUTINE [A-Z](.*)\(/SUBROUTINE $ARGV[1]$1\(/;
		$line =~ s/SUBROUTINE  [A-Z](.*)\(/SUBROUTINE  $ARGV[1]$1\(/;
	    }
	    printf("New line: %s", $line);
	}
    }

    if ($ARGV[0] =~ m/T01/) {
	if ($line =~ m/CALL\s.*[A-Z]/)  {
	    printf("Old line: %s", $line);
	    if (($line !~ m/CALL T01/))  {
		$line =~ s/CALL [A-Z](.*)\(/CALL $ARGV[1]$1\(/;
		$line =~ s/CALL  [A-Z](.*)\(/CALL  $ARGV[1]$1\(/;
	    }
	    printf("New line: %s", $line);
	}

	if ($line =~ m/SUBROUTINE\s.*[A-Z]/)  {
	    printf("Old line: %s", $line);
	    if (($line !~ m/SUBROUTINE T01/))  {
		$line =~ s/SUBROUTINE [A-Z](.*)\(/SUBROUTINE $ARGV[1]$1\(/;
		$line =~ s/SUBROUTINE  [A-Z](.*)\(/SUBROUTINE  $ARGV[1]$1\(/;
	    }
	    printf("New line: %s", $line);
	}
    }

    if ($ARGV[0] =~ m/T89/) {
	if ($line =~ m/REAL  A\(1\), XI\(1\)/)  {
	    printf("Old line: %s", $line);
	    $line =~ s/A\(1\)/A\(30\)/;
	    $line =~ s/XI\(1\)/XI\(4\)/;
	    printf("New line: %s", $line);
	}
    }

    if ($line =~ m/COMMON/)  {
	
	# Special case for Geopack_2003.  Need
	# to shorten name so modified name does
	# not make line too long.
	if ($ARGV[0] =~ m/Geopack_2003/) {
	    if ($line =~ m/\/GEOPACK/)  {
		$line =~ s/\/GEOPACK/\/GEOPK/;
	    }
	}

	printf("Old line: %s", $line);
	if ($line =~ s?(.*COMMON.*)/(.*)/ (.*)?$1/$2$ARGV[1]/ $3?) {
	} else {
	    $line =~ s?(.*COMMON.*)/(.*)/(.*)?$1/$2$ARGV[1]/$3?;
	}
	printf(OUTFILE "%s", $line);
	printf("New line: %s", $line);
    } else {
	printf(OUTFILE "%s", $line);
    }

}

$com = "cp $ARGV[0] $ARGV[0].original";
system($com);

$com = "cp $ARGV[0].modified " . $ARGV[0];
system($com);

close(INFILE);
close(OUTFILE);
