#include <stdio.h>
#include "express.h"
#define MAX_NAME_SIZE 256

int
sm_gsmgse(OMobj_id sp_to_gsmgse_id, OMevent_mask event_mask, int seq_num)
{
   /***********************/
   /*  Declare variables  */
   /***********************/
   char  *CoordSys = NULL;
   double  Scale;
   int Trans_Data = 1;
   int  *UT_Time = NULL;
   int UT_Time_size = 0;
   OMobj_id SmField_id;
   int SmField_ndim, *SmField_dims, SmField_nspace, SmField_nnodes;
   float *SmField_coord;
   int SmField_ncomp, SmField_comp_count, SmField_veclen;
   int    SmField_data_type, SmField_ndata;
   float  *SmField_data;
   OMobj_id GSMField_id;
   int GSMField_ndim, *GSMField_dims, GSMField_nspace, GSMField_nnodes;
   float *GSMField_coord;
   int GSMField_ncomp, GSMField_comp_count, GSMField_veclen;
   int    GSMField_data_type, GSMField_ndata;
   float  *GSMField_data;
   OMobj_id DipoleAxis_id;
   int DipoleAxis_ndim, *DipoleAxis_dims, DipoleAxis_nspace, DipoleAxis_nnodes;
   float *DipoleAxis_coord;
   int DipoleAxis_ncomp, DipoleAxis_comp_count, DipoleAxis_veclen;
   int    DipoleAxis_data_type, DipoleAxis_ndata;
   float  *DipoleAxis_data;

   int *t,i,j,k,size,coord;
   float *gsm;
   float gse[3],r1[3][3], r[3],xs,ys,zs,xn,yn,zn,cj;
   float north[3], south[3];
   
   float *sm;
   char label[MAX_NAME_SIZE];
   char delim[1] = ";";
   int dims0[1];
 

   /***********************/
   /*  Get input values   */
   /***********************/
   /* Get CoordSys's value */
   if (OMget_name_str_val(sp_to_gsmgse_id, OMstr_to_name("CoordSys"),
			  &CoordSys, 0) != 1)
     CoordSys = NULL;

   /* Get Scale's value */
   if (OMget_name_real_val(sp_to_gsmgse_id, OMstr_to_name("Scale"),
			   &Scale) != 1)
     Scale = 1.0;
   
   /* Get Time array */
   /* Get Trans_data value */
   if (OMget_name_real_val(sp_to_gsmgse_id, OMstr_to_name("Trans_Data"),
			   &Trans_Data) != 1)
     Trans_Data = 1.0;
   
   UT_Time = (int *)OMret_name_array_ptr(sp_to_gsmgse_id,
					 OMstr_to_name("UT_Time"),
					 OM_GET_ARRAY_RD,
					 &UT_Time_size, NULL);

	if (UT_Time == 0) {
		
   ERRverror("",ERR_NO_HEADER | ERR_INFO," sm_gsmgse: no input time\n");
		return (1);
	}
   /* Get SmField structured mesh */
   /* Get mesh id */
   SmField_id = OMfind_subobj(sp_to_gsmgse_id, OMstr_to_name("SmField"), OM_OBJ_RW);
	if (OMis_null_obj(SmField_id)) {
		
   ERRverror("",ERR_NO_HEADER | ERR_INFO," sm_gsmgse: no input field\n");
		return (1);
	}

   /* Get mesh dims array */
   FLDget_dims (SmField_id, &SmField_dims, &SmField_ndim);

   /* Get mesh nspace */
   FLDget_nspace (SmField_id, &SmField_nspace);
	if (SmField_nspace != 3) {
			   ERRverror("",NULL," sm_gsmgse only works for nspace=3 \n");
		return(0);
	}
   /* Get mesh coordinates */
   FLDget_coord (SmField_id, &SmField_coord, &SmField_nnodes, 
                 OM_GET_ARRAY_RD);
   /* Get SmField's node data */

   /* Get field id */
   SmField_id = OMfind_subobj(sp_to_gsmgse_id, OMstr_to_name("SmField"), OM_OBJ_RW);

   /* Get number of node data components */
   FLDget_node_data_ncomp (SmField_id, &SmField_ncomp);

   /***********************/
   /* Function's Body     */
   /***********************/
   ERRverror("",ERR_NO_HEADER | ERR_INFO,"I'm in function: sm_gsmgse generated from method: sp_to_gsmgse.sm_gsmgse\n");


   /***********************/
   /*  Set output values  */
   /***********************/
   
   /* Set GSMField structured mesh */

   /* Get mesh id */
   GSMField_id = OMfind_subobj(sp_to_gsmgse_id, OMstr_to_name("GSMField"), OM_OBJ_RW);

   /* Set mesh dimensionality, GSMField_ndim can be 1,2 or 3 */
   FLDset_ndim (GSMField_id, SmField_ndim);

   /*** fill in dims array with your values ***/

   FLDset_dims (GSMField_id, SmField_dims);

   /* Set mesh nspace, GSMField_nspace can be 1,2 or 3 */
   FLDset_nspace (GSMField_id, SmField_nspace);

   /* Set mesh coordinates */
   /* first allocate GSMField_coord array */
		GSMField_nnodes = SmField_nnodes;
   FLDget_nnodes (GSMField_id, &GSMField_nnodes);
   GSMField_nspace = SmField_nspace;
   GSMField_coord = (float *)ARRalloc(NULL, DTYPE_FLOAT, 
                              GSMField_nspace*GSMField_nnodes, NULL);

   /*** fill in GSMField_coord array with X[,Y,Z] values at each node ***/

   
   /* Set DipoleAxis structured mesh */

   /* Get mesh id */
   DipoleAxis_id = OMfind_subobj(sp_to_gsmgse_id, OMstr_to_name("DipoleAxis"), OM_OBJ_RW);

   /* Set mesh dimensionality, DipoleAxis_ndim can be 1,2 or 3 */
   DipoleAxis_ndim=1;
   FLDset_ndim (DipoleAxis_id, DipoleAxis_ndim);

   /* Set mesh dims array */
   DipoleAxis_dims = (int *)ARRalloc(NULL, DTYPE_INT, DipoleAxis_ndim, NULL);

   /*** fill in dims array with your values ***/
   DipoleAxis_dims[0]=2;
   FLDset_dims (DipoleAxis_id, DipoleAxis_dims);
   if (DipoleAxis_dims)
      ARRfree((char *)DipoleAxis_dims);

   /* Set mesh nspace, DipoleAxis_nspace can be 1,2 or 3 */
   DipoleAxis_nspace=3;
   FLDset_nspace (DipoleAxis_id, DipoleAxis_nspace);

   /* Set mesh coordinates */
   /* first allocate DipoleAxis_coord array */
   FLDget_nnodes (DipoleAxis_id, &DipoleAxis_nnodes);
   
   DipoleAxis_coord = (float *)ARRalloc(NULL, DTYPE_FLOAT, 
                              DipoleAxis_nspace*DipoleAxis_nnodes, NULL);

   /*** fill in DipoleAxis_coord array with X[,Y,Z] values at each node ***/

   
   /* set  DipoleAxis node data */

   /* Get field id */
   DipoleAxis_id = OMfind_subobj(sp_to_gsmgse_id, OMstr_to_name("DipoleAxis"), OM_OBJ_RW);

   /* Set number of node data components */
   DipoleAxis_ncomp=1;
   FLDset_node_data_ncomp (DipoleAxis_id, DipoleAxis_ncomp);

   /* For each node data component set veclen, type and data arry itself */
   /* Set veclen, assign DipoleAxis_veclen before next call */
   DipoleAxis_veclen = 1;
   FLDset_node_data_veclen (DipoleAxis_id,0,DipoleAxis_veclen);

   /* Set data array */
   DipoleAxis_data_type = DTYPE_FLOAT;

   /* allocate DipoleAxis_data array first */
   /* assume float array and DipoleAxis_ndata is set to number of nodes */
   DipoleAxis_ndata = DipoleAxis_nnodes;
   DipoleAxis_data = (float *)ARRalloc(NULL, DipoleAxis_data_type, 
                                 DipoleAxis_veclen*DipoleAxis_ndata, NULL);

      /*  Other useful calls:

          FLDset_node_data_id()
          FLDset_node_null_data()
          FLDset_node_data_label()
      */
   
   dims0[0] = 2;
/*  FILL IN THE OUTPUT FIELD  Here!                                      */
/*                                                                       */
/* Free old field data                                                   */

   DipoleAxis_data[0]=1.;
   DipoleAxis_data[1]=1.;
   t = UT_Time;
   j = 0;
   north[0]=north[1]=0;
   north[2] = Scale;
   south[0]=south[1] = 0;
   south[2]=-(Scale);

   RECALC(t,t+1,t+2,t+3,t+4);
	
/* Rotate Points into selected Coord System  */
 
 
   size = GSMField_nnodes;
   if(!strcmp(CoordSys,"NONE"))
     coord = 3;
   else if (!strcmp(CoordSys,"GSM"))
     coord = 0;
   else if (!strcmp(CoordSys,"GSE"))
     coord = 1;
   else if (!strcmp(CoordSys,"GEO"))
     coord = 2;
   /*	coord = AVSchoice_number("Coord SYS",out_sys) - 1; */

  		/* Set rotation coefficients */

   j = 1;
   xn = 1;
   yn = 0;
   zn = 0;
   for (i=0;i<3;i++) {
     SMGSM(&xn,&yn,&zn,gse,gse+1,gse+2,&j);  
     if (coord ==0)  {
       r1[0][i] = gse[0];
       r1[1][i] = gse[1];
       r1[2][i] = gse[2];
     }	
     if(coord ==1) {
       j=1;
       GSMGSE(gse,gse+1,gse+2,r,r+1,r+2,&j);
       r1[0][i] = r[0];
       r1[1][i] = r[1];
       r1[2][i] = r[2];
     }
     if(coord == 2) {
       j = -1;
       GEOGSM(r,r+1,r+2,gse,gse+1,gse+2,&j);	
       r1[0][i] = r[0];
       r1[1][i] = r[1];
       r1[2][i] = r[2];
     }
     k = xn;
	 xn = zn;
 	 zn = yn; 
	 yn = k; 
}
/* printf("r1 = %f %f %f\n     %f %f %f\n     %f %f %f\n",
		r1[0][0],r1[1][0],r1[2][0],r1[0][1],r1[1][1],r1[1][2],r1[0][2],r1[1][2],
			r1[2][2]);
*/

 /* No Rotation */
   
   

   if (coord == 3) {

  		for ( i=0;i<SmField_nnodes;i++){
     	GSMField_coord[i] = SmField_coord[i];
     /*     printf("%f %f\n",GSMField_coord[i],SmField_coord[i]); */
   		}
		DipoleAxis_coord[0] = north[0];
       DipoleAxis_coord[1] = north[1];
       DipoleAxis_coord[2] = north[2];
       DipoleAxis_coord[3] = south[0];
       DipoleAxis_coord[4] = south[1];
       DipoleAxis_coord[5] = south[2];
     } 
   
   else{
     /* Do dipole axis rotation */
 		for (k=0;k<3;k++) {
		DipoleAxis_coord[k] = r1[k][0]*north[0]
			+r1[k][1]*north[1]+r1[k][2]*north[2]; 
  		DipoleAxis_coord[k+3] = r1[k][0]*south[0]
			+r1[k][1]*south[1]+r1[k][2]*south[2];
		}
   }
	
   printf("Finished Dipole Rotation:%f %f %f %f %f %f\n",DipoleAxis_coord[0],DipoleAxis_coord[1],
		DipoleAxis_coord[2],DipoleAxis_coord[3],DipoleAxis_coord[4],
		DipoleAxis_coord[5]);

   /* Rotate data coordinates */
   if (coord != 3) {	
     for (i=0;i<size;i++) {
       gsm = GSMField_coord + 3*i;
       sm = SmField_coord + 3*i;
  	for (k=0;k<3;k++) gsm[k] = r1[k][0]*sm[0]+r1[k][1]*sm[1]+r1[k][2]*sm[2];              }
   }
   /*	Now do data */
printf("Coordinate rotation done\n");

   /* Get GSM field id */
   GSMField_id = OMfind_subobj(sp_to_gsmgse_id, OMstr_to_name("GSMField"), OM_OBJ_RW);
 
   /* Set number of node data components */
 	GSMField_ncomp=SmField_ncomp;
   FLDset_node_data_ncomp (GSMField_id, GSMField_ncomp);
	
   /* Set data array */
   /* data_type should be set to one of the following: 
      DTYPE_BYTE, DTYPE_CHAR, DTYPE_SHORT, 
      DTYPE_INT, DTYPE_FLOAT, DTYPE_DOUBLE) */

   GSMField_data_type = DTYPE_FLOAT;


   for (cj = 0; cj<SmField_ncomp;cj++) {
     /* Get veclen  of current data component */

     FLDget_node_data_veclen (SmField_id, cj, &SmField_veclen);
   FLDget_node_data_label (SmField_id, cj, label, MAX_NAME_SIZE);

     /* Get data array and data_type which is one of the following: 
	DTYPE_BYTE, DTYPE_CHAR, DTYPE_SHORT, 
	DTYPE_INT, DTYPE_FLOAT, DTYPE_DOUBLE */
   
     FLDget_node_data (SmField_id, cj, &SmField_data_type,
		       &SmField_data,&SmField_ndata, OM_GET_ARRAY_RD);

/* Correct for get error in current express */

     

   /* allocate  GSMField node data component by component */


  
   /* Set veclen, assign GSMField_veclen before next call */

     GSMField_veclen = SmField_veclen;
   FLDset_node_data_comp (GSMField_id,cj,GSMField_veclen, label,"");

/* Correct for get error in current express */
	GSMField_ndata = SmField_ndata/SmField_veclen;
/* end correction */


   /* allocate GSMField_data array first */
   /* assume float array and GSMField_ndata is set to number of nodes */
 
    GSMField_data = (float *)ARRalloc(NULL, SmField_data_type, 
				   GSMField_veclen *GSMField_ndata, NULL); 

   
   if(GSMField_data == NULL){
     printf("Could not allocate data array\n");
   }
/*   else printf("Allocated %d data\n",GSMField_veclen*GSMField_ndata);
    
   
   printf("%f %f %f %f %f %f %d\n",xn,yn,zn,xs,ys,zs,SmField_veclen);
*/


   for (i=0;i<size*SmField_veclen;i=i+SmField_veclen) {
     gsm = GSMField_data +i;
     sm = SmField_data +i;
     /*  scalar or coord ==3, no rotation */
	if (SmField_veclen != 3 || coord ==3 || !Trans_Data) {
		for (k=0;k<SmField_veclen;k++)  gsm[k] = sm[k];
	} 
	else { 

		/* Vector - Do rotation */
	for (k=0;k<3;k++) gsm[k] = r1[k][0]*sm[0]+r1[k][1]*sm[1]+r1[k][2]*sm[2];
	   
	}
   }
   FLDset_node_data (GSMField_id, cj, GSMField_data,
		     GSMField_data_type,
		     GSMField_ndata*GSMField_veclen, OM_SET_ARRAY_FREE);
       

	/*	AVSfield_get_labels(SM_Field,label,delim);
		AVSfield_set_labels(*GSM_Field,label,delim); */
   }
                 
 printf("Now store the data:\n");

  FLDset_coord (GSMField_id, GSMField_coord,
		 GSMField_nspace*GSMField_nnodes, 
		 OM_SET_ARRAY_FREE);

   FLDset_coord (DipoleAxis_id, DipoleAxis_coord,
		 DipoleAxis_nspace*DipoleAxis_nnodes, 
		 OM_SET_ARRAY_FREE);
   
   FLDset_node_data (DipoleAxis_id,0, DipoleAxis_data,
		     DipoleAxis_data_type,
		     DipoleAxis_ndata*DipoleAxis_veclen,
		     OM_SET_ARRAY_FREE);
 
   /*************************/
   /*  Free input variables */
   /*************************/
   if (CoordSys)
      free(CoordSys);

   if (SmField_dims)
      ARRfree((char *)SmField_dims);
   if (SmField_coord)
      ARRfree((char *)SmField_coord);
   if (SmField_data)
     ARRfree((float *)SmField_data);

   return(1);
}
