      Program hdftake
!      Subroutine hdftake(G, R)
#include "hdf.inc"

      Character*80 fname, name

      Real*8 Ihead(4),G(23,76,36,25), day, hour, min, R(25)
      Integer*4 iFIleid, iSecid, iSecindex, iaDimid, iRank, iAttrid
      Integer iNtype, iNattr, iLen, iStatus
      Integer steps, stepnum
      Integer iaDim4d(4), iaStart4d(4), iaEdge4d(4), iaStride4d(4)
      Integer iaDim1d(1), iaStart1d(1), iaEdge1d(1), iaStride1d(1)
      Integer sfstart, sfend, sffattr, sfrcatt, sfrnatt, sfn2index
      Integer sfselect, sfginfo, sfrdata, sfendacc
      Character*80 caCont, caDim, caSec, caAttr
      Logical found
      found=.false.
c      nargs = iargc()
c      if(nargs < 4)then
c         write(6,*)'incorrect call to hdftake'
c         write(6,*)
c     $        'usage: hdftake filename model_day model_hour model_min'
c         return
c      endif
c      call getarg(1,fname)
c      call getarg(2, day)
c      call getarg(3, hour)
c      call getarg(4, min)
      day = 1
      hour = 4
      min = 0
      fname = 'cmite7001.hdf'
      iFileid = sfstart(fname, DFACC_RDONLY)
      if(iFileid .lt. 0) then 
         write(6,*) 'Unable to open ',fname,' for read!'
         STOP
      endif
                                !determine who wrote the file
      iSecid = sffattr(iFileid, 'written_by')
      iStatus = sfrcatt(iFileid, iSecid, caAttr)
      if(iStatus .eq. -1)then
         write(6,*)'hdftake: failed to find written_by'
         STOP
      endif
      if(caAttr(1:1) .eq. 'C')then
         write(6,*)'hdftake: unable to restart from C files'
         STOP
      endif
      iSecid = sffattr(iFileid,'steps')
      iStatus = sfrnatt(iFileid, iSecid, steps)
      if(iStatus .eq. -1) then
         write(6,*)'hdftake: failed to determine number of steps'
         STOP
      endif
      
      stepnum = 1
 1000 Continue
c     stepnum = stepnum + 1
c      call RSTSTR(name)
c      write(name, 103)day, hour, min
c      iSecindex = sfn2index(iFileid, name)
c      iSecid = sfselect(iFileid, iSecindex)
c      iStatus = sfginfo(iSecid, caSec, iRank, iaDim1d, iNtype, iNattr)
c      if(iStatus .eq. -1)then
c         write(6,*)'hdftake: failure reading time step info'
c         STOP
c      endif
c      do i=1,iRank
c         iaStart1d(i) = 0
c         iaEdge1d(i) = iaDim1d(i)
c      enddo
c      iStatus = sfrdata(iSecid, iaStart1d, 1, iaEdge1d, Ihead)
c      if(iStatus .eq. -1)then
c         write(6,*)'hdftake:failure reading time step'
c         STOP
c      endif
c      iStatus = sfendacc(iSecid)
c       if(iStatus .eq. -1)then
c         write(6,*)'hdftake:failure closing time step'
c         STOP
c      endif
c      write(6,*)Ihead
c      if(stepnum .eq. 1 .AND. 
c     $     ((day .lt. Ihead(2)) .OR.
c     $     ((day .le. Ihead(2)) .AND. (hour .lt. Ihead(3))) .OR.
c     $     ((day .le. Ihead(2)) .AND. (hour .le. Ihead(3)) 
c     $     .AND. (min .lt. Ihead(4))))) then
c                               !time step not in file
c         write(6,*)'hdftake WARNING: '
c         write(6,*)'time given is before the first time in the file'
c         write(6,*)'hdftake: returning the first time step in the file'
cc     set g to the coresponding data array
c         found=.true.
c      endif  
c      if(stepnum .eq. steps .AND. 
c     $     (day .gt. Ihead(2) .OR.
c     $     (day .ge. Ihead(2) .AND. hour .gt. Ihead(3)) .OR.
c     $     (day .ge. Ihead(2) .AND. hour .ge. Ihead(3) 
c     $     .AND. min .gt. Ihead(4)))) then
c                                !time step not in file
c         write(6,*)'hdftake WARNING'
c         write(6,*)'time given is after the last time in the file'
c         write(6,*)'hdftake: returning the last time step in the file'
cc     set g to last data array
c         found=.true.
c      endif                     !step occurs after file ends
c      if(day .eq. Ihead(2) .AND. hour .eq. Ihead(3) 
c     $     .AND. min .eq. Ihead(4))then
c     set g to the current data array
c         write(6,*)'yo'
c         write(6,*)'hdftake: found the correct time step'
c         found=.true.
c      endif
c      if(.not.found) then
c         stepnum = stepnum + 1
c         goto 1000
c      endif
c      
cc     begining of g being set to the correct array
      call RSTSTR(caSec)
      write(caSec, 103)nint(day), nint(hour), nint(min)
c      write(6,*)caSec
      iSecindex = sfn2index(iFileid,caSec)
      iSecid = sfselect(iFileid,iSecindex)
      iStatus = sfginfo(iSecid,caSec,iRank,iaDim4d,iNtype,iNattr)
      if(iStatus .eq. -1)then
         write(6,*)'hdftake:failure getting data step info'
         STOP
      endif
      do i=1,iRank
         iaStride4d(i) = 1
         iaStart4d(i) = 0
         iaEdge4d(i) = iaDim4d(i)
      enddo
      iStatus = sfrdata(iSecid, iaStart4d, iaStride4d, iaEdge4d, G)
      
      if(iStatus .eq. -1)then
         write(6,*)'hdftake:failure reading data step'
         STOP
      endif
      iStatus = sfendacc(iSecid)
      if(iStatus .eq. -1)then
         write(6,*)'hdftake:failure closing data step'
         STOP
      endif                     !done writing time step for this case
      iStatus = sfend(iFileid)
      if(iStatus .eq. -1)then
         write(6,*)'hdftake:failure closing file'
         STOP
      endif

      do k=1,25
         do j=1,36
            do i=1,76
               do h=1,23
                  write(6,*)h+23*((i-1)+76*((j-1)+36*(k-1))),G(h,i,j,k)
               enddo
            enddo
         enddo
      enddo
      

 100  format('hdftake: there are ',i3.3,' time steps in this file')
 101  format('look for model day ',i3.3,' hour ',i3.3,' min ',i3.3)
 102  format('time_',i3.3)
 103  format('data_',i3,'_',i3,'_',i3)

c     RETURN
      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine RSTSTR(caout)
      character*(*) caout

      iLen = len(caout)
      do i=1,iLen
         caout(i:i) = '\0'
      ENDDO

      RETURN 
      END
