      Subroutine readtinghdf(fname, G, D, R, day, hour, min, flag)


#include "hdf.inc"
#include "dffunc.inc"

      Character*1024 fname, name

      Real*8 Ihead(4),G(23,73,36,25),F(23,76,36,25),R(25),D(23,72,36,25)
      Real*8 mday, mhour, mmin,fstep(3),lstep(3),day,hour,min
      Integer*4 iFIleid, iSecid, iSecindex, iaDimid, iRank, iAttrid
      Integer iNtype, iNattr, iLen, iStatus
      Integer steps, stepnum, one, blah
      Integer iaDim4d(4), iaStart4d(4), iaEdge4d(4), iaStride4d(4)
      Integer iaDim1d(1), iaStart1d(1), iaEdge1d(1), iaStride1d(1)
      Integer flag
      Logical found
      Character*80 caCont, caDim, caSec, caAttr


      found = .false.
      one = 1
      mday = day
      mhour = hour
      mmin = min
      flag = 0
      iFileid = sfstart(fname, DFACC_RDONLY)
      if(iFileid .lt. 0) then 
         flag = -1
         return
      endif
!     determine who wrote the file
      iSecid = sffattr(iFileid, 'written_by')
      iStatus = sfrcatt(iFileid, iSecid, caAttr)
      if(iStatus .eq. -1)then
         flag = -2
         return
      endif
      if(caAttr(1:1) .eq. 'C')then
         flag = -3
         return
      endif
!     get the total number of steps
      iSecid = sffattr(iFileid,'steps')
      iStatus = sfrnatt(iFileid, iSecid, steps)
      if(iStatus .eq. -1) then
         flag = -4
         return
      endif
!     get the first time step in the file
      call xRSTSTR(name)
      write(name, 102)'first step'
      iSecindex = sfn2index(iFileid, name)
      iSecid = sfselect(iFileid, iSecindex)
      iStatus = sfginfo(iSecid, caSec, iRank, iaDim1d, iNtype, iNattr)
      if(iStatus .eq. -1)then
         flag = -5
         return
      endif
      do i=1,iRank
         iaStart1d(i) = 0
         iaEdge1d(i) = iaDim1d(i)
      enddo
      iStatus = sfrdata(iSecid, iaStart1d, 1, iaEdge1d, fstep)
      if(iStatus .eq. -1)then
         flag = -6
         return 
      endif
      iStatus = sfendacc(iSecid)
      if(iStatus .eq. -1)then
         flag = -7
         return
      endif 
!     get the last time step in the file
      call xRSTSTR(name)
      write(name, 102)'last step'
      iSecindex = sfn2index(iFileid, name)
      iSecid = sfselect(iFileid, iSecindex)
      iStatus = sfginfo(iSecid, caSec, iRank, iaDim1d, iNtype, iNattr)
      if(iStatus .eq. -1)then
         flag = -5
         return
      endif
      do i=1,iRank
         iaStart1d(i) = 0
         iaEdge1d(i) = iaDim1d(i)
      enddo
      iStatus = sfrdata(iSecid, iaStart1d, 1, iaEdge1d, lstep)
      if(iStatus .eq. -1)then
         flag = -6
         return 
      endif
      iStatus = sfendacc(iSecid)
      if(iStatus .eq. -1)then
         flag = -7
         return
      endif 
      stepnum = 1
      if(mday .lt. fstep(1) .OR.!check if time given is before first in file
     $     (mday .le. fstep(1) .AND. mhour .lt. fstep(2)) .OR.
     $     (mday .le. fstep(1) .AND. mhour .le. fstep(2) .AND. 
     $     mmin .lt. fstep(3))) then
         mday = fstep(1)
         mhour = fstep(2)
         mmin = fstep(3)
         flag = 1
      endif
      if(mday .gt. lstep(1) .OR.!check if time given is after last in file
     $     (mday .ge. lstep(1) .AND. mhour .gt. lstep(2)) .OR.
     $     (mday .ge. lstep(1) .AND. mhour .ge. lstep(2) .AND. 
     $     mmin .gt. lstep(3))) then
         mday = lstep(1)
         mhour = lstep(2)
         mmin = lstep(3)
         flag = 2
      endif
!     Find the time step now
      call xRSTSTR(name)
      write(name, 103)nint(mday),nint(mhour),nint(mmin)
      iSecindex = sfn2index(iFileid, name)
      if(iSecindex .eq. -1)then
         flag = -8
         return
      endif
      iSecid = sfselect(iFileid, iSecindex)
      iStatus = sfginfo(iSecid, caSec, iRank, iaDim4d, iNtype,iNattr)
      if(iStatus .eq. -1)then
         flag = -9
         return
      endif

      do i=1,iRank
         iaStride4d(i) = 1
         iaStart4d(i) = 0
         iaEdge4d(i) = iaDim4d(i)
      enddo
!      write(6,*)'info: ',iaStride4d,' ',iaStart4d,' ',iaEdge4d
!     read the time step
      iStatus = sfrdata(iSecid, iaStart4d, iaStride4d, iaEdge4d, F)
      if(iStatus .eq. -1)then
         flag = -10
         return
      endif
      iStatus = sfendacc(iSecid)
      if(iStatus .eq. -1)then
         flag = -11
         return
      endif                   
!     done reading data step for this case
      iStatus = sfend(iFileid)
      if(iStatus .eq. -1)then
         flag = -12
         return
      endif
!     copy f to g
      DO k=1,25
         DO j=1,36
            DO i=1,72
               DO h=1,23
                  G(h,i,j,k)=F(h,i,j,k)
                  D(h,i,j,k)=F(h,i,j,k)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
!     copy the periodic row of longitude to make vis appear complete
      DO k=1,25
         DO j=1,36
            DO h=1,23
               G(h,73,j,k)=F(h,1,j,k)
            ENDDO
         ENDDO
      ENDDO
!     fill in the radius array
      DO k=1,25
         R(k) = ((F(15,1,1,k)/100000)+97.0)
      ENDDO

      
      
 100  format('hdftake: there are ',i3.3,' time steps in this file')
 101  format('look for model day ',i3.3,' hour ',i3.3,' min ',i3.3)
 102  format(a)
 103  format('data_',i3,'_',i3,'_',i3)

      Return
      END
      

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine xRSTSTR(caout)

      character*(*) caout

      iLen = len(caout)
      do i=1,iLen
         caout(i:i) = '\0'
      ENDDO
      RETURN 
      END
