      Program ting2hdf

#include "hdf.inc"
#include "dffunc.inc"

      CHARACTER*80 name
      CHARACTER*80 fname, caCont
      REAL*8 IHEAD(4), G(23,76,36,25),F(76,575),P(1573240),step(3)
      INTEGER*4 iFileid, iSecid, iaDimid, iRank, iStatus
      INTEGER iaDim4d(4), iaStart4d(4), iaEdge4d(4), iaStride4d(4)
      INTEGER iaDim1d(1), iaStart1d(1), iaEdge1d(1), iaStride1d(1)
!      INTEGER sfstart, sfend, sfcreate
!      INTEGER sfwdata, sfendacc, sfsattr
      INTEGER iNx, iNy, iNz, iNv, iLen
      INTEGER stepnum, index
      LOGICAL swap
      SAVE iFileid


      swap = .false.
      nargs = iargc()
      if(nargs < 1) then
         write(6,*)'incorrect call to ting2hdf'
         write(6,*)'usage: ting2hdf filename [-s]'
         return
      endif
      call getarg(1,name)
c      write(fname,102)name
#ifdef AIX
      iLen=LEN_TRIM(name)
#endif
#ifndef AIX
      iLen=LNBLNK(name)
#endif
      fname(1:iLen-3) = name(1:iLen-3)
      fname(iLen-3:iLen) = '.hdf'
      write(6,*)'creating ',fname
      if(nargs > 1)then
         swap = .true.
      endif
      iNx = 76
      iNy = 36
      iNz = 25
      iNv = 23

      iFileid = sfstart(fname(1:iLen), DFACC_CREATE)
      if(iFileid .lt. 0) then 
         write(6,*) 'Unable to open ',fname,' for read!'
         STOP
      endif
      write(6,*)'hdfdump: file created'

      IHIST = 4
      stepnum = 0
      write(caCont, 103) iNx, iNy, iNz, iNv
#ifdef AIX
      iLen=LEN_TRIM(caCont)
#endif
#ifndef AIX
      iLen=LNBLNK(caCont)
#endif
      iStatus = 
     $     sfsattr(iFileid,'file_contents',DFNT_CHAR8,iLen,caCont)
      iStatus = sfsattr(iFileid,'written_by',DFNT_CHAR8,7,'FORTRAN')
         
      if(swap.eq..false.) then
         write(6,*)'dumping a non byte swapped file'
c         iStatus = sfsattr(iFileid,'steps', DFNT_INT32,1,stepnum)
!         done = .false.
c         write(6,*) name
         open(IHIST, file=name, form='UNFORMATTED')
 1000    Continue
         stepnum = stepnum + 1
         READ(IHIST,END=900)IHEAD
         if(stepnum .eq. 1)then
            call xRSTSTR(name)
            write(name,102)'first step'
c            write(6,*)name
            do i=1,3
               step(i) = IHEAD(i+1)
            enddo
c            write(6,*)step
            iaStride1d(1)=1
            iaStart1d(1)=0
            iaEdge1d(1)=3
            iaDim1d(1)=3
            iRank=1
c            write(6,*)'stride ',iaStride1d,' start ',iaStart1d
c            write(6,*)'edge ',iaEdge1d,' dim ',iaDim1d,' rank ',iRank
            iSecId = sfcreate(iFileid,name,DFNT_FLOAT64,iRank,iaDim1d)
            iStatus = sfwdata(iSecId,iaStart1d,iaStride1d,iaEdge1d,step)
            iStatus = sfendacc(iSecId)
c            write(6,*)IHEAD(2),IHEAD(3),IHEAD(4)
         endif
c         call RSTSTR(name)
c         write(name, 100)stepnum
c         write(6,*)name
c         iaStride1d(1)=1
c         iaStart1d(1)=0
c         iaEdge1d(1)=4
c         iaDim1d(1)=4
c         iRank=1
c         write(6,*)'stride ',iaStride1d,' start ',iaStart1d
c         write(6,*)'edge ',iaEdge1d,' dim ',iaDim1d,' rank ',iRank
c         iSecId = sfcreate(iFileid,name,DFNT_FLOAT64,iRank,iaDim1d)
c         iStatus = sfwdata(iSecId,iaStart1d,iaStride1d,iaEdge1d,IHEAD)
c         iStatus = sfendacc(iSecId)
c         write(6,*)IHEAD(2),IHEAD(3),IHEAD(4)
         
         DO J=1,36
            READ(IHIST,END=900)((F(I,K),I=1,76),K=1,25*23)
            do k=1,25
               do i=1,76
                  do h=1,23
                     G(h,i,j,k) = F(i,k+(h-1)*25)
                  enddo
               enddo
            enddo
         enddo
c         write(6,*)F
c         do k=1,25*23
c            do i=1,76
c               write(6,*)i,k,F(i,k)
c            enddo
c         enddo
         
         call xRSTSTR(name)
         write(name, 101)nint(IHEAD(2)),nint(IHEAD(3)),nint(IHEAD(4))
c         write(6,*)name
         iRank = 4
         iaDim4d(1) = iNv
         iaDim4d(2) = iNx
         iaDim4d(3) = iNy
         iaDim4d(4) = iNz
         DO i=1,iRank
            iaStride4d(i)=1
            iaStart4d(i)=0
            iaEdge4d(i)=iaDim4d(i)
         ENDDO
c         write(6,*)'stride ',iaStride4d,' start ',iaStart4d
c         write(6,*)'edge ',iaEdge4d,' dim ',iaDim4d,' rank ',iRank
         iSecId = sfcreate(iFileid,name,DFNT_FLOAT64,iRank,iaDim4d)
         iStatus = sfwdata(iSecId,iaStart4d,iaStride4d,iaEdge4d,G)
         iStatus = sfendacc(iSecId)
         goto 1000
      ELSE
         write(6,*)'dumping a byte swapped file'
c        write(6,*)name
         open(4,file=name,FORM='UNFORMATTED',ACCESS='DIRECT',
     $        RECL=8)
 1001    Continue
         stepnum=stepnum+1
         read(4, END=900)P
         do i=1,1573240
            call byteswapr8(P(i))
c            write(6,*)i,P(i)
         enddo
         do i=1,4
            IHEAD(i) = P(i)
         enddo
c         write(6,*) IHEAD
         if(stepnum .eq. 1)then
            call xRSTSTR(name)
            write(name,102)'first step'
c            write(6,*)name
            do i=1,3
               step(i) = IHEAD(i+1)
            enddo
c            write(6,*)step
            iaStride1d(1)=1
            iaStart1d(1)=0
            iaEdge1d(1)=3
            iaDim1d(1)=3
            iRank=1
c            write(6,*)'stride ',iaStride1d,' start ',iaStart1d
c            write(6,*)'edge ',iaEdge1d,' dim ',iaDim1d,' rank ',iRank
            iSecId = sfcreate(iFileid,name,DFNT_FLOAT64,iRank,iaDim1d)
            iStatus = sfwdata(iSecId,iaStart1d,iaStride1d,iaEdge1d,step)
            iStatus = sfendacc(iSecId)
c            write(6,*)IHEAD(2),IHEAD(3),IHEAD(4)
         endif

         do j=1,36
            index = 5+(j-1)*43700+(j-1)
            do k=1,25*23
               do i=1,76
                  F(i,k) = P(index+i+76*(k-1))
               enddo
            enddo
            do k=1,25
               do i=1,76
                  do h=1,23
                     G(h,i,j,k) = F(i,k+(h-1)*25)
                  enddo
               enddo
            enddo
         enddo
c         write(6,*)'writing f'
c         write(6,*)F
c         write(6,*)'done writing f'
c         stepnum = stepnum + 1
c         call RSTSTR(name)
c         write(name, 100)stepnum
c         write(6,*)name
c         iaStride1d(1)=1
c         iaStart1d(1)=0
c         iaEdge1d(1)=iLen
c         iaDim1d(1)=iLen
c         iRank=1
c         iSecId = sfcreate(iFileid,name,DFNT_FLOAT64,iRank, iaDim1d)
c         iStatus = sfwdata(iSecId,iaStart1d,iaStride1d,iaEdge1d,IHEAD)
c         iStatus = sfendacc(iSecId)
c         write(6,*)IHEAD
c         do j=1,36
c            index = 5 + (j-1)
c            do i=1,76
c               do h=1,23
c                  do k=1,25
c                     call byteswapr8
c     $                    (P(index+h+23*((i-1)+76*((j-1)+36*(k-1)))))
c     $                    (P(index+k+25*((h-1)+23*((i-1)+76*(j-1)))))
c                     G(h,i,j,k) = 
c     $                    (P(index+h+23*((i-1)+76*((j-1)+36*(k-1)))))
c     $                    P(index+k+25*((h-1)+23*((i-1)+76*(j-1))))
c                     write(6,*)h,i,j,k,
c     $                    index+h+23*((i-1)+76*((j-1)+36*(k-1))),
c     $                    G(h,i,j,k),
c     $                    P(index+h+23*((i-1)+76*((j-1)+36*(k-1))))
c     $                    index+k+25*((h-1)+23*((i-1)+76*(j-1))),
c     $                    P(index+k+25*((h-1)+23*((i-1)+76*(j-1))))
c                  enddo
c               enddo
c            enddo
c         enddo
         
c         do k=1,25
c            do j=1,36
c               do i=1,76
c                  do h=1,23
c                     write(6,*)h,i,j,k,G(h,i,j,k)
c                  enddo
c               enddo
c            enddo
c         enddo
         
         call xRSTSTR(name)
         write(name, 101)nint(P(2)),nint(P(3)),nint(P(4))
c         write(6,*)name
         iRank = 4
         iaDim4d(1) = iNv
         iaDim4d(2) = iNx
         iaDim4d(3) = iNy
         iaDim4d(4) = iNz
         DO i=1,iRank
            iaStride4d(i)=1
            iaStart4d(i)=0
            iaEdge4d(i)=iaDim4d(i)
         ENDDO
         iSecId = sfcreate(iFileid,name,DFNT_FLOAT64,iRank,iaDim4d)
         iStatus = sfwdata(iSecId,iaStart4d,iaStride4d,iaEdge4d,G)
         iStatus = sfendacc(iSecId)
         goto 1001 
         
      ENDIF
 100  FORMAT('time_',i3.3)
 101  FORMAT('data_',i3,'_',i3,'_',i3)
 102  FORMAT(a)
 103  FORMAT('3D-MHD',i3,'',i3,'',i3,' with ',i3,' variables')

 900  write(6,*)'End of input file found, finishing HDF file'
c      write(6,*)'last step',IHEAD
      call xRSTSTR(name)
      write(name,102)'last step'
c      write(6,*)name
      do i=1,3
         step(i) = IHEAD(i+1)
      enddo
c      write(6,*)step
      iaStride1d(1)=1
      iaStart1d(1)=0
      iaEdge1d(1)=3
      iaDim1d(1)=3
      iRank=1
c      write(6,*)'stride ',iaStride1d,' start ',iaStart1d
c      write(6,*)'edge ',iaEdge1d,' dim ',iaDim1d,' rank ',iRank
      iSecId = sfcreate(iFileid,name,DFNT_FLOAT64,iRank,iaDim1d)
      iStatus = sfwdata(iSecId,iaStart1d,iaStride1d,iaEdge1d,step)
      iStatus = sfendacc(iSecId)
c      write(6,*)IHEAD(2),IHEAD(3),IHEAD(4)

      iStatus = sfsattr(iFileid,'steps', DFNT_INT32,1,stepnum)
      iStatus = sfend(iFileid)
      
      RETURN
      END



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine xRSTSTR(caout)
      character*(*) caout

      iLen = len(caout)
      do i=1,iLen
         caout(i:i) = '\0'
      ENDDO

      RETURN 
      END
      
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine byteswapr8(r)
  
      integer*1 ii(8), jj(8)
      real*8 r,s,t
      equivalence (s,ii)
      equivalence (t,jj)

      s = r
      jj(1) = ii(8)
      jj(2) = ii(7)
      jj(3) = ii(6)
      jj(4) = ii(5)
      jj(5) = ii(4)
      jj(6) = ii(3)
      jj(7) = ii(2)
      jj(8) = ii(1)
      r = t

      end
