#!/bin/bash

# Example: CISM_DX 0.56 to 0.57
#   svnhistory.sh /cism1/svn/VIZ trunk/CISM_DX-src 1130 1237

REPOS=$1
RPATH=$2
REV1=$3
REV2=$4

echo ""
echo "REVISION : DATE : AUTHOR : LOG"

for r in $( seq $REV2 -1 $REV1 ); do

    LOG=$(svnlook log $REPOS $RPATH -r $r )
    AUTHOR=$(svnlook author $REPOS $RPATH -r $r )
    DATE=$(svnlook date $REPOS $RPATH -r $r | sed -e 's| *(.*) *||' | sed -e 's|-0400||' | sed -e 's/\(:\|-\| \)//g' )
    echo
    echo "$r : $DATE : $(printf '%8s' $AUTHOR) : $LOG"
    svnlook changed $REPOS $RPATH -r $r | sed -e 's|^|       |'

done
