%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot all data as time series
% Needs Matlab hdf scripts.  Tested on RHEL 3.0 with Matlab 6.5.0.  
% R.S. Weigel 08/26/2004
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get global variables and path setting
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CISM_DX_GLOBALS;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hdf_dir      = [CISM_DX_DATA_FULL_ROOT,'measurements/uniform_time_series/'];

% Determine the names of magentoemter data files
D = readdir([hdf_dir,'CISM_DX_1_min_ground_magnetometer_data.*.hdf']);

for i = 1:size(D,2)

PART = sprintf('part_%d',i);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HDF load information 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
eps_filename = ['./make_plots_1_min_ground_magnetometers.',PART,'.eps'];
Title        = ['One Min Gnd. Mag. Data Sets (arb. scales) ',PART];
FILES        = {[hdf_dir,'CISM_DX_1_min_ground_magnetometer_data.',PART,'.hdf']};
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

make_plots_prep;
make_plots_eps;

end

