%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot all data as time series
% Needs Matlab hdf scripts.  Tested on RHEL 3.0 with Matlab 6.5.0.  
% R.S. Weigel 08/26/2004
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get global variables and path setting
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CISM_DX_GLOBALS;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
eps_filename = './make_plots_1_min_satellite.eps';
Title        = '1-minute satellite data';
hdf_dir      = [CISM_DX_DATA_FULL_ROOT,'measurements/uniform_time_series/'];
FILES        = {...
    [hdf_dir,'CISM_DX_1_min_GOES10_data.hdf'],...
    [hdf_dir,'CISM_DX_1_min_GOES8_data.hdf'],...
    [hdf_dir,'CISM_DX_1_min_ULYSSES_data.hdf'],...
    [hdf_dir,'CISM_DX_1_min_POLAR_data.hdf'],...
    [hdf_dir,'CISM_DX_1_min_IMP8_data.hdf'],...
    [hdf_dir,'CISM_DX_1_min_GEOTAIL_data.hdf'],...
    [hdf_dir,'CISM_DX_1_min_WIND_data.hdf'],...
    [hdf_dir,'CISM_DX_1_min_ACE_data.hdf']};
%clear FILES;
%FILES        = {[hdf_dir,'CISM_DX_1_min_ULYSSES_data.hdf']};


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		 
make_plots_prep;
make_plots_eps;
