z  = 1;
z1 = 1;
z2 = 1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for k = 1:length(FILES)

Info      = hdfinfo(FILES{k});
SDS       = Info.SDS;
M         = length(SDS);                % Number of data sets

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load and average the data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j = 1:M

  % Number of points per day
  Npd(z) = str2num(name2value(SDS(j),'Points Per Day'));

  tic;
  temp      = double(hdfread(SDS(j))); % 1-D time series
  fprintf('Loading series #%2d/%2d, load time = %.2f [sec]\n',...
	  j,length(SDS),toc);
  fflush(stdout);

  tic;
  if (Npd > 1) % If more than 1 point per day, compute daily average
    temp  = block_mean_nonflag(temp,Npd(j),CISM_DX_FLAG);
  end
  
  if (size(temp,2) > 1) % 2-D data
    temp  = scale_nonflag(temp,2,[],CISM_DX_FLAG);
    temp  = reflag(temp,CISM_DX_FLAG,0);
  else % 1-D data
    temp  = scale_nonflag(temp,2,[],CISM_DX_FLAG);
    temp  = reflag(temp,CISM_DX_FLAG,mean_nonflag(temp,1,CISM_DX_FLAG));
  end  

  fprintf('Averaging series #%2d/%2d, averaging time = %.2f [sec]\n',...
	  j,length(SDS),toc);

  tempName = SDS(j).Name;

  S = size(temp);
  
  if (max(S) == prod(S)) % 1-D data set
    X1c{z1}     = temp;
    Names1{z1}  = tempName;
    Year_f1(z1) = str2num(name2value(SDS(j),'Year_f'));
    Year_o1(z1) = str2num(name2value(SDS(j),'Year_o'));
    z1 = z1+1;
  else % 2-D data set
    X2c{z2}     = temp;
    Names2{z2}  = tempName;
    Year_f2(z1) = str2num(name2value(SDS(j),'Year_f'));
    Year_o2(z1) = str2num(name2value(SDS(j),'Year_o'));
    z2 = z2+1;
  end

  z = z+1;
end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
