clear

CISM_DX_GLOBALS;

NDAYS       = 10;
LEAD_TIME   = 1;
threat(1)   = 0.8;
threat(2)   = 0.9;
MINY        = 0;
MAXY        = 10;
MINX        = 0;
MAXX        = NDAYS;
YSTEP       = 1;

Xa = [2004 3 1 0 1 1;
      2004 3 2 0 1 1;
      2004 3 3 0 1 1;
      2004 3 4 0 1 1;
      2004 3 5 0 1 1;
      2004 3 6 0 1 1;
      2004 3 7 0 1 1;
      2004 3 8 0 1 1;
      2004 3 9 0 1 1;
      2004 3 10 0 1 1;
      2004 3 11 0 1 1;
      2004 3 12 0 1 1;
      2004 3 13 0 1 1];      
Xf = [Xa;
      2004 3 14 0 1 1];

Xa(:,7:16) = rand(size(Xa,1),10);
Xf(:,7:16) = rand(size(Xf,1),10);

[Va,Vf,T]    = time_union(Xf,Xa,FLAG,'day');
L            = size(Va,1);
[temp,I]     = month_labels([T(1,1):T(end,1)],2);

XLabels         = repmat(blanks(size(temp,2)),length(I),1);
keep            = [1:2:length(I)];
XLabels(keep,:) = temp(keep,:);

Vplot        = Va;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

eglobpar2;   % get access to global parameters
einit2;
eopen2('./plot_2d_demo.eps');

eImageLegendLabelText = '';

eWinWidth       = 200;
eWinHeight      = 140;
ePageWidth      = 1.1*eWinWidth;
ePageHeight     = 1.1*eWinHeight;

ePlotAreaHeight = 80;
ePlotAreaWidth  = 150;
ePlotAreaPos    = [20 40]; % Position of 0,0 on axes wrt bounding
                           % box set by eWinWidth eWinHeight

eImageLegendPos = [0 -5];

colorMap        = [0 0 0;0 0 0;0 0 1;1 1 0;1 0 0];

Vplot           = reflag(Vplot,FLAG,0);

eaxes2(I,XLabels,[MINY YSTEP MAXY],[]);
eimagesc_2d(Vplot',colorMap,'e',[0 0.2 1.0]); % print scaled image
eplot2;
eclose2;

