eglobpar2;  % declare global parameters
einit2;     % get default parameters

ePlotAreaPos       = [15 20]; % x y position of left bottom corner of plot area
ePlotAreaWidth     = 150;     % mm
ePlotAreaHeight    = 200;     % mm
ePlotTitleDistance = 4;
ePlotLegendPos     = [0 -15];
ePlotLegendFontSize = 3;
ePlotLegendFontSize = 3;
eAxesValueFontSize=2;

eopen2(eps_filename);         % open eps-file and write eps-head

Lcolors = [1 0 0 ; ...
	   0 1 0 ; ...
	   0 0 1 ; ...
	   0 1 1 ; ...
	   0 0 0 ];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 1:length(Yc)

  esubplot2(size(Xc,2),1,i,[0.5,1])

  ePlotTitleText       = TITLE{i};
  eXAxisSouthLabelText = XLABEL{i};
  eYAxisWestLabelText  = YLABEL{i};
  
  eaxes2(XTICS{i},XTICLABELS{i},YTICS{i},YTICLABELS{i});
  
  for j = 1:size(Yc{i},2)

    if (length(Xc{i}) < 20000) 
      
      eplot2(Xc{i},Yc{i}(:,j),LEGEND{i,j},0,Lcolors(j,:));    
    
    else

      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      % Kludge to avoid over-filling stack in gs (alt. fix is to re-compile
      % gs with larger stack size).  This forces a pop at about 80% of
      % the stack memory capacity on the gs install on FC 1.
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Nseg = 1+floor(length(Xc{i})/20000);
      for k = 1:Nseg
	a     = 1 + (k-1)*20000;
	b     = a + 20000 - 1;
	b     = min(length(Xc{i}),b);
	if (k == Nseg)
	  eplot2(Xc{i}(a:b),Yc{i}(a:b,j),'',0,Lcolors(j,:));
	else
	  eplot2(Xc{i}(a:b),Yc{i}(a:b,j),LEGEND{i,j},0,Lcolors(j,:));	  
	end
      end
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    end
  
  end

  eplot2; 

end

eclose2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
