%%NAME
%%  estackeps  -  stack eps files
%%
%%SYNOPSIS
%%  estackeps(epsFileNames) stacks files with first file in cell array on
%%  the top of page.  Width of page is determined by width of first
%%  file. Global parameter eWinHeight is ignored and height is the
%%  sum of the heights of the input files.
%%  
%%PARAMETER(S)
%%  epsFileNames  Cell array containing names of eps-files
% written by R.S. Weigel

function estackeps(epsFileNames)

  eglobpar;

  headsize=500;

  nRows = length(epsFileNames);
  
  tWidth=eWinWidth;
  %tHeight=eWinHeight/nRows;
  yPos = 0;
  
  % read boxes
  for i = 1:nRows
    epsFileName = epsFileNames{i};
    epsFile=fopen(epsFileName,'rb');
    head=fread(epsFile,headsize,'uchar');
    fclose(epsFile);
    head=setstr(head');
    pos=findstr(head,'BoundingBox:')+12;
    win(i,:)=sscanf(head(pos(1):pos(1)+40),'%f',4);
    boxWidth=(win(i,3)-win(i,1))/eFac;
    boxHeight=(win(i,4)-win(i,2))/eFac;

    xPos=0;
    rFacW=tWidth/boxWidth;
    einseps(xPos,yPos,epsFileName,rFacW,rFacW); 
    yPos=yPos+boxHeight;

  end
