function Y = sum_nonflag(X,Y,FLAG_VAL,EXACT)
%SUM_NONFLAG Sum of nonflagged elements
%
%  X = SUM_NONFLAG(X,Y) uses FLAG = NaN and CONDITION = 1.
%
%  See IS_FLAG for description of CONDITION.
%
%  X = SUM_NONFLAG(X,Y,FLAG,CONDITION) 
%    
%   See also NONFLAG.

% R.S. Weigel, 03/19/2005.  
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
if (nargin < 3)
  FLAG_VAL = NaN;
end
if (nargin < 4)
  EXACT = 1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  

[jnk,IX] = reflag(X,FLAG_VAL,FLAG_VAL,EXACT);
[jnk,IY] = reflag(Y,FLAG_VAL,FLAG_VAL,EXACT);
I        = union(IX,IY);
Y        = X+Y;
Y(I)     = FLAG_VAL;
  