/* libflag.h    header file that works for both C and C++ */

/* note that this works in both C and C++ because:
          1)  only C style comments are used
          2)  name mangling is turned off using  extern "C" { ... }
              in  #ifdef  --cplusplus   <-- a special name
          3)  good practice is used to be sure included just once
*/

#ifndef LIBFLAG_H_   /* to only include once */
#define LIBFLAG_H_   /* to only include once */

#ifdef __cplusplus    /* make it C if in C++ compiler */
  extern "C" {
#endif

/* Put other C header files here e.g., */
/* #include <time.h>                   */

int is_flag(double *A, double FLAG, int COND);

void mean_nonflag(double *A, double FLAG, 
		  int COND, int mrows, int ncols,
		  double *B, int *Ng);

void moving_mean_nonflag(double *A , double FLAG, 
			 int COND, int mrows, int ncols,
			 int N, double *B , int *Ng );
                            
#ifdef __cplusplus  /* closing } for C in C++ compiler  */
  }
#endif

#endif  /* LIBFLAG_H_  to only include once */


