#include "mex.h"
#include "libflag.h"

void mexFunction(int nlhs, mxArray *plhs[],
                 int nrhs, const mxArray *prhs[])
{
  /* Declare variables. */ 
  int ncols, mrows;
  int COND;
  double FLAG;
  double *pr;
  double *A, *B;
  int *Ng;

  /* get the dimensions of the input matrix */
  mrows = mxGetM(prhs[0]);
  ncols = mxGetN(prhs[0]);

  /* Get the first argument */
  A = (double *)mxGetPr(prhs[0]);
  
  /*  get the scalar input FLAG */
  FLAG = mxGetScalar(prhs[1]);

  /*  get the scalar input COND */
  COND = mxGetScalar(prhs[2]);

  if (mxIsNaN(FLAG)){
    COND = -1;
  }
  
  plhs[0] = mxCreateDoubleMatrix(1 , ncols, mxREAL);
  B       = mxGetPr(plhs[0]);
  plhs[1] = mxCreateNumericMatrix(1 , ncols, mxINT32_CLASS, mxREAL);
  Ng      = (int *)mxGetPr(plhs[1]);

  /*****************************************************/
  mean_nonflag(A,FLAG,COND,mrows,ncols,B,Ng);
  /*****************************************************/

  return;

}
