#include <octave/oct.h>
#include <lo-mappers.h>
#include <libflag.h>

DEFUN_DLD (mean_nonflag_oct, args, ," ")
{

  octave_value_list retval;

  int i, j;

  /* Outputs */
  double *B;
  int *Ng;

  /* Inputs */
  double FLAG;
  int COND;
  double *A;

  /*******************************************************/
  /* Extract info from Octave function call              */
  /*******************************************************/
  //int nargin = args.length();

  Matrix   Aov(args(0).matrix_value());
  FLAG =       args(1).double_value ();
  COND = (int) args(2).double_value ();

  if (xisnan(FLAG)){
    COND = -1;
  }
  /*****************************************************/

  /*******************************************************/
  /* Form outputs                                        */
  /*******************************************************/
  int mrows  = Aov.rows();
  int ncols  = Aov.cols();

  RowVector Bov(ncols);
  RowVector Ngov(ncols);

  A  = (double *)malloc(mrows*ncols*sizeof(double));
  B  = (double *)malloc(ncols*sizeof(double));
  Ng = (int *)malloc(ncols*sizeof(int));

  /*******************************************************/

  /* Need to eliminate this step               */
  /* Transform input matrix to a plain c array */
  for (j = 0; j < ncols ; j++){
    for (i = 0; i < mrows ; i++){
      A[i + mrows*j]  = Aov(i,j);
    }
  }  

  /*****************************************************/
  mean_nonflag(A,FLAG,COND,mrows,ncols,B,Ng);
  /*****************************************************/

  /* Need to eliminate this step                 */
  /* Transform output matrix to an Octave matrix */
  for (j = 0; j < ncols ; j++){
    Bov(j)  = B[j];
    Ngov(j) = Ng[j];
  }

  free(A);
  free(B);
  free(Ng);

  retval(0) = Bov;
  retval(1) = Ngov;
  return retval;

}

