#include <octave/oct.h>
#include <lo-mappers.h>
#include <libflag.h>

DEFUN_DLD (moving_mean_nonflag_oct, args, ," ")
{
  octave_value_list retval;

  int i, j;

  /* Outputs */
  double *B;
  int *Ng;

  /* Inputs */
  double FLAG;
  int COND;
  int N;
  double *A;

  /*******************************************************/
  /* Extract info from Octave function call              */
  /*******************************************************/
  //int nargin = args.length();

  Matrix   Aov(args(0).matrix_value());
  N    = (int) args(1).double_value ();
  FLAG =       args(2).double_value ();
  COND = (int) args(3).double_value ();

  if (xisnan(FLAG)){
    COND = -1;
  }
  /*****************************************************/

  /*******************************************************/
  /* Form outputs                                        */
  /*******************************************************/
  int mrows  = Aov.rows();
  int ncols  = Aov.cols();

  Matrix Ngov(mrows,ncols);

  A    = (double *)malloc(mrows*ncols*sizeof(double));
  B    = (double *)malloc(mrows*ncols*sizeof(double));
  Ng   = (int *)malloc(mrows*ncols*sizeof(int));

  /*******************************************************/

  /* Need to eliminate this step               */
  /* Transform input matrix to a plain c array */
  for (j = 0; j < ncols ; j++){
    for (i = 0; i < mrows ; i++) {
      A[i + mrows*j]  = Aov(i,j);
    }
  }

  /*******************************************************/
  /* Call function from flaglib                          */
  /*******************************************************/
  moving_mean_nonflag(A,FLAG,COND,mrows,ncols,N,B,Ng);
  /*****************************************************/

  /* Need to eliminate this step                 */
  /* Transform output matrix to an Octave matrix */
  for (j = 0; j < ncols ; j++){
    for (i = 0; i < mrows ; i++) {
      Aov(i,j)  = B[i + mrows*j];
      Ngov(i,j) = Ng[i + mrows*j];
    }
  }

  free(A);
  free(B);
  free(Ng);

  retval(0) = Aov;
  retval(1) = Ngov;
  return retval;


}

