#include "mex.h"
#include "libname.h"

void mexFunction(int nlhs, mxArray *plhs[],
                 int nrhs, const mxArray *prhs[])
{
  
  int libname_error;

  int i, j;
  int debug;
  int verbosity;

  double *Bm; /* m -> matrix */
  double *Am;
  int ncols_Am, mrows_Am;

  double *Bv; /* v -> vector */
  double *Av;
  int mrows_Av;

  /* Treat all numeric inputs as arrays and convert as needed */
  double *Bs; /* s -> scalar */
  double *As;
  double *Ai1,*Ai2; /* i -> int */

  /* get the dimensions of the inputs */
  mrows_Am = mxGetM(prhs[0]);
  ncols_Am = mxGetN(prhs[0]);
  mrows_Av = mxGetM(prhs[1]);

  Am = (double *)mxGetPr(prhs[0]);
  Av = (double *)mxGetPr(prhs[1]);
  As = (double *)mxGetPr(prhs[2]);

  Ai1   = (double *)mxGetPr(prhs[3]);
  debug = (int) Ai1[0];

  Ai2       = (double *)mxGetPr(prhs[4]);
  verbosity = (int) Ai2[0];
  
  plhs[0] = mxCreateDoubleMatrix(mrows_Am , ncols_Am, mxREAL);
  Bm      = mxGetPr(plhs[0]);

  plhs[1] = mxCreateDoubleMatrix(mrows_Av , 1, mxREAL);
  Bv      = mxGetPr(plhs[1]);

  plhs[2] = mxCreateDoubleMatrix(1 , 1, mxREAL);
  Bs      = mxGetPr(plhs[2]);

  if ( (debug == 1) || (verbosity > 0) ) {
    for (i=0;i<mrows_Am;i++) {
      for (j=0;j<ncols_Am;j++) {
	printf("Am[%d][%d]=%f ",i,j,Am[i+ncols_Am*j]);
      }
      printf("\n");
    }
  }

  libname_error = libname_functionname(Am, ncols_Am, mrows_Am,
				       Av, mrows_Av, 
				       As,
				       Bm, Bv, Bv);

  return;

}
