function po = checkpath(p,who_called)

## Determine if a directory is fit to be added or removed from path.
## Only called by xaddpath.

if (nargin<2)
  who_called = 'checkpath';
end

if (p(end) != ":")
  p = [p,':'];
end
if (p(1) != ":")
  p = [':',p];
end

if length(p)>4
  if (p(end-2:end-1)=="//") && (warn_matlab_incompatible == 1)
    warning ("%s: Adding a path with trailing double slashes is not Matlab compatable", who_called );
  end
end

po = '';
I = find(p==":");
for j = 2:length(I)

  pc = p(I(j-1)+1:I(j)-1);

  [s, err, m] = stat (pc);
  if (err != 0)
    warning("%s: Problem directory %s. stat('%s') returns: %s",...
             who_called, pc, pc, m);
    ret = 0;
    continue;
  elseif (index (s.modestr, "d") != 1)
    warning("%s: %s is not a directory (mode=%s)", who_called, pc, s.modestr);
    ret = 0;
    continue;
  elseif (! (s.modestr(8) == "r"
    || (getgid == s.gid && s.modestr(5) == "r")
    || (getuid == s.uid && s.modestr(2) == "r")))
    warning ("%s: %s is not readable (mode=%s)", who_called, s.modestr);
    ret = 0;
  else
    po = [po,':',pc];
  endif

end

po = po(2:end);