%NONFLAG_DEMO 
% Demo of MAX_,MIN_,ARV_,MSE_,MEAN_,STD_,BLOCK_DETREND_,
% and BLOCK_MEAN_NONFLAG fns.
%
%   NONFLAG_DEMO executes several tests on the _NONFLAG functions.
% 
%   See also MEAN_NONFLAG_DEMO, UNSCALE_DEMO, DIFF_NONFLAG_DEMO.


fprintf('Test 1\n');fflush(stdout);
for i = 1:2

  if (i == 2),FLAG = 999.0;,end;
  if (i == 1),FLAG = NaN;,end;
  
  D    = [1 2 FLAG 3 4 FLAG FLAG 5 6 FLAG 7 8 9 10]';  
  Z    = zeros(size(D));
  Do   = [1:10]';
  Zo   = zeros(size(Do));

  % Note max_nonflag, min_nonflag, mean_nonflag, and std_nonflag, do not
  % have the same syntax as Octave or Matlab max, min, and std functions.
  % The demos below are compatable with these Octave and Matlab functions,
  % however

  T(1) = max_nonflag(D,1,FLAG)  - max(Do);
  T(2) = min_nonflag(D,1,FLAG)  - min(Do);
  T(3) = arv_nonflag(D,Z,FLAG)  - arv(Do,Zo);
  T(4) = mse_nonflag(D,Z,FLAG)  - mse(Do,Zo);
  T(5) = mean_nonflag(D,1,FLAG) - mean(Do);
  T(6) = std_nonflag(D,1,FLAG) - std(Do);
  I = find(T~=0);
  if ~isempty(I)
    error('Found error in _nonflag function');
  else
    fprintf('Test 1.%d OK.\n',i);fflush(stdout);
  end
end

input('Continue?');

fprintf('\nTest 2\n');fflush(stdout);
D
fprintf('Dreflag  = reflag(D,FLAG,-FLAG);\n');
Dreflag  = reflag(D,FLAG,-FLAG);
Dreflag

input('Continue?');

fprintf('\nTest 3\n');fflush(stdout);
Do
fprintf('Doreflag   = reflag(Do,FLAG,-FLAG);\n');
Doreflag   = reflag(Do,FLAG,-FLAG);
Doreflag

input('Continue?');

fprintf('\nTest 4\n');fflush(stdout);
D(1) = -1;
D
fprintf('rectify_nonflag(D,FLAG)\n');
rectify_nonflag(D,FLAG)

input('Continue?');

fprintf('\nTest 5\n');fflush(stdout);
Do
fprintf('Do_dt = block_detrend(Do,3);\n');
Do_dt = block_detrend(Do,3);
Do_dt

input('Continue?');

fprintf('\nTest 6\n');fflush(stdout);
D
fprintf('D_dt = block_detrend_nonflag(D,3,FLAG);\n');
D_dt = block_detrend_nonflag(D,3,FLAG);
D_dt

input('Continue?');

fprintf('\nTest 7\n');fflush(stdout);
Do
fprintf('Do_dt = block_mean(Do,3);\n');
Do_dt = block_mean(Do,3);
Do_dt

input('Continue?');

fprintf('\nTest 8\n');fflush(stdout);
D
fprintf('D_dt  = block_mean_nonflag(D,3,FLAG);\n');
D_dt  = block_mean_nonflag(D,3,FLAG)
D_dt

