function [TEXTc,K] = findstr_keep(TEXTc,pattern)
%FINDSTR_REMOVE Keep elements of cell array that have a given string
%
%   [STRc,K] = FINDSTR_REMOVE(STRcell,string) returns STRcell(K). 
%
%   See also FINDSTR.

if ~iscell(pattern)
  pattern_cell{1}=pattern;
else
  pattern_cell=pattern;
end

K = [];
TEXTv = strvcat(1,TEXTc{:})';
Nc    = size(TEXTv,1);
TEXTv = TEXTv(:)';
for i = 1:length(pattern_cell)
  Ktmp = findstr(TEXTv,pattern_cell{i});
  if (~isempty(Ktmp))
    K = [K,floor(Ktmp/Nc)];
  end
end

K = setdiff([1:length(TEXTc)],unique(K));
TEXTc = TEXTc(K);


