%REMOVE_LINES_DEMO Demo of REMOVE_LINES.

more on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Remove this lines from perlop_demo.dat and
% write resulting file in perlop_demo.dat_modified.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
LINES = [1:5,7,8]; 

remove_lines('perlop_demo.dat',LINES);

type perlop_demo.dat_modified

if (isunix)
  eval(sprintf('!rm perlop_demo.dat_modified'));  
else
  eval(sprintf('!del "perlop_demo.dat_modified"'));  
end

fprintf('\n\n\n____________________________________________________\n\n\n');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Use PERLOP to remove lines that contain an IP address
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Regular expression for lines that have IP address. The !~ grabs 
% lines that do not match the REGEXP.  
% The [0-9]+ matches an integer with or any length.  The \. is
% pattern for a period (The . is a special character in Perl, so it must be
% escaped to become literal.)

REGEXP = '!~ m/[0-9]+\.[0-9]+\.[0-9]+\.[0-9]/';
[I,A]  = perlop('perlop_demo.dat',REGEXP,[],[],'file');
A

fprintf('\n\n\n____________________________________________________\n\n\n');

% Alternatively, we can remove lines that contain an IP address by
% finding lines that have an IP address with PERLOP and then removing
% them with REMOVE_LINES.  The former method is faster, however.

REGEXP = '=~ m/[0-9]+\.[0-9]+\.[0-9]+\.[0-9]/';
I      = perlop('perlop_demo.dat',REGEXP,[],[],'file');

remove_lines('perlop_demo.dat',I)

type perlop_demo.dat_modified

if (isunix)
  eval(sprintf('!rm perlop_demo.dat_modified'));  
else
  eval(sprintf('!del "perlop_demo.dat_modified"'));  
end

more off