function gunzip(FILENAME,PATH)
%GUNZIP Use gzip to uncompress file
% 
%   GUNZIP(FILE)
% 
%   Assumes gunzip is invoked with /usr/bin/gzip -d if OS is Unix.
%   Assumes gunzip is invoked with /usr/bin/gzip -d if OS is Windows.
%
%   GUNZIP(FILE,GUNZIP_COMMAND) uses gunzip command GUNZIP_COMMAND.
%
%   See also GZIP.

% R.S. Weigel, December 22, 2003.

if (isunix)  
  if (nargin > 1)
    comstr = PATH;    
  else
    comstr = '/usr/bin/gzip';
  end
  com = sprintf('%s -d %s\n',comstr,FILENAME);
  system(com);
else
  if (nargin > 1)
    comstr = PATH;    
  else
    fs = '\\'; % Avoid octave warning
    comstr = ['.',fs(1),'gzip.exe'];
  end
  com = sprintf('"%s" -d "%s"\n',comstr,FILENAME);
  system(com);
end
