#include "mex.h"
#include "libsp.h"

void mexFunction(int nlhs, mxArray *plhs[],
                 int nrhs, const mxArray *prhs[])
{

  int i,j;  
  int libsp_error;

  double *Bo;

  double *xo;
  int mrows_xo, ncols_xo;

  double *IdL;
  int mrows_IdL,ncols_IdL;

  double *x;
  double *tmp;
  int coordsys;

  /* get the dimensions of the inputs */
  mrows_IdL = mxGetM(prhs[1]);
  ncols_IdL = mxGetN(prhs[1]);
  mrows_xo = mxGetM(prhs[2]);
  ncols_xo = mxGetN(prhs[2]);

  /*printf("mrows_xo=%d ncols_xo=%d\n",mrows_xo,ncols_xo);*/

  x   = (double *)mxGetPr(prhs[0]);
  IdL = (double *)mxGetPr(prhs[1]);
  xo  = (double *)mxGetPr(prhs[2]);

  tmp  = (double *)mxGetPr(prhs[3]);
  coordsys = (int) tmp[0];

  plhs[0] = mxCreateDoubleMatrix(mrows_xo , ncols_xo, mxREAL);
  Bo      = mxGetPr(plhs[0]);

  libsp_error = libsp_biot_savart(x, 
				  IdL, ncols_IdL, 
				  xo, ncols_xo, 
				  Bo, coordsys);
  return;

}
