coordsys = 1;
n = 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Wire loop of radius 1 in the x-y plane with center at the origin.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ns = 100;                         % Number of segments
b  = 1;                          % Wire radius
Io = 1;                          % Current in wire
xo = [0 0 0];                    % Observation point

x      = zeros(Ns,3);
th     = 2*pi*([0:Ns-1]')/Ns;
x(:,1) = cos(th);
x(:,2) = sin(th);

[L,dL] = arc_length(x); 
IodL   = Io.*dL;

Bd    = biot_savart(x,IodL,xo);    % Discrete solution
Bc(3) = B_ring(xo(3),b,Io);      % Continuous solution

Error_test = 1-Bd(3)/Bc(3);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if (~exist('biot_savart_test.mat'))
  Error = Error_test;
  save biot_savart_test.mat
else
  load biot_savart_test.mat
  if ( Error > 1e-2 )
    error('biot_savart_test: Test 1 failed.\n');
  else
    fprintf('biot_savart_test: Test 1 passed.\n');
  end
end

