/* libsp.h  uses header file that works for both C and C++ */

/* note that this works in both C and C++ because:
          1)  only C style comments are used
          2)  name mangling is turned off using  extern "C" { ... }
              in  #ifdef  --cplusplus   <-- a special name
          3)  good practice is used to be sure included just once
*/

#ifndef LIBSP_H_   /* to only include once */
#define LIBSP_H_   /* to only include once */

#ifdef __cplusplus    /* make it C if in C++ compiler */
  extern "C" {
#endif

/* Put other C header files here e.g., */
/* #include <time.h>                   */

int libsp_biot_savart(double *x,
		      double *IdL, int ncols_IdL,
		      double *xo, int ncols_xo,
		      double *Bo, int coordsys);
                            
#ifdef __cplusplus  /* closing } for C in C++ compiler  */
  }
#endif

#endif  /* LIBSP_H_  to only include once */


