clear

% Tube, current in z direction.

rh = 1.0;
tol = 1e-5;
trace = 0;

dt   = 0.05;
dy   = 0.05;

ymax = 200;
ymin = -ymax;
xo   = [0.05:0.3:0.95];
xo   = [xo,2,4,8,16];

for j = 1:length(xo)

Xo   = [xo(j) 0 0];

th = 2*pi*[0.0:dt:1-dt];
io = 1/length(th);

for i = 1:length(th)
  
  %% Segment 2
  y  = [-ymax:dy:ymax]';
  Ny = length(y);
  x  = rh*cos(th(i))*ones(Ny,1);
  z  = rh*sin(th(i))*ones(Ny,1);
  X  = [x,y,z];
  
  [L,dL] = arc_length(X);
  
  IdL = io*dL;
  B2(i,:) = biot_savart(X,IdL,Xo);

  L = L-L(1);
%  Bq(i) = quad8('dB',L(1),L(end),tol,trace,L,dL,X,Xo);

end

S(j,:)  = sum(B2);
%Sq(j,:) = sum(Bq);
fprintf('j = %d/%d\b\b\b\b\b\b\b\b\b\b',j,length(xo));
end

S(end,3)
clf
plot(xo,log10(abs(S(:,3)))); hold on;
%plot(xo,log10(abs(Sq)),'r')

