clear

show_plot=1;

rh_o = 1.0;
dt   = 0.1;
dx   = 0.1;
dy   = 0.1;
rmax = 100;
ymax = 0.5;
ymin = -0.5;
xo   = [0.1:0.1:0.95];
xo   = [xo,2,4,8,16];
s    = 0.0; % Slope of lines in and out.

rho = [1:dx:rmax]';
th  = 2*pi*[0.0:dt:1-dt];
Nth = length(th);
io = 1/length(th);

if (show_plot)
  clf;
  subplot(1,2,1);
end

for j = 1:length(xo)

Xo   = [xo(j) 0 0];

for i = 1:Nth

  %% Segment 1
  x  = rh_o*cos(th(i))*rho;
  Nx = length(x);
  z  = rh_o*sin(th(i))*rho;
  y  = -s*rho+s*rho(1) - 0.5;
  X  = [x,y,z];
  
  if (show_plot)
  plot3(x,y,z,'r.','LineWidth',3);hold on;grid on;
  xlabel('x');ylabel('y');zlabel('z')
  end

  [L,dL] = arc_length(X);
  
  IdL = -io*dL;
  B1(i,:) = biot_savart(X,IdL,Xo);
  
  %% Segment 2
  y  = [-ymax:dy:ymax]';
  Ny = length(y);
  x  = rh_o*cos(th(i))*ones(Ny,1);
  z  = rh_o*sin(th(i))*ones(Ny,1);
  X  = [x,y,z];

  if (show_plot)
  plot3(x,y,z,'g','LineWidth',3);hold on;
  end
  
  [L,dL] = arc_length(X);
  
  IdL = io*dL;
  B2(i,:) = biot_savart(X,IdL,Xo);

  %% Segment 3
  x  = rh_o*cos(th(i))*rho;
  Nx = length(x);
  z  = rh_o*sin(th(i))*rho;
  y  = s*rho-s*rho(1) + 0.5;
  X  = [x,y,z];

  if (show_plot)
  plot3(x,y,z,'b','LineWidth',3);hold on;
  end
  
  [L,dL] = arc_length(X);

  IdL = io*dL;
  B3(i,:) = biot_savart(X,IdL,Xo);

  
end

S1(j,:) = sum(B1);
S2(j,:) = sum(B2);
S3(j,:) = sum(B3);
S(j,:)  = sum(B1)+sum(B2)+sum(B3);

fprintf('j = %d/%d\b\b\b\b\b\b\b\b\b\b',j,length(xo));

end
fprintf('\n');

cm = 3;

if (show_plot)
  subplot(1,2,2);
  plot(xo,log10(abs(S1(:,cm))),'r','LineWidth',2);hold on;grid on;
  plot(xo,log10(abs(S2(:,cm))),'g')
  plot(xo,log10(abs(S3(:,cm))),'b')
  plot(xo,log10(abs(S(:,cm))),'k','LineWidth',2)
  xlabel('x');ylabel('log10(B) due to each set of currents');
end


