% Transform to/from systems

Nc  = 1e4;

xc  = rand(Nc,3);
xs  = transform('Cartesian','Spherical',xc);
xcc = transform('Spherical','Cartesian',xs);

Vc  = rand(Nc,3);
Vs  = transform('Cartesian','Spherical2',Vc,xc);
Vcc = transform('Spherical2','Cartesian',Vs,xs);

[ex,Iex] = max(abs(xcc-xc)); % Ratio should not be much larger than 1.
ex = ex/eps;
[eV,IeV] = max(abs(Vcc-Vc)); % Ratio should not be much larger than 1.
eV = eV/eps;

if (max(ex(:))>100)
  xc(Iex,:)
  error('transform_demo: Error in x larger than expected.');
end

if (max(eV(:))>100)
  xc(IeV,:)
  Vc(IeV,:)
  error('transform_demo: Error in V larger than expected.');
end
