function dat2mat(Dir)
%DAT2MAT Convert plain data file into matlab binary format.
%  
%   DAT2MAT(DIR) or  
%   DAT2MAT uses default value of DIR = '.'
%
%   Creates Matlab binary files *.mat out of all files named *.dat in DIR.
%   The .dat file must be uniform and space-delimited ASCII files with no
%   text.  There will be a single variable in the *.mat file named * .

% R.S. Weigel 04/07/2004.

if (nargin == 0)  
  Dir = readdir('.');
end

for i = 1:size(Dir,1)

  fname = deblank(Dir(i,:));
  L     = length(fname);
  if (L > 3)
    I = strmatch('.dat',fname(L-3:L));
  if (~isempty(I))
    fprintf('dat2mat.m is operating on %s ... ',fname);fflush(stdout);
    com1  = sprintf('%s = load(''%s'');',fname(1:L-4),fname);
    eval(com1);
    com2 =  sprintf('%s = unique(%s,''rows'');',fname(1:L-4),fname(1:L-4));
    eval(com2);
    if (is_octave)
      com3  = sprintf('save -mat-binary %s.mat %s;',fname(1:L-4),fname(1:L-4));
    else
      com3  = sprintf('save %s.mat %s;',fname(1:L-4),fname(1:L-4));      
    end
    eval(com3);
    fprintf('Done\n');fflush(stdout);
  end
  
  end
  
end
