%SLIM_MHDHDF Slim down a LFM-generated hdf file by keeping every 4th dump.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% New file is named oldfilename-reduced.hdf.
% Needs Matlab hdf scripts.  Tested on RHEL 3.0 with Matlab 6.5.0.
% R.S. Weigel, 08/26/2004
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
% Load HDF data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
hdf_dir      = [CISM_DX_DATA_FULL_ROOT,'model_output/lfm-data/SASH-data/'];
file_old     = [hdf_dir,'Jun01-23.hdf'];
file_new     = [hdf_dir,'Jun01-23-reduced.hdf'];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get global variables and path setting
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CISM_DX_GLOBALS;
if (is_octave)
  error('Only works in Matlab.')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Info_old     = hdfinfo(file_old);

for i = 1:length(Info_old.SDS)
  Z{i}  = hdfread(Info_old.SDS(i)); 
end
k = 0;

eval(sprintf('!rm -f %s',file_new));

sd_id    = hdfsd('start',file_new,'DFACC_CREATE');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = [1,2,[3:4:43]]  
  k = k + 1;
  
  A       = Z{i};

  ds_name = sprintf('Data-Set-%d',k+1);
  ds_type = 'float32';
  ds_rank = ndims(A);
  ds_rank = 1;
  ds_dims = fliplr(size(A));
  ds_dims = ds_dims(1);
  
  sds_id  = hdfsd('create',sd_id,ds_name,ds_type,ds_rank,ds_dims);
  status  = hdfsd('setcompress',sds_id,'deflate','deflate_level',5);
  
  ds_start  = zeros(1:ndims(A)); % Start at the beginning
  ds_start  = 0;
  ds_stride = [];           % Write every element. 
  ds_edges  = ds_dims(1);   % Reverse the dimensions.

  stat      = hdfsd('writedata',sds_id ,ds_start, ds_stride, ds_edges, A);

  stat       = hdfsd('endaccess',sds_id);
  
  if (stat ~= 0)
    fprintf('HDF file problem.\n');
  end
end

stat = hdfsd('end',sd_id);
Info_new     = hdfinfo(file_new);

