
/* R.S. Weigel 11/11/2004 */

int is_flag(double x, double FLAG, int COND)
{
  
  int I = 0;

  if (COND == -1) {
    if (isnan(x) == 1)
      I = 1;
    return I;
  }
  if (COND == 0) {
    if (x >= FLAG)
      I = 1;
    return I;
  }
  if (COND == 1) {
    if (x == FLAG) 
      I = 1;
    return I;
  }
  if (COND == 2) {
    if (fabs(x) >= FLAG)
      I = 1;
    return I;
  }

  return I;

}

void mean_nonflag(double *A, double FLAG, int COND, 
		  int mrows, int ncols,
		  double *B, int *Ng)
{

  int i,j,k,ind;
  double temp;

  for (j = 0; j < ncols ; j++){

    k    = 0;
    temp = 0.0;
    
    for (i = 0; i < mrows ; i++){
      
      ind = i + j*mrows;
      
      if ( is_flag(A[ind],FLAG,COND) == 0 ) {
	temp = temp + A[ind];
	k   = k+1;
      }
      
    } /* end for (i = 0 ; ... */

    if (k == 0) {
      B[j]  = FLAG;
      Ng[j] = 0;
    }
    else {
      B[j]  = temp/k;
      Ng[j] = k;
    }
    
  } /* end for (j = 0 ; ... */

}

void moving_mean_nonflag(double *A, double FLAG, int COND, 
			 int mrows, int ncols, int N, 
			 double *B, int *Ng)
{

  int i,j,k;
  int oldx,newx;
  int Im1;

  for (j = 0; j < ncols ; j++){
      
    B[0 + j*mrows]   = 0.0;
    Ng[0 + j*mrows]  = 0;

    for (i = 0; i < N ; i++) {
      if (is_flag(A[i+j*mrows],FLAG,COND) == 0) {
	B[0 + j*mrows]  = B[0 + j*mrows] + A[i + j*mrows];
	Ng[0 + j*mrows] = Ng[0 + j*mrows] + 1;
      }
    }

    for (k = 1; k < mrows-N+1 ; k++){

      Im1   = k - 1 + j*mrows;
      newx  = is_flag(A[Im1+N],FLAG,COND);
      oldx  = is_flag(A[Im1],FLAG,COND);

      if (newx==0) {
	if (oldx==0) {
	  B[k + j*mrows]  = B[Im1] - A[Im1] + A[Im1+N];
	  Ng[k + j*mrows] = Ng[Im1];
	} else {
	  B[k + j*mrows]  = B[Im1] + A[Im1+N];
	  Ng[k + j*mrows] = Ng[Im1]+1;
	}
      }

      if (newx==1) {
	if (oldx==0) {
	  B[k + j*mrows]  = B[Im1] - A[Im1];
	  Ng[k + j*mrows] = Ng[Im1] - 1;
	  
	} else {
	  B[k + j*mrows]  = B[Im1];/* - A[Im1];*/
	  Ng[k + j*mrows] = Ng[Im1];
	}
      }
    } 
  
    if (N == mrows)
      k = 1;

    for (i = k; i < mrows ; i++){
      B[i+j*mrows]  = FLAG;
      Ng[i+j*mrows] = 0;
    }

    if (Ng[1 + j*mrows] == 0) {
      B[1 + j*mrows] = FLAG;
    }

    for (k = 0; k < mrows-(N-1) ; k++){
      if (Ng[k + j*mrows] > 0) {
	B[k + j*mrows]  = B[k + j*mrows]/Ng[k + j*mrows];
      } else {
	B[k + j*mrows]  = FLAG;      
      }
    }


  }

  return;

}
