%startup;

CISM_DX_DATA_FULL_ROOT = '/home/cism/weigel/Programs/CISM_DX_DATA-Full/';

thedatadir    = [CISM_DX_DATA_FULL_ROOT,...
		 'measurements/uniform_time_series/matfiles/Ground_Magnetometers/'];
directory_fmi = sprintf('%sFMI',thedatadir);
directory_dmi = sprintf('%sDMI',thedatadir);
directory_spi = sprintf('%sSPIDR',thedatadir);

% This is the master list of all data

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MAGLIST_SPI  = ['mcq ';'tik1'];
YEARS_SPI    = [1993 2001; 1976 2000];
COORDSYS_SPI = ['XYZ';'HDZ'];
FLAG_SPI     = repmat(99999,size(MAGLIST_SPI,1),3);
SOURCE_SPI   = 'http://spidr.ngdc.noaa.gov';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MAGLIST_FMI = ['and ';'abk ';'bjn ';'dob ';'han ';...
	       'hop ';'hor ';'iva ';'kev ';'kil ';...
	       'kir ';'loz ';'lek ';'lyr ';'lyc ';...
	       'mas ';'muo ';'nal ';'nur ';'ouj ';...
	       'pel ';'rvk ';'sod ';'sor ';'tro ';...
	       'tar ';'ups '];

YEARS_FMI    = repmat([1995 2002],size(MAGLIST_FMI,1),1);
COORDSYS_FMI = repmat(['XYZ'],size(MAGLIST_FMI,1),1);
FLAG_FMI     = repmat(99999,size(MAGLIST_FMI,1),3);
SOURCE_FMI   = 'http://www.geo.fmi.fi/image';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MAGLIST_DMI = ['her ';'hon ';'bou ';'ott ';'kak ';...
	       'stj ';'sjg ';'paf ';'drv ';'dvs ';...
	       'csy ';'maw ';'mea ';'mbc ';'res ';...
	       'blc ';'lrv ';'pbq ';'brw ';'sod ';...
	       'cmo ';'ykc ';'bjn ';'had1';'had2';...
	       'gdh1';'gdh2';'naq1';'naq2';'ngk1';...
	       'ngk2';'abk ';'thl1';'thl2';'fcc '];

% These flags were computed by visual inspection using mag_data_re_flag.m
% These flags were replaced with 99999 using mag_data_re_flag.m

if (0) % Old flags
FLAG_DMI(:,1) = [99999     ; 99999     ; 99999     ; 99999     ; 99999    ;...
		 49999     ; 49999     ; 99999     ; 99999     ; 99999    ;...
		 99999     ; 99999     ; 29999     ; 7999      ; 4999     ;...
		 39999     ; 69999     ; 59999     ; 29999     ; 79999    ;...
		 89999     ; 69999     ; 49999     ; 99999     ; 99999 ;...
		 59999     ; 59999     ; 99999     ; 99999     ; 99999 ;...
		 99999     ; 99999     ; 19999     ; 9999      ; 59999 ];

FLAG_DMI(:,2) = [99999     ; 49999     ; 49999     ; 99999     ; 99999    ;...
		 49999     ;   599     ; 99999     ; 99999     ; 99999    ;...
		 99999     ; 99999     ; 29999     ; 7999      ; 4999     ;...
		 39999     ; 69999     ; 59999     ; 29999     ; 79999    ;...
		 99999     ; 19999     ; 49999     ; 99999     ; 99999 ;...
		 99999     ; 99999     ; 99999     ; 99999     ; 99999 ;...
		 99999     ; 99999     ; 99999     ; 99999     ; 99999 ];
		 
FLAG_DMI(:,3) = [99999     ; 99999     ; 99999     ; 99999     ; 99999    ;...
		 59999     ; 49999     ; 99999     ; 99999     ; 99999    ;...
		 99999     ; 99999     ; 29999     ; 7999      ; 4999     ;...
		 39999     ; 69999     ; 59999     ; 29999     ; 79999    ;...
		 99999     ; 89999     ; 49999     ; 99999     ; 99999 ;...
		 99999     ; 99999     ; 99999     ; 99999     ; 99999 ;...
		 99999     ; 99999     ; 99999     ; 99999     ; 99999 ];
end

FLAG_DMI   = repmat(99999,size(MAGLIST_DMI,1),3);
YEARS_DMI  = [1975 2000 ; 1984 2001 ; 1980 2001 ; 1982 2000 ; 1977 2001 ;...
	      1978 2001 ; 1983 2001 ; 1969 2001 ; 1969 2001 ; 1989 1995 ;...
	      1989 2002 ; 1991 2002 ; 1975 2001 ; 1981 1996 ; 1978 2001 ;...
	      1980 2001 ; 1989 2002 ; 1985 2000 ; 1976 2001 ; 1980 2001 ;...
	      1990 2001 ; 1983 2001 ; 1992 2002 ; 1990 1999 ; 2000 2001 ;...
	      1982 1995 ; 1996 2001 ; 1983 1995 ; 1996 2001 ; 1995 2000 ;... 
	      2001 2001 ; 1982 2001 ; 1975 1995 ; 1996 2001 ; 1983 2001 ];
	      

COORDSYS_DMI = ['HDZ'     ; 'HDZ'     ; 'HDZ'     ; 'XYZ'     ; 'HDZ'   ;...
		'XYZ'     ; 'HDZ'     ; 'XYZ'     ; 'XYZ'     ; 'XYZ'   ;...
		'XYZ'     ; 'XYZ'     ; 'XYZ'     ; 'XYZ'     ; 'XYZ'   ;...
		'XYZ'     ; 'HDZ'     ; 'XYZ'     ; 'HDZ'     ; 'XYZ'   ;...	       
		'HDZ'     ; 'XYZ'     ; 'HDZ'     ; 'HDZ'     ; 'XYZ'   ;...
		'HDZ'     ; 'XYZ'     ; 'HDZ'     ; 'XYZ'     ; 'HDZ'   ;...
		'XYZ'     ; 'XYZ'     ; 'HDZ'     ; 'XYZ'     ; 'XYZ'   ];

SOURCE_DMI = 'http://web.dmi.dk/projects/wdcc1/';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MAGLIST_JGR = ['ABK';'BJN';'HAN';...
	       'HOP';'HOR';'KIR';...
	       'LYR';'NAL';'NUR';...
	       'OUJ';'SOD';'SOR'];

YEARS_JGR    = repmat([1998 2000],size(MAGLIST_JGR,1),1);
COORDSYS_JGR = repmat(['XYZ'],size(MAGLIST_JGR,1),1);
FLAG_JGR     = repmat(99999,size(MAGLIST_JGR,1),3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

