clear
addpath('../../');startup;
mag_data_info;

YEARS        = YEARS_JGR;
MAGLIST      = MAGLIST_JGR;
I            = [1:5,7:12];  % Remove KIR data
MAGLIST      = MAGLIST_JGR(I,:);
YEARS        = YEARS_JGR(I,:);

COORDS_CGM   = station_name2geomagnetic(MAGLIST);
CGM_LAT      = 90-COORDS_CGM(:,1); % Change to CGM latitude from CGM colatitude.

[CGM_LAT,I]  = sort(CGM_LAT);
MAGLIST      = MAGLIST(I,:);
YEARS        = YEARS(I,:);
years        = [1995:2002];

COMP         = 'X';
TAG          = 'All';k = 1;

SEASON_NAME  = {'All Data','Spring','Summer','Fall','Winter'};

%prep_mlt_colat
eval(sprintf('load /tmp/TEMP_DOY_%s_%s',COMP,TAG));

for plot_type = 1:2
  setpos;orient tall;j=0;
  for season = [1,79,166,264,356]
    
    j = j+1;
    
    % Set limits on colorbars
    if (plot_type == 1 | j == 1)
      zlims   = [-120 120];
      Nb      = 8; % Number of segments in colorbar
    else
      zlims   = [-60 60];
      Nb      = 8; % Number of segments in colorbar
    end
    
    % Average over second dimension which is DOY
    xm_all = squeeze(mean(Xm,2));
    xm     = squeeze(Xm(:,season,:));
    xm     = xm - repmat(mean(xm_all),size(xm,1),1);    

    if (plot_type == 1 & j == 1)
      AMPSTR  = sprintf('{\\fontsize{18} %s}',COMP);
    end
    if (plot_type == 2)
      if (j == 1)
	AMPSTR  = sprintf('{\\fontsize{18} %s}',COMP);      
      else
	AMPSTR  = sprintf('{\\fontsize{18} \\delta %s}',COMP);
      end
    end

    % Plot difference from ...
    if (plot_type == 2)
      xm      = xm - repmat(mean(xm),size(xm,1),1);
      xm      = xm - (xm_all - repmat(mean(xm_all),size(xm,1),1));
    end

    % Plot difference of all data from average over MLT
    if (j == 1)
      xm = xm_all - repmat(mean(xm_all),size(xm,1),1);
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Plot mean X
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if j > 1
      subplot(3,2,j+1)
    else
      subplot(3,2,j)
    end

    UT         = 24*[0:size(xm,1)-1]/(size(xm,1)-1);
    UT         = repmat(UT,size(MAGLIST,1),1);
    %MLT        = UT;
    MLT        = ut2mlt(UT,MAGLIST);
    
    %[th,r]     = meshgrid( (MLT/24.0)*2*pi , CGM_LAT );

    r          = repmat(CGM_LAT,1,size(MLT,2));
    th         = (MLT/24.0)*2*pi;

    rp         = [r(1,:)];
    thp        = [th(end,:)];
    [Xp,Yp]    = pol2cart(thp-pi/2,rp);
    
    r          = [-2+r(1,:) ; -1+r(1,:) ; r];
    th         = [th ; th(end,:) ; th(end,:)];
    [X,Y]      = pol2cart(th-pi/2,r);

    xmo        = [zlims(1)*ones(size(xm,1),1),zlims(2)*ones(size(xm,1),1),xm];

    [cl1,h1]   = contourf(X,Y,xmo',Nb-1);hold on;
    hc         = colorbarf2(cl1,h1,'vert',xmo',zlims(1,:));    

                 patch(Xp,Yp,'k');
    
    hh         = plot(0,CGM_LAT,'w.','MarkerSize',15);
    hh         = plot(0,.99*CGM_LAT(end),'w.','MarkerSize',15); % Cheat so last pt. shows

                 axis square;
		 axis off;
		 spokes;
		 set(get(gca,'xlabel'),'visible','on');
		 set(get(gca,'ylabel'),'visible','on');
		 text(22,38,AMPSTR);
		 text(-39,38,sprintf('{\\fontsize{18} %s}',SEASON_NAME{j}));
		 drawnow;

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
if (plot_type == 1)
  eps_write(sprintf('plot_mlt_colat'));
else
  eps_write(sprintf('plot_mlt_colat_diff'));
end
%colormap(flipud(hot));  % Colors that copy to black and white properly.
%if (plot_type == 1)
%  eps_write(sprintf('plot_mlt_colat_bw'));
%else
%  eps_write(sprintf('plot_mlt_colat_diff_bw'));
%end
colormap('default');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    input('Continue?');
end




