clear
addpath('../../');startup;
mag_data_info;

YEARS        = YEARS_JGR;
MAGLIST      = MAGLIST_JGR;
I            = [1:5,7:12];  % Remove KIR data
MAGLIST      = MAGLIST_JGR(I,:);
YEARS        = YEARS_JGR(I,:);

COORDS_CGM   = station_name2geomagnetic(MAGLIST);
CGM_LAT      = 90-COORDS_CGM(:,1); % Change to CGM latitude from CGM colatitude.

[CGM_LAT,I]  = sort(CGM_LAT);
MAGLIST      = MAGLIST(I,:);
YEARS        = YEARS(I,:);
years        = [1995:2002];

COMP         = 'X';

SEASON_NAME  = {'All Data','','',...
		'Spring By','By-','By+',...
		'Summer By','By-','By+',...
		'Fall By','By-','By+',...
		'Winter By','By-','By+'};
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ns         = 24*number_days(1963,1994)+1;
data_dir = '/home/cism/weigel/Programs/CISM_DX_DATA-Full/measurements/uniform_time_series';
load(sprintf('%s/matfiles/OMNIWeb_B_V_Np_1_hour_1963_2002.mat',data_dir));
SW         = X(Ns:end,:);

I3b        = find(SW(:,3) == FLAG);
I4b        = find(SW(:,4) == FLAG);

SW(:,8)    = rectify(-SW(:,3)).*SW(:,4)/1000;
SW(I3b,8)  = FLAG;
SW(I4b,8)  = FLAG;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
TAG_c = {'All','By-','By+','By'};

if (0)
for k = 1:4

  TAG = TAG_c{k};
  if (strmatch('All',TAG))
    H_remove = [];
  end

  if (strmatch('By',TAG))
    Ll(:,8)   = [-100   1.0  1.0 1.0]';
    Lh(:,8)   = [ 100   4.0  4.0 4.0]';
    Ll(:,2)   = [-100  -2.0  0.0 -1.0]';
    Lh(:,2)   = [ 100   0.0  2.0  1.0]';
    
    H_remove  = find( SW(:,8) > Lh(k,8) | SW(:,8) < Ll(k,2) | ...
		      SW(:,2)  > Lh(k,8)  | SW(:,2) < Ll(k,2) ); % Hours to exclude
  end		      
  prep_mlt_colat;
end
end

TAG  = 'All';
eval(sprintf('load /tmp/TEMP_DOY_%s_%s',COMP,TAG));
Xm_c{1,1} = Xm;clear Xm;
Xm_c{1,1} = dXm;clear dXm;
TAG  = 'By';
eval(sprintf('load /tmp/TEMP_DOY_%s_%s',COMP,TAG));
Xm_c{2,1} = Xm;clear Xm;
Xm_c{2,1} = dXm;clear dXm;
TAG  = 'By-';
eval(sprintf('load /tmp/TEMP_DOY_%s_%s',COMP,TAG));
Xm_c{3,1} = Xm;clear Xm;
Xm_c{3,1} = dXm;clear dXm;
TAG  = 'By+';
eval(sprintf('load /tmp/TEMP_DOY_%s_%s',COMP,TAG));
Xm_c{4,1} = Xm;clear Xm;
Xm_c{4,1} = dXm;clear dXm;

close all;
for plot_type = 1:2
  figure;setpos;orient tall;j=0;
  for season = [1,79,166,264,356]
    for by     = 2:4
      Xm  = Xm_c{by,1};
      Xmo = Xm_c{2,1};
      j   = j+1;
    
    % Set limits on colorbars
    if (plot_type == 1 | j == 1)
      zlims   = [-120 120];
      zlims   = [0 10];
      Nb      = 8; % Number of segments in colorbar
    else
      zlims   = [-20 20];
      zlims   = [-2 2];
      Nb      = 8; % Number of segments in colorbar
    end

    % Average over second dimension which is DOY
    xm_all = squeeze(mean(Xm,2));
    xm     = squeeze(Xm(:,season,:));
    %xm     = xm - repmat(mean(xm_all),size(xm,1),1);    

    % Plot difference of data on given DOY from average over MLT
    if (plot_type == 1 & j == 1)
      AMPSTR  = sprintf('{\\fontsize{18} %s}',COMP);
    end
    if (plot_type == 2)
      if (j == 1)
	AMPSTR  = sprintf('{\\fontsize{18} %s}',COMP);      
      else
	AMPSTR  = sprintf('{\\fontsize{18} \\delta %s}',COMP);
      end
    end
    % Plot difference from ...
    if (plot_type == 2)
      xm_ref  = squeeze(mean(Xmo(:,season,:),2));
      xm      = squeeze(Xm(:,season,:));
      xm      = xm - repmat(mean(xm),size(xm,1),1);
      xm      = xm - (xm_ref - repmat(mean(xm_ref),size(xm,1),1));
    end

    % Plot difference of all data from average over MLT
    if (j == 1)
      %xm = xm_all - repmat(mean(xm_all),size(xm,1),1);
      xm = xm_all;
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Plot mean X
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if (j == 1 | j > 3)
    subplot(5,3,j)

    UT         = 24*[0:size(xm,1)-1]/(size(xm,1)-1);
    UT         = repmat(UT,size(MAGLIST,1),1);
    %MLT        = UT;
    MLT        = ut2mlt(UT,MAGLIST);
    
    %[th,r]     = meshgrid( (MLT/24.0)*2*pi , CGM_LAT );

    r          = repmat(CGM_LAT,1,size(MLT,2));
    th         = (MLT/24.0)*2*pi;

    rp         = [r(1,:)];
    thp        = [th(end,:)];
    [Xp,Yp]    = pol2cart(thp-pi/2,rp);
    
    r          = [-2+r(1,:) ; -1+r(1,:) ; r];
    th         = [th ; th(end,:) ; th(end,:)];
    [X,Y]      = pol2cart(th-pi/2,r);

    xmo        = [zlims(1)*ones(size(xm,1),1),zlims(2)*ones(size(xm,1),1),xm];

    [cl1,h1]   = contourf(X,Y,xmo',Nb-1);hold on;

    %if (j == 1 & plot_type == 1)
      hc         = colorbarf2(cl1,h1,'vert',xmo',zlims(1,:));    
    %end
    %if (plot_type == 2)
    %end
                 patch(Xp,Yp,'k');
    
    hh         = plot(0,CGM_LAT,'w.','MarkerSize',15);
    hh         = plot(0,.99*CGM_LAT(end),'w.','MarkerSize',15); % Cheat so last pt. shows

                 axis square;
		 axis off;
		 spokes;
		 set(get(gca,'xlabel'),'visible','on');
		 set(get(gca,'ylabel'),'visible','on');
		 text(22,38,AMPSTR);
		 text(-39,40,sprintf('{\\fontsize{12} %s}',SEASON_NAME{j}));
		 drawnow;
		 
    end
    end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
if (plot_type == 1)
  eps_write(sprintf('plot_mlt_colat_By'));
else
  eps_write(sprintf('plot_mlt_colat_diff_By'));
end
%colormap(flipud(hot));  % Colors that copy to black and white properly.
%if (plot_type == 1)
%  eps_write(sprintf('plot_mlt_colat_bw'));
%else
%  eps_write(sprintf('plot_mlt_colat_diff_bw'));
%end
colormap('default');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    input('Continue?');
end




