clear
addpath('../../');startup;
mag_data_info;

YEARS        = YEARS_JGR;
MAGLIST      = MAGLIST_JGR;
I            = [1:5,7:12];  % Remove KIR data
I            = [1:2];
MAGLIST      = MAGLIST_JGR(I,:);
YEARS        = YEARS_JGR(I,:);

COORDS_CGM   = station_name2geomagnetic(MAGLIST);
CGM_LAT      = 90-COORDS_CGM(:,1); % Change to CGM latitude from CGM colatitude.

[CGM_LAT,I]  = sort(CGM_LAT);
MAGLIST      = MAGLIST(I,:);
YEARS        = YEARS(I,:);
years        = [1995:2002];

COMP         = 'X';
TAG          = 'All';
TAG          = 'By';
SEASON_NAME  = {'All Data','Spring','Summer','Fall','Winter'};
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ns         = 24*number_days(1963,1994)+1;
data_dir = '/home/cism/weigel/Programs/CISM_DX_DATA-Full/measurements/uniform_time_series';
load(sprintf('%s/matfiles/OMNIWeb_B_V_Np_1_hour_1963_2002.mat',data_dir));
SW         = X(Ns:end,:);

I3b        = find(SW(:,3) == FLAG);
I4b        = find(SW(:,4) == FLAG);

SW(:,8)    = rectify(-SW(:,3)).*SW(:,4)/1000;
SW(I3b,8)  = FLAG;
SW(I4b,8)  = FLAG;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if (strmatch('All',TAG))
  H_remove = [];
end

if (strmatch('By',TAG))
  Ll(:,8)   = [-100   1.0  1.0 1.0]';
  Lh(:,8)   = [ 100   4.0  4.0 4.0]';
  Ll(:,2)   = [-100  -2.0  0.0 -1.0]';
  Lh(:,2)   = [ 100   0.0  2.0  1.0]';

  k         = 1;
  H_remove  = find( SW(:,8) > Lh(k,8) | SW(:,8) < Ll(k,2) | ...
		    SW(:,2)  > Lh(k,8)  | SW(:,2) < Ll(k,2) ); % Hours to exclude
end		      

%prep_mlt_colat
eval(sprintf('load /tmp/TEMP_DOY_%s_%s',COMP,TAG));

for plot_type = 1:1
  setpos;orient tall;j=0;
%  for season = [1,79,166,264,356]
  for season = [1]
    
    j = j+1;
    
    % Set limits on colorbars
    if (plot_type == 1 | j == 1)
      zlims   = [-120 120];
      Nb      = 8; % Number of segments in colorbar
    else
      zlims   = [-60 60];
      Nb      = 8; % Number of segments in colorbar
    end
    
    % Average over second dimension which is DOY
    xm_all = squeeze(mean(Xm,2));
    xm     = squeeze(Xm(:,season,:));
    xm     = xm - repmat(mean(xm_all),size(xm,1),1);    

    % Plot difference of data on given DOY from average over MLT
    if (plot_type == 1)
      AMPSTR  = sprintf('{\\fontsize{18} B_%s}',COMP);
    end

    % Plot difference from ...
    if (plot_type == 2)
      xm      = xm - repmat(mean(xm),size(xm,1),1);
      xm      = xm - (xm_all - repmat(mean(xm_all),size(xm,1),1));
      AMPSTR  = sprintf('{\\fontsize{18} \\delta B_%s}',COMP);
    end

    % Plot difference of all data from average over MLT
    if (j == 1)
      xm = xm_all - repmat(mean(xm_all),size(xm,1),1);
    end
    
    xm          = xm(:,I);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Plot mean X
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    
    [th,r]     = meshgrid(([0:size(xm,1)-1]*360/(size(xm,1)-1))*pi/180,CGM_LAT);

    rp         = [r(1,:)];
    thp        = [th(end,:)];
    [Xp,Yp]    = pol2cart(thp-pi/2,rp);
    
    r          = [-2+r(1,:) ; -1+r(1,:) ; r];
    th         = [th ; th(end,:) ; th(end,:)];
    [X,Y]      = pol2cart(th-pi/2,r);
    
    xmo        = [zlims(1)*ones(size(xm,1),1),zlims(2)*ones(size(xm,1),1),xm];

    [cl1,h1]   = contourf(X,Y,xmo',Nb-1);hold on;
    hc         = colorbarf2(cl1,h1,'vert',xmo',zlims(1,:));    

                 patch(Xp,Yp,'k');
    
    hh         = plot(0,CGM_LAT,'w.','MarkerSize',15);
    hh         = plot(0,.99*CGM_LAT(end),'w.','MarkerSize',15); % Cheat so last pt. shows

                 axis square;
		 axis off;
		 spokes;
		 set(get(gca,'xlabel'),'visible','on');
		 set(get(gca,'ylabel'),'visible','on');
		 text(22,38,AMPSTR);
		 text(-39,38,sprintf('{\\fontsize{18} %s}',SEASON_NAME{j}));
		 drawnow;

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
if (plot_type == 1)
  eps_write(sprintf('plot_mlt_colat'));
else
  eps_write(sprintf('plot_mlt_colat_diff'));
end
%colormap(flipud(hot));  % Colors that copy to black and white properly.
%if (plot_type == 1)
%  eps_write(sprintf('plot_mlt_colat_bw'));
%else
%  eps_write(sprintf('plot_mlt_colat_diff_bw'));
%end
colormap('default');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    input('Continue?');
end




