function UT = mlt2ut(MLT,Name)
%MLT2UT Convert magnetic local time (MLT) to UT.
%
%    UT = MLT2UT(MLT,Name) UT is a single column array with elements in the
%    range [0,24].
%  
%    MLT = UT + (24 - MLTMN), where MLTMN is obtained from NSSDC website.
%
%    See also UT2MLT.

MLTMN  = station_name2mltmn(Name);
MLTMN  = repmat(MLTMN,length(MLT),1);

UT      = MLTMN + MLT - 24;
UT      = mod(UT,24);
