%QUIET_DAY_DETREND_DEMO DEMO of QUIET_DAY_DETREND

YEAR = 2000;

% J is index of first day of each month;
J    = cumsum(days_per_month([1:12],YEAR));
J    = [1, 1+J(1:end-1)];                  

Nd         = number_days(YEAR); % Number of days in 2000
Q          = zeros(Nd,1);       % The quiet days vector
Q(J)       = 1;    % Make first day of each month quiet (please).
Q(J+12)    = 1;    % Make 13th day of each month quiet (please).
Q(J(2))    = 1;    % Make first day of second month quiet (please).
Q(J(2)+12) = 1;    % Make 13th day of second month quiet (please).

D          = repmat([1:24]',1,Nd); % Create 24xNd matrix
D(:,J)    = -10;                   % Set first day of each month to -10
D(:,J+12) =   0;                   % Set 13th day of each month to 0
D(:,J(2)) = -20;                   % Set first day of second month to -20
D(:,J+12) =   0;                   % Set 13th day of second month to 0
D         = D(:);                  % Make D a 24*Nd x 1 array

% Do the detrending
[Ddetrended,DQr] = quiet_day_detrend(Q,D,2000,99999);

% Plot the first two months of data
%setpos;
plot(DQr,'r','LineWidth',3);hold on;
plot(Ddetrended,'g','LineWidth',3);
plot(D,'y','LineWidth',3);
axis([0 2*31*24 -20 40]);  % Look at first two months of data
xlabel('Hour')
legend('Quiet Day Profile of Month','Detrended Data','Original Data');
