clear
FLAGVAL = 99999.9;
COMP    = 'X';

for zz = 1:1

eval(sprintf('load /tmp/TEMP_%s',COMP(zz)));
I       = find(max(Xm) < floor(FLAGVAL));   
% floor is there because of FLAGVAL is represented as
% 9.999989999999999e+04
Xm          = Xm(:,I);
Xm          = Xm - repmat(mean(Xm),size(Xm,1),1);
CGM_LAT     = CGM_LAT(I,:);
[CGM_LAT,I] = sort(CGM_LAT);
Xm          = Xm(:,I);

close all;
if (zz == 1),caseval = 'X';comp = 'x';,end;
if (zz == 2),caseval = 'Y';comp = 'y';,end;
if (zz == 3),caseval = 'H';comp = 'H';,end;
AMPSTR        = sprintf('{\\fontsize{48} B_%s}',comp);
SIG_AMPSTR    = sprintf('{\\fontsize{48}\\sigma}_{\\fontsize{18}{B_%s}}',comp);
D_AMPSTR      = sprintf('{\\fontsize{36} |dB_%s/dt|}',comp);
SIG_D_AMPSTR  = sprintf('{\\fontsize{48}\\sigma}_{\\fontsize{18}{|dB_%s/dt|}}',comp);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot mean X
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;setpos;
[th,r]   = meshgrid(([0:size(Xm,1)-1]*360/(size(Xm,1)-1))*pi/180,CGM_LAT);
[X,Y]    = pol2cart(th-pi/2,r);
zlims    = [-80 80;-80 80;0 100];
zlims    = [-80 80;-80 80;0 100];
Xmo      = Xm;
Xmo(1)   = zlims(zz,1);
Xmo(end) = zlims(zz,2);
[cl,h]   = contourf(X,Y,Xmo');plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hc       = colorbarf2(cl,h,'vert',Xm',zlims(zz,:));
%hc       = colorbarf2(cl,h,'vert',Xm');
[cl,h]   = contourf(X,Y,Xm');plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hh       = plot(0,CGM_LAT,'w.','MarkerSize',15);
hh       = plot(0,.99*CGM_LAT(end),'w.','MarkerSize',15); % Cheat so last pt. shows
 axis square;
 axis off

 set(get(gca,'xlabel'),'visible','on');
 set(get(gca,'ylabel'),'visible','on');
 set(get(hc,'Title'),'String','(nT)');
 hold on;
 colormap('default')
 if (zz == 1),Fig_letter    = '(a)';end
 if (zz == 2),Fig_letter    = '(c)';end
 if (zz == 3),Fig_letter    = '(e)';end
 spokes;text(22,34,AMPSTR);text(-39,36,sprintf('{\\fontsize{48} %s}',Fig_letter));
 eps_write(sprintf('global_polar_mlt_%s',caseval),2);
 colormap(flipud(hot));  % Colors that copy to black and white properly.
 eps_write(sprintf('global_polar_mlt_%s_bw',caseval),2);
 colormap('default');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
break
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot std X
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;setpos;
[th,r]   = meshgrid(([0:size(Xm,1)-1]*360/(size(Xm,1)-1))*pi/180,CGM_LAT);
[X,Y]    = pol2cart(th-pi/2,r);
zlims    = [0 150;0 150;0 150];
Xmo      = stdXm;
Xmo(1)   = zlims(zz,1);
Xmo(end) = zlims(zz,2);
[cl,h]   = contourf(X,Y,Xmo');plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hc       = colorbarf2(cl,h,'vert',stdXm',zlims(zz,:));
[cl,h]   = contourf(X,Y,stdXm');plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hh       = plot(0,CGM_LAT,'w.','MarkerSize',15);
hh       = plot(0,.99*CGM_LAT(end),'w.','MarkerSize',15); % Cheat so last pt. shows

 axis square
 axis off
 set(get(gca,'xlabel'),'visible','on')
 set(get(gca,'ylabel'),'visible','on')
 set(get(hc,'Title'),'String','(nT)') 
 hold on;
 if (zz == 1),Fig_letter    = '(a)';end
 if (zz == 2),Fig_letter    = '(c)';end
 if (zz == 3),Fig_letter    = '(e)';end
 spokes;text(22,36,SIG_AMPSTR);text(-39,33,sprintf('{\\fontsize{48} %s}',Fig_letter));
 eps_write(sprintf('global_polar_mlt_std_%s',caseval),2);
 colormap(flipud(hot))
 eps_write(sprintf('global_polar_mlt_std_%s_bw',caseval),2);
 colormap('default')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot dX
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;setpos;
[th,r]   = meshgrid(([0:size(Xm,1)-1]*360/(size(Xm,1)-1))*pi/180,CGM_LAT);
[X,Y]    = pol2cart(th-pi/2,r);
zlims    = [0 7;0 7;0 7];
Xmo      = dXm;
Xmo(1)   = zlims(zz,1);
Xmo(end) = zlims(zz,2);
[cl,h]   = contourf(X,Y,Xmo');plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hc       = colorbarf2(cl,h,'vert',dXm',zlims(zz,:));
[cl,h]   = contourf(X,Y,dXm');plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hh       = plot(0,CGM_LAT,'w.','MarkerSize',15);
hh       = plot(0,.99*CGM_LAT(end),'w.','MarkerSize',15); % Cheat so last pt. shows
 axis square
 axis off
 set(get(gca,'xlabel'),'visible','on')
 set(get(gca,'ylabel'),'visible','on')
 set(get(hc,'Title'),'String','(nT/min)') 
 hold on;  
 if (zz == 1),Fig_letter    = '(b)';end
 if (zz == 2),Fig_letter    = '(d)';end
 if (zz == 3),Fig_letter    = '(f)';end
 spokes;text(11.5,33.5,D_AMPSTR);text(-39,33,sprintf('{\\fontsize{48} %s}',Fig_letter));
 eps_write(sprintf('global_polar_mlt_d%s',caseval),2);
 colormap(flipud(hot))
 eps_write(sprintf('global_polar_mlt_d%s_bw',caseval),2);
 colormap('default')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot std dX
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;setpos;
[th,r]   = meshgrid(([0:size(Xm,1)-1]*360/(size(Xm,1)-1))*pi/180,CGM_LAT);
[X,Y]    = pol2cart(th-pi/2,r);
zlims    = [0 20;0 20;0 20];
Xmo      = stddXm;
Xmo(1)   = zlims(zz,1);
Xmo(end) = zlims(zz,2);
[cl,h]   = contourf(X,Y,Xmo');plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hc       = colorbarf2(cl,h,'vert',stddXm',zlims(zz,:));
[cl,h]   = contourf(X,Y,stddXm');plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hh       = plot(0,CGM_LAT,'w.','MarkerSize',15);
hh       = plot(0,.99*CGM_LAT(end),'w.','MarkerSize',15); % Cheat so last pt. shows
 axis square
 axis off
 set(get(gca,'xlabel'),'visible','on')
 set(get(gca,'ylabel'),'visible','on')
 set(get(hc,'Title'),'String','(nT/min)') 
 hold on;
 spokes
 if (zz == 1),Fig_letter    = '(b)';end
 if (zz == 2),Fig_letter    = '(d)';end
 if (zz == 3),Fig_letter    = '(f)';end
 spokes;text(19,36,SIG_D_AMPSTR);text(-39,33,sprintf('{\\fontsize{48} %s}',Fig_letter));
 eps_write(sprintf('global_polar_mlt_std_d%s',caseval),2);
 colormap(flipud(hot))
 eps_write(sprintf('global_polar_mlt_std_d%s_bw',caseval),2);
 colormap('default')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close

end




