clear
FLAGVAL = 99999.9;
COMP    = 'X';
zz      = 1;
Nb      = 5; % Number of segments in colorbar

eval(sprintf('load /tmp/TEMP_DOY_%s',COMP));

%clear Xm dXm;

CGM_LATo = CGM_LAT;
clear CGM_LAT;

clf;
whitebg(gcf,'k');
set(gcf,'Color',[0 0 0])
set(gcf,'Position',[4  60 554   729]);

for season = 1:365

xm      = squeeze(Xm(:,season,:));
I       = find(max(xm) < floor(FLAGVAL));   
% floor is there because of FLAGVAL is represented as 9.999989999999999e+04
xm       = xm(:,I);
xm       = xm - repmat(mean(xm),size(xm,1),1);

CGM_LAT     = CGM_LATo(I,:);
[CGM_LAT,I] = sort(CGM_LAT);
xm          = xm(:,I);
if (zz == 1),caseval = 'X';comp = 'x';,end;
if (zz == 2),caseval = 'Y';comp = 'y';,end;
if (zz == 3),caseval = 'H';comp = 'H';,end;
AMPSTR        = sprintf('{\\fontsize{48} B_%s}',comp);
SIG_AMPSTR    = sprintf('{\\fontsize{48}\\sigma}_{\\fontsize{18}{B_%s}}',comp);
D_AMPSTR      = sprintf('{\\fontsize{36} |dB_%s/dt|}',comp);
SIG_D_AMPSTR  = sprintf('{\\fontsize{48}\\sigma}_{\\fontsize{18}{|dB_%s/dt|}}',comp);

Nb      = 7; % Number of segments in colorbar
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot mean X
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%setpos;
subplot(2,1,1)
[th,r]     = meshgrid(([0:size(xm,1)-1]*360/(size(xm,1)-1))*pi/180,CGM_LAT);
[X,Y]      = pol2cart(th-pi/2,r);
zlims      = [-120 120;-80 80;0 100];
xmo        = xm;
xmo(1)     = zlims(zz,1);
xmo(end)   = zlims(zz,2);
xmo(2)     = zlims(zz,1);
xmo(end-1) = zlims(zz,2);
[cl1,h1]   = contourf(X,Y,xmo',Nb-1);hold on;%plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hc         = colorbarf2(cl1,h1,'vert',xmo',zlims(zz,:));

hh         = plot(0,CGM_LAT,'w.','MarkerSize',15);
hh         = plot(0,.99*CGM_LAT(end),'w.','MarkerSize',15); % Cheat so last pt. shows
axis square;
axis off

 set(get(gca,'xlabel'),'visible','on');
 set(get(gca,'ylabel'),'visible','on');
% set(get(hc,'Title'),'String','(nT)');
 hold on;
% colormap('default')
 if (zz == 1),Fig_letter    = '(a)';end
 if (zz == 2),Fig_letter    = '(c)';end
 if (zz == 3),Fig_letter    = '(e)';end
 Fig_letter = sprintf('DOY=%d',season);
 spokes;text(22,34,AMPSTR);text(-39,36,sprintf('{\\fontsize{24} %s}',Fig_letter));

subplot(2,1,2)

xm     = squeeze(dXm(:,season,:));
I      = find(max(xm) < floor(FLAGVAL));   
xm     = xm(:,I);

[th,r]     = meshgrid(([0:size(xm,1)-1]*360/(size(xm,1)-1))*pi/180,CGM_LAT);
[X,Y]      = pol2cart(th-pi/2,r);
zlims      = [-120 120;-80 80;0 100];
zlims      = [0 30];
%zlims      = [0 240];
Nb         = 5;
xmo        = xm;
xmo(1)     = zlims(zz,1);
xmo(end)   = zlims(zz,2);
xmo(2)     = zlims(zz,1);
xmo(end-1) = zlims(zz,2);
[cl1,h1]   = contourf(X,Y,xmo',Nb-1);hold on;%plotformat(h,1,10,18,0 ,18,0 ,18,0 ,18,0);hold on;
hc         = colorbarf2(cl1,h1,'vert',xmo',zlims(zz,:));

hh         = plot(0,CGM_LAT,'w.','MarkerSize',15);
hh         = plot(0,.99*CGM_LAT(end),'w.','MarkerSize',15); % Cheat so last pt. shows
axis square;
axis off

 set(get(gca,'xlabel'),'visible','on');
 set(get(gca,'ylabel'),'visible','on');
% set(get(hc,'Title'),'String','(nT)');
 hold on;
% colormap('default')
 if (zz == 1),Fig_letter    = '(b)';end
 if (zz == 2),Fig_letter    = '(c)';end
 if (zz == 3),Fig_letter    = '(e)';end
 Fig_letter = sprintf('DOY=%d',season);
 spokes;text(22,34,D_AMPSTR);text(-39,36,sprintf('{\\fontsize{24} %s}',Fig_letter));

drawnow;
clf;
%M(season) = getframe;
%clf;
% eps_write(sprintf('global_polar_mlt_%s_%d',caseval,season),2);
% colormap(flipud(hot));  % Colors that copy to black and white properly.
% eps_write(sprintf('global_polar_mlt_%s_%d_bw',caseval,season),2);
% colormap('default');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%input('Continue?');
end




