clear;

Tave    = 30;

COMP = 'X';
for zz = 1:1

if (1)
MAGLIST = ['AND';'ABK';'BJN';'DOB';'HAN';'HOP';'HOR';'IVA';'KEV';'KIL';'KIR';'LOZ';...
	   'LEK';'LYR';'LYC';'MAS';'MUO';'NAL';'NUR';'OUJ';'PEL';'RVK';'SOD';'SOR';...
	   'TRO';'TAR';'UPS'];

MLTMN        = station_name2mltmn(MAGLIST);
COORDS_CGM   = station_name2geomagnetic(MAGLIST);
CGM_LAT      = 90-COORDS_CGM(:,1); % Change to CGM latitude from CGM colatitude.

load ./matfiles/FMI_1995.mat
clear Dy Dz

end

for i = 1:size(Dx,3)
  temp     = Dx(:,:,i);
  temp     = temp(:);
  ao       = round(MLTMN(i)*60);       % Round MLTMN to nearest minute.
  bo       = length(temp) - (24*60-ao);  % Make length integer number of days.
  X(:,i)   = temp(ao+1:bo);              % First datapoint now at 0 MLT.
end

clear Dx temp;

% Now size(X,1) is now 1440 elements (1 day) smaller.
% The first minute of each column corresponds to first 
% midnight MLT of year.

dX      = abs(diff(X));
dX      = [dX(1,:);dX];  % Makes dX same size as X by repeating first row.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Averaging 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 1:size(dX,2)

  temp0        = reshape(dX(:,i),1440,length(dX(:,i))/1440);
  dXm(:,i)     = blockave(mean_nonzero(temp0,2,FLAG,FLAG),Tave);
  
  temp         = reshape(dX(:,i),1440,length(dX(:,i))/1440);
  stddX(:,i)   = std(temp,[],2);
  stddXm(:,i)  = blockave(stddX(:,i),Tave);
  
  temp2        = reshape(X(:,i),1440,length(X(:,i))/1440);
  Xm(:,i)      = blockave(mean_nonzero(temp2,2,FLAG,FLAG),Tave);
  
  temp3        = reshape(X(:,i),1440,length(X(:,i))/1440);
  stdXm(:,i)   = blockave(std(temp2,[],2),Tave);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Interpolate so smooth at midnight
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a             = 0.5*(Xm(1,:) + Xm(end,:));
Xm(1,:)       = a;
Xm(end,:)     = a;
a             = 0.5*(stdXm(1,:) + stdXm(end,:));
stdXm(1,:)    = a;
stdXm(end,:)  = a;
a             = 0.5*(dXm(1,:) + dXm(end,:));
dXm(1,:)      = a;            
dXm(end,:)    = a;            
a             = 0.5*(stddXm(1,:) + stddXm(end,:));
stddXm(1,:)   = a;
stddXm(end,:) = a;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

keep Xm dXm stdXm stddXm MLTMN MAGLIST CGM_LAT

com = sprintf('save /tmp/TEMP_%d.mat',COMP(zz));
eval(com);

end


