clear;

Tave    = 30;
FLAG    = 99999.9;
COMP    = 'X';

for zz = 1:1

if (0)
MAGLIST = ['AND';'ABK';'BJN';'DOB';'HAN';'HOP';'HOR';'IVA';'KEV';'KIL';'KIR';'LOZ';...
	   'LEK';'LYR';'LYC';'MAS';'MUO';'NAL';'NUR';'OUJ';'PEL';'RVK';'SOD';'SOR';...
	   'TRO';'TAR';'UPS'];

MLTMN        = station_name2mltmn(MAGLIST);
COORDS_CGM   = station_name2geomagnetic(MAGLIST);
CGM_LAT      = 90-COORDS_CGM(:,1); % Change to CGM latitude from CGM colatitude.

load ./matfiles/FMI_1995.mat
clear Dy Dz

for i = 1:size(Dx,3)
  temp     = Dx(:,:,i);
  temp     = temp(:);
  ao       = round(MLTMN(i)*60);       % Round MLTMN to nearest minute.
  bo       = length(temp) - (24*60-ao);  % Make length integer number of days.
  X(:,i)   = temp(ao+1:bo);              % First datapoint now at 0 MLT.
end

clear Dx temp;

% Now size(X,1) is now 1440 elements (1 day) smaller.
% The first minute of each column corresponds to first 
% midnight MLT of year.

dX      = abs(diff(X));
dX      = [dX(1,:);dX];  % Makes dX same size as X by repeating first row.

save /tmp/TEMP.mat
end

load /tmp/TEMP.mat

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Averaging 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Nd = 30;
for j = 1:floor(365/Nd)
  
a = 1440*Nd*(j-1)+1;
b = a + 1440*Nd - 1;
I = [a:b]';
for i = 1:size(X,2)
  temp         = reshape(X(I,i),1440,length(X(I,i))/1440);
  Xm(:,i)      = blockave(mean_nonzero(temp,2,FLAG,FLAG),Tave);
  stdXm(:,i)   = blockave(std_nonzero(temp,2,FLAG,FLAG),Tave);

  temp         = reshape(dX(I,i),1440,length(dX(I,i))/1440);
  dXm(:,i)     = blockave(mean_nonzero(temp,2,FLAG,FLAG),Tave);
  stddXm(:,i)  = blockave(std_nonzero(temp,2,FLAG,FLAG),Tave);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Interpolate so smooth at midnight
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a             = 0.5*(Xm(1,:) + Xm(end,:));
Xm(1,:)       = a;
Xm(end,:)     = a;
a             = 0.5*(stdXm(1,:) + stdXm(end,:));
stdXm(1,:)    = a;
stdXm(end,:)  = a;
a             = 0.5*(dXm(1,:) + dXm(end,:));
dXm(1,:)      = a;            
dXm(end,:)    = a;            
a             = 0.5*(stddXm(1,:) + stddXm(end,:));
stddXm(1,:)   = a;
stddXm(end,:) = a;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Xm_c{j}       = Xm;
stdXm_c{j}    = stdXm;
dXm_c{j}      = dXm;
stddXm_c{j}   = stddXm;

fprintf('j = %d\n',j);

end

keep Xm_c dXm_c stdXm_c stddXm_c MLTMN MAGLIST CGM_LAT zz COMP

com = sprintf('save /tmp/TEMPa_%s.mat Xm_c dXm_c stdXm_c stddXm_c MLTMN MAGLIST CGM_LAT',COMP(zz));
eval(com);

end

