clear;
more off;

mag_data_info;

W       = 30;
Tave    = 30;
COMP    = 'X';
FLAG    = FLAG_JGR;
YEARS   = YEARS_JGR;
YEARS   = [1995:2002];
MAGLIST = MAGLIST_JGR;

for years = YEARS(1,1):YEARS(1,end)
  DOYc{years-YEARS(1)+1} = [1:number_days(years,years)];
end

DOY = cat(2,DOYc{:});

MLTMN        = station_name2mltmn(MAGLIST);
COORDS_CGM   = station_name2geomagnetic(MAGLIST);
CGM_LAT      = 90-COORDS_CGM(:,1); % Change to CGM latitude from CGM colatitude.
years        = [YEARS(1,1):YEARS(1,end)];

for i = 1:size(MAGLIST,1)
  [tempX,tempdX] = mag_data_load(MAGLIST(i,:),years,'X',directory_fmi,FLAG(i,1));
  ao     = round(MLTMN(i)*60);          % Round MLTMN to nearest minute.
  bo     = length(tempX) - (24*60-ao);  % Make length integer number of days.
  tempX  = tempX(ao+1:bo);              % First datapoint now at 0 MLT, DOY=1.
  tempdX = tempdX(ao+1:bo);             % First datapoint now at 0 MLT, DOY=1.
  
  % Now size(X,1) is now 1440 elements (1 day) smaller.
  % The first minute of each column corresponds to first 
  % midnight MLT of year.

  tempX2   = reshape(tempX,1440,length(tempX)/1440);
  tempdX2  = reshape(tempdX,1440,length(tempdX)/1440);
  
%  for doy = 1:1:365
  for doy = 1:4

    I       = season_surround(doy,W);
%    I       = doy_surround(doy,W);
    J       = ismember(DOY,I);
    J       = find(J == 1);
    J       = J(1:end-1);

    tempX3         = tempX2(:,J);
    tempdX3        = tempdX2(:,J);
    Xm(:,i,doy)    = blockave(mean_nonzero(tempX3,2,FLAG(i,1),FLAG(i,1)),Tave);
    dXm(:,i,doy)   = blockave(mean_nonzero(abs(tempdX3),2,FLAG(i,1),FLAG(i,1)),Tave);
    dYm(:,i,doy)   = blockave(max_nonzero(abs(tempdX3),2,FLAG(i,1),FLAG(i,1)),Tave);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Interpolate so smooth at midnight
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    a              = 0.5*(Xm(1,:,doy) + Xm(end,:,doy));
    Xm(1,:,doy)    = a;
    Xm(end,:,doy)  = a;
    a              = 0.5*(dXm(1,:,doy) + dXm(end,:,doy));    
    dXm(1,:,doy)    = a;
    dXm(end,:,doy)  = a;
    a              = 0.5*(dYm(1,:,doy) + dYm(end,:,doy));    
    dYm(1,:,doy)    = a;
    dYm(end,:,doy)  = a;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  end

end

clear temp*

com = sprintf('save /tmp/TEMP_SEASON_%s.mat',COMP);
eval(com);

