function MLT = ut2mlt(UT,Name)
%UT2MLT Convert UT to magnetic local time.
%
%    MLT = UT2MLT(UT,Name) UT is a single column array with elements in the
%    range [0,24].
%  
%    MLT = UT + (24 - MLTMN), where MLTMN is obtained from NSSDC website.
%    using the year 1998.  MLTMN is UT that gives a MLT of midnight.  
%  
%    See also, UT2LT.

MLTMN  = station_name2mltmn(Name);
MLTMN  = repmat(MLTMN,size(UT));

MLT = UT + 24.0 - MLTMN; % Transformation is LT   = UT + 24 - LTMN;
MLT = mod(MLT,24);
