function thepath = perlpath
%PERLPATH Returns the absolute path of Perl binary file.
%
%   thepath = PERLPATH Returns the absolute path of Perl binary file
%
%   if is_unix = 1, thepath = '/usr/bin/perl';
%   if is_unix = 0, thepath = 'C:\MATLAB6p5\sys\perl\win32\bin\perl.exe';
%
%   This function is used by PERLOP.
%  
%   See also PERLOP.
  
if (is_unix)  
  thepath = '/usr/bin/perl';
  D       = dir(thepath(1:end-5));
  Da      = strvcat(D.name);
  I       = strmatch('perl',Da,'exact');
else
  thepath = 'C:\MATLAB6p5\sys\perl\win32\bin\perl.exe';
  D       = dir(thepath(1:end-9));
  Da      = strvcat(D.name);
  I       = strmatch('perl.exe',Da,'exact');
end

if (isempty(I))
  str1 = '??? Cannot find perl executable in';
  str2 = sprintf('\n %s \n Edit perlpath.m to fix.',thepath(1:end-9));
  disp([str1,str2])
  return;
end