function X = is_cygwin()
%IS_CYGWIN Returns 0 if called from Octave on Windows
%
%   value = IS_CYGWIN
%
%   If the string "cygdrive" appears in what is returned by PWD,
%   concludes that you are running the Windows version of Octave and returns
%   1.
%
%   See also IS_OCTAVE, IS_UNIX.

% R.S. Weigel 04/11/2004.
  
CURR_PATH = pwd;
if (is_octave)
  if (length(CURR_PATH) > 9)
    if (CURR_PATH(2:9) == 'cygdrive')
      X   = 1;
    else
      X   = 0;
    end
  else
    X   = 1;
  end
else
  X = 0;
end
  
