
// TO DO: KEY_UP and KEY_DOWN changes the currently selected stat
function getKey(evt) {
    switch(evt.keyCode) {
    case KEY_LEFT:
        evt.preventDefault();
        if(gCursorX > browserStartPoint) {
            --gCursorX;
            // update cursor
            var cur = $("browser_horizcurs");
            if(cur) {
                var x = 400*(gCursorX-browserStartPoint)/(browserEndPoint-browserStartPoint);
                cur.setAttributeNS(null, "transform", "translate(" + x + ",0)");
                cur.setAttributeNS(ns.drag, "x", x);
            }

            // update pie chart
//            drawPieChart();
        }
        break;
    case KEY_RIGHT:
        evt.preventDefault();
        if(gCursorX < browserEndPoint) {
            ++gCursorX;
            // update cursor
            var cur = $("browser_horizcurs");
            if(cur) {
                var x = 400*(gCursorX-browserStartPoint)/(browserEndPoint-browserStartPoint);
                cur.setAttributeNS(null, "transform", "translate(" + x + ",0)");
                cur.setAttributeNS(ns.drag, "x", x);
            }

            // update pie chart
//            drawPieChart();
        }
        break;
    }
}

var bDraggingLatch = false;

function dragMove(evt) {
    if(!bDraggingLatch) {
        bDraggingLatch = true;
        
        if(evt.dragEnt == $('browser_horizcurs')) {
            var newCursorX = browserStartPoint + Math.round( (evt.userx/400) * (browserEndPoint-browserStartPoint) );
            if(newCursorX >= browserStartPoint && newCursorX <= browserEndPoint) {
                gCursorX = newCursorX;
//	        setTimeout("drawPieChart()", 10);
//                drawPieChart();
            }
        }
        else if(evt.dragEnt == $('browser_leftgrip') || evt.dragEnt == $('browser_rightgrip')) {
            var left = parseFloat($('browser_leftgrip').getAttributeNS(ns.drag,"x"));
            var right = 400 + parseFloat($('browser_rightgrip').getAttributeNS(ns.drag,"x"));
            changeGlobalXAxisBounds(left,right);
        }
        else if(evt.dragEnt == $('browser_scrollbar') ) {
            var left = parseFloat($('browser_scrollbar').getAttributeNS(ns.drag,"x"));
            var right = left + parseFloat($('browser_scrollbar').getAttributeNS(null, "width"));
            changeGlobalXAxisBounds(left,right);
        }
        else {
            // moving legend - who cares
        }
        
        bDraggingLatch = false;
    }
}

function dragStart(evt) {
    if( evt.dragEnt == $('browser_leftgrip') || 
        evt.dragEnt == $('browser_rightgrip') ||
        evt.dragEnt == $('browser_scrollbar')
        ) 
    {
        // remove axes
        var axes = $('browser_timechartaxes');
        removeChildren(axes);
    }
}

// recreate axes
function dragDrop(evt) {
    if( evt.dragEnt == $('browser_leftgrip') || 
        evt.dragEnt == $('browser_rightgrip') ||
        evt.dragEnt == $('browser_scrollbar')
        ) 
    {
        // this will change the MaxY and the gCursorX
        reflowTimeBasedAxesAndPie();

        // this will potentially rescale in the y-direction
        var left = parseFloat($('browser_leftgrip').getAttributeNS(ns.drag,"x"));
        var right = 400 + parseFloat($('browser_rightgrip').getAttributeNS(ns.drag,"x"));
        changeGlobalXAxisBounds(left,right);
    }
}

function clickGraph(evt) {
    // only process if the click was on the graph (not the legend)
    if(bDraggingLegend) { 
        bDraggingLegend = false;
        return;
    }
            
    var p = document.documentElement.createSVGPoint();
    p.x = evt.clientX;
    p.y = evt.clientY;

    var screenCTMInv = getScreenCTM().inverse();
    p = p.matrixTransform(screenCTMInv);
    
    if(p.x >= 0 && p.y >= 0 && p.x <= 400 && p.y <= 300) {
        // determine the data point to use
        gCursorX = browserStartPoint + Math.round( (p.x/400) * (browserEndPoint-browserStartPoint) );

        // actual X will be aligned with the data points
        var actualX = (400 * (gCursorX-browserStartPoint)) / (browserEndPoint-browserStartPoint);
        
        // update cursor
        var cur = $('browser_horizcurs');
        if(cur) {
            cur.setAttributeNS(null, "transform", "translate(" + actualX + ",0)");
            cur.setAttributeNS(ns.drag, "x", actualX);
        }
        
        // update pie chart
//        drawPieChart();
    }
}
