
function PieElementsContainer() {
    var r = 125, cx = 150, cy = 150;
    
    this.elem = $('browser_piegroup'); //make('g', {id:'Top'});
//    this.elem.setAttributeNS(null, 'transform', 'translate(450,0)');//display', 'none');
//    $('browser_stat').appendChild(this.elem);
    
    this.elem.appendChild( make('circle', {id:'OuterRing', cx:cx, cy:cy, r:cx }) );
    this.AllWedges = this.elem.appendChild( make( 'g', {id:'AllWedges', 
                                                        transform:'rotate(90,150,150)'}) );
    var LabelG = make( 'g', {id:'LabelG'} );
    var ele = 0;
    var browsers = {}, name;
    this.BrowserWedgePaths = new Object();
    this.BrowserPctLabels = new Object();
    this.BrowserVerLabels = new Object();
    this.BrowserFamilyLabels = new Object();
    for(var browser in BrowserData) {

        // create wedge path elements
        var attr = { id:("WEDGE" + browser), 'class':"wedge " + cssname(browser) };
        if(!ele) {
            attr['cx'] = cx; attr['cy']=cy; attr['r'] = r;
            ele = make( 'circle', attr );            
        }
        else {
            ele = make( 'path', attr );
        }
        this.BrowserWedgePaths[browser] = this.AllWedges.appendChild(ele);
        
        // create labels (percentages and version)
        this.BrowserPctLabels[browser] = LabelG.appendChild(make('text', { 'class':'label pct'}, '%'));

        var version = browser.split( '/' )[1];
        if( version == 'Other' ) version = 'X';
        
        this.BrowserVerLabels[browser] = LabelG.appendChild(make('text', { 'class':'label version'}, version));
        
        name = browser.replace( /\/.*/, '' );
        if(!this.BrowserFamilyLabels[name]) {
            this.BrowserFamilyLabels[name] = LabelG.appendChild( make('text', {'class':'label browser'}, name) );
        }

    } // for(var browser in BrowserData)
    
    this.AllWedges.appendChild( LabelG );
    this.elem.appendChild( make('circle', {'id':'InnerRing', 'cx':cx, 'cy':cy, 'r':r-1 }) );
    this.elem.appendChild( make('circle', {'id':'BrVerFill', 'cx':cx, 'cy':cy, 'r':r-15 }) );
    this.elem.appendChild( make('circle', {'id':'BrPctFill', 'cx':cx, 'cy':cy, 'r':r-30 }) );    
    
    this.Title = this.elem.appendChild( make('text', {id:'PieTitle',x:150,y:325}, 'Distribution for '));
    this.SubTitle = this.elem.appendChild( make('text', {id:'PieSubTitle',x:150,y:340}, 'Total Hits: '));
}

var BrowserPieElements = null;

// TO DO:  Fix this function for sparse data (see soverygood.com)
function drawPieChart()
{
    if(document.documentElement.suspendRedraw) {
        document.documentElement.suspendRedraw(200);
    }
    
    var TotalBrowserHits = 0;
    for(var browser in BrowserData) {
        TotalBrowserHits += BrowserData[browser][gCursorX]||0;
    }

    var pct = 0, prevBrowserPct = 0;
    var r = 125, cx = 150, cy = 150;
    var startx = 0, starty = 0, endx = 0, endy = 0;
    var theta = 0, delta = 0;
    var ele = 0;
    var attr = null;
    var pf = 26, vf = 13; // percent and version radial offsets, in pixels

    var browsers = {}, name;
  
    for(var browser in BrowserPieElements.BrowserWedgePaths) {
        BrowserPieElements.BrowserWedgePaths[browser].setAttributeNS(null, "display", "none");
        BrowserPieElements.BrowserPctLabels[browser].setAttributeNS(null, "display", "none");
        BrowserPieElements.BrowserVerLabels[browser].setAttributeNS(null, "display", "none");
    }
    
    for(var browser in BrowserData) {
        pct = prevBrowserPct + (BrowserData[browser][gCursorX]||0) / TotalBrowserHits;
        if(pct == prevBrowserPct) { continue; }

        name = browser.replace( /\/.*/, '' );
        browsers[name] = (browsers[name]||0) + pct - prevBrowserPct;
    
        // starting point:
        theta = (2 * Math.PI) * prevBrowserPct;
        delta = -theta;
        startx = cx - Math.cos(theta) * r; // negative sign is to mirror horizontally
        starty = cy - Math.sin(theta) * r; // negative sign is because y is in the down direction

        // end point:
        theta = (2 * Math.PI) * pct;
        delta += theta;
        endx = cx - Math.cos(theta) * r; // negative sign is to mirror horizontally
        endy = cy - Math.sin(theta) * r; // negative sign is because y is in the down direction

        attr = { 'class':"wedge " + cssname(browser) };
         
        BrowserPieElements.BrowserWedgePaths[browser].setAttributeNS(null, "display", "inline");
        BrowserPieElements.BrowserWedgePaths[browser].setAttributeNS(null, "d", 
                  "M" + startx + "," + starty + " " + // elliptical arc to the end point
                  "A" + r + "," + r + " 0 " +  // radii and x-axis-rotation
                  ( (delta > Math.PI || delta < 0) ? 1 : 0 ) + // large-arc-flag 
                  " 1 " + // sweep-flag
                  endx + "," + endy + " " + 
                  "L" + cx + "," + cy + " Z");

        // Now draw percentage label 
        var thisPct = Math.round(100.0*(pct-prevBrowserPct));
        if(thisPct > 2.0) {
            theta -= ( (delta/2) );
            var lx = Math.cos(theta);
            var ly = Math.sin(theta);
            var angle = (theta * 180.0 / Math.PI) - 90;
            var version = browser.split( '/' )[1];
            if( version == 'Other' ) version = 'X';

            removeChildren(BrowserPieElements.BrowserPctLabels[browser]);
            BrowserPieElements.BrowserPctLabels[browser].appendChild(document.createTextNode(thisPct + "%"));
            var str = 'translate('+(cx-lx*(r-pf))+','+(cy-ly*(r-pf))+') ' + 'rotate('+ angle +') ';
            BrowserPieElements.BrowserPctLabels[browser].setAttributeNS(null, "display", "inline");
            BrowserPieElements.BrowserPctLabels[browser].setAttributeNS(null, "transform", str);

            str = 'translate('+(cx-lx*(r-vf))+','+(cy-ly*(r-vf))+') ' + 'rotate('+ angle +') ';
            BrowserPieElements.BrowserVerLabels[browser].setAttributeNS(null, "transform", str);
            BrowserPieElements.BrowserVerLabels[browser].setAttributeNS(null, "display", "inline");
        }
//        else {
//            BrowserPieElements.BrowserPctLabels[browser].setAttributeNS(null, "display", "none");
//            BrowserPieElements.BrowserVerLabels[browser].setAttributeNS(null, "display", "none");
//        }

        prevBrowserPct = pct;

    } // for each series

    // Now draw browser name labels
    prevBrowserPct = pct = 0;
    for(var browser in browsers)
    {
        pct = browsers[browser];
        theta = (prevBrowserPct + pct/2) * Math.PI * 2;
        var labx = cx - Math.cos(theta) * (r+7.8);
        var laby = cy - Math.sin(theta) * (r+7.8);
        
        var str = 'translate('+ labx +','+ laby +') '+
                    'rotate('+ ((theta * 180.0 / Math.PI) - 90) +') ';
        BrowserPieElements.BrowserFamilyLabels[browser].setAttributeNS(null, "transform", str);
        
        prevBrowserPct += pct;
    }

    // add titles
    var date = Dates[gCursorX];
                         
    removeChildren(BrowserPieElements.Title);
    BrowserPieElements.Title.appendChild(document.createTextNode('Distribution for ' + date));
    
    removeChildren(BrowserPieElements.SubTitle);
    BrowserPieElements.SubTitle.appendChild(document.createTextNode('Total Browser Hits: ' + TotalBrowserHits));
    
    if(document.documentElement.unsuspendRedrawAll) {
        document.documentElement.unsuspendRedrawAll();
    }
} // end drawPieChart()

