function BINARY_COM = checkdeps(BINARY_LIST,verbosity,error_notfound)

if (nargin < 2)
  verbosity = 0;
end

if iscell(BINARY_LIST)
  LIST = BINARY_LIST;
else
  LIST = cellstr(BINARY_LIST);
end

if (nargin < 3)
  error_notfound = zeros(1,length(LIST));
end

LISTo = LIST;
for i = 1:length(LIST)

  found = 0;

  I = findstr(LIST{i},'/');
  if ~isempty(I) % If directories included in name
    depstr = sprintf('%s',LIST{i});
    if (exist(depstr)==2)
      found = 1;
      BINARY_COM{i} = depstr;
      if (verbosity > 0)
	fprintf('checkdeps: Found %s.\n',LIST{i});
      end
    else
      fprintf('checkdeps: Did not find %s. Continuing search.\n', ...
	      LIST{i});
      if (I(end) < length(LIST{i})) % Extract binary name
	LIST{i} = LIST{i}(I(end)+1:end);
      end
    end
  end

  if (found == 0)
    depstr = sprintf('/usr/bin/%s',LIST{i});
    if (exist(depstr)==2)
      found = 1;
      BINARY_COM{i} = depstr;
      if (verbosity > 0)
	fprintf('checkdeps: Found %s in /usr/bin.\n',LIST{i});
      end
    else
      fprintf('checkdeps: Did not find /usr/bin/%s. Continuing search.\n', ...
	      LIST{i});
    end
  end

  if (found == 0)
    depstr = sprintf('/bin/%s',LIST{i});  
    if (exist(depstr)==2)
      found = 1;
      BINARY_COM{i} = depstr;
      if (verbosity > 0)
	fprintf('checkdeps: Found %s in /bin.\n',LIST{i});
      end
    else
      fprintf('checkdeps: Did not find /bin/%s. Continuing search.\n', ...
	      LIST{i});
    end
  end
  
  if (found == 0)

    BINARY_COM{i} = -1;

    if (error_notfound(i)==1)
      if isempty(I)
	error('checkdeps: Did not find %s in /bin or /usr/bin.\n',LIST{i});
      else
	error('checkdeps: Did not find %s, or /bin/%s, or /usr/bin/%s.\n',...
		LIST{i},LISTo{i},LIST{i});      
      end
    else
      if isempty(I)
	warning('checkdeps: Did not find %s in /bin or /usr/bin.\n',LIST{i});
      else
	warning('checkdeps: Did not find %s, /bin/%s, or /usr/bin/%s.\n',...
		LISTo{i},LIST{i},LIST{i});      
      end
    end
  
  end


end

if ~iscell(BINARY_LIST) & (size(BINARY_LIST,1)==1)
  tmp = BINARY_COM; clear BINARY_COM;
  BINARY_COM = tmp{1};
end
  