function ATTR = Akebono_info(Attr)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Attr.FLAG = 'NaN';
Attr.CreatedWith  = ['Akebono.m'];
Attr.Name    = 'Akebono MeV > 2.5 electron flux amplitude';
Attr.Acknowledgement = ['From http://www.darts.isas.ac.jp/akbn/:' ...
		    ' AKEBONO data were provided by'...
		    ' (proper PIs) through DARTS at Institute of '...
		    ' Space and Astronautical Science (ISAS) in Japan.'];
Attr.Note = 'Akebono is also known as Exos-D.';
Attr.Source  = 'Vassiliadis/Nagai';
Attr.PPD = '1';
Attr.Warning = ['From http://www.darts.ac.jp/akbn/:' ...
		' In order to confirm the reliability'...
		' of the data, we also recommend you to contact to'...
		' proper PIs (& contact persons) before using the data'...
		' in oral/poster presentations.'];
Attr.README  = ...
    'Second dimension is L-shell bin (1-100), L = 1 + (bin number)/10';
Attr.Unit   = 'particles/str.cm.cm.s';
Attr.TimeUnit = 'day';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ATTR{1} = Attr;

Attr.Name = 'Akebono 0.95<MeV<2.5 electron flux amplitude';
ATTR{2}   = Attr;

Attr.Name = 'Akebono 0.30<MeV<0.95 electron flux amplitude';
ATTR{3}   = Attr;
