if (is_octave == 1)
  warning('This test requires Matlab (needs CDFREAD)');
  return;
end

warning('CDAWeb_test: Need to hard wire values for tests in CDAWeb_test');
%return; % Need to hard wire values in here

% To download original data from lasp, use, e.g.
% mkdir goes/0_mag ; cd goes/0_mag ; wget -m --np -nH --cut-dirs=8 "http://lasp.colorado.edu/~weigel/tsds_data/original-s0/cdaweb.gsfc.nasa.gov/pub/istp/goes/0_mag"; find . -name "index.*" | xargs -i rm -f {}

% Note that wget with http requires that you cd to the directory with the
% year subdirectories.

TSDS_GLOBALS

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

NAMES =  {'Wind Bx (CDAWeb)','Wind By (CDAWeb)','Wind Bz (CDAWeb)',...
	  'Wind X position (CDAWeb)',...
	  'Wind Y position (CDAWeb)',...
	  'Wind Z position (CDAWeb)'}

NAMES = {'Wind Bx (CDAWeb)','Wind By (CDAWeb)','Wind Bz (CDAWeb)'};

tmp = ts_slice(NAMES,[2001 7 13],[2001 7 17],'minute');

if (0)
  fname = 'wi_h0_mfi_19981027_v05.cdf';
  I = cdfinfo(sprintf(fname));
  Z = cdfread(sprintf(fname),'VARIABLES','BGSM');
  t = cdfread(sprintf(fname),'VARIABLES','Epoch');
  rm(fname);
end

z = cat(1,cat(2,Z{:})');
D = ts_slice(NAMES,[1998 10 27],[1998 10 27]);

if ( max((z(1,:) - D(1,:))./z(1,:)) > 2*eps('single') )
  error('Error for CDAWeb_test test 3.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 3.1\n\n');
end

if ( max((z(2,:) - D(2,:))./z(2,:)) > 2*eps('single') )
  error('Error for CDAWeb_test test 3.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 3.2\n\n');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NAMES = {'ACE Bx (CDAWeb)','ACE By (CDAWeb)','ACE Bz (CDAWeb)'};
fname = 'ac_h0_mfi_19981027_v04.cdf';
com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
	      'istp/ace/mfi_h0/1998/%s'],...
	      TSDS_WGET,TSDS_DATA_ORIG_HTTP,fname);
system(com);

I = cdfinfo(fname);
Z = cdfread(fname,'VARIABLES','BGSM');
t = cdfread(fname,'VARIABLES','Epoch');

z = cat(1,cat(2,Z{:})');

D = ts_slice(NAMES,[1998 10 27],[1998 10 27]);

% Note z is on 16s grid and D on 1-min grid.  D generated from
% z by nearest-neighbor interpolation.

z(2,:)
t{1}
D(1,:)

z(6,:)
t{2}
D(2,:)

if( z(6,:) ~= D(2,:) )
  error('Error for CDAWeb_test test 1.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 1.1\n\n');
end

rm(fname);

D = ts_slice(NAMES,[1997 1 1],[1998 12 31]);
[Ig,Dg(:,1)] = ts_get(NAMES{1});
[Ig,Dg(:,2)] = ts_get(NAMES{2});
[Ig,Dg(:,3)] = ts_get(NAMES{3});

a = 1440*number_days(1997,1998);
Dg(a,:)
D(end,:)

if( Dg(a,:) ~= D(end,:) )
  error('Error for CDAWeb_test test 1.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 1.2\n\n');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NAMES    = {'Doublestar 2 X position','Doublestar 2 Y position',...
	    'Doublestar 2 Z position'};
NAMES = NAMES{1};
fname    = 'T2_SP_AUX_20041019_V0.cdf';
com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
	      'istp/doublestar/d2/sp/aux/2004/%s'],...
	      TSDS_WGET,TSDS_DATA_ORIG_HTTP,fname);
system(com);

I = cdfinfo(fname);
Z = cdfread(fname,'VARIABLES','sc_r_xyz_gse__T2_SP_AUX');
t = cdfread(fname,'VARIABLES','Epoch__T2_SP_AUX');

z = cat(1,cat(2,Z{:})');

%D = ts_slice(NAMES,[1992 10 4],[1992 10 4]);
D = ts_slice(NAMES,[2004 10 19],[2004 10 19]);
%[xx,D2] = ts_get(NAMES);

%a = 60*11+21;

t{1:4}
z(1:4,:)
D(1:4,:)

if( z(1,:) ~= D(1,:) )
  error('Error for CDAWeb_test test 7.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 7.1\n\n');
end

if( z(2,:) ~= D(2,:) )
  error('Error for CDAWeb_test test 7.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 7.2\n\n');
end
rm(fname);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NAMES    = {'GOES 8 X position (CDAWeb)','GOES 8 Y position (CDAWeb)',...
	    'GOES 8 Z position (CDAWeb)'};
fname    = 'g8_k0_mag_20000101_v04.cdf';
com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
	      'istp/goes/8_mag/2000/%s'],...
	      TSDS_WGET,TSDS_DATA_ORIG_HTTP,fname);
system(com);

I = cdfinfo(fname);
Z = cdfread(fname,'VARIABLES','SC_pos_sm');
t = cdfread(fname,'VARIABLES','Epoch');

z = cat(1,cat(2,Z{:})');

D = ts_slice(NAMES,[2000 1 1],[2000 1 1]);

t{1:2}
z(1:2,:)
D(1:2,:)

if( z(1,:) ~= D(1,:) )
  error('Error for CDAWeb_test test 6.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 6.1\n\n');
end

if( z(2,:) ~= D(2,:) )
  error('Error for CDAWeb_test test 6.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 6.2\n\n');
end
rm(fname);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NAMES    = {'IMP 8 Bx (CDAWeb)','IMP 8 By (CDAWeb)',...
	    'IMP 8 Bz (CDAWeb)'};
NAMES = NAMES{1};
fname    = 'i8_k0_mag_20000101_v02.cdf';
com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
	      'istp/imp8/mag/2000/%s'],...
	      TSDS_WGET,TSDS_DATA_ORIG_HTTP,fname);
%fname    = 'i8_k0_mag_19921004_v02.cdf';
%com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
%	      'istp/imp8/mag/1992/%s'],...
%	      TSDS_WGET,TSDS_DATA_ORIG_HTTP,fname);
system(com);

I = cdfinfo(fname);
Z = cdfread(fname,'VARIABLES','B_GSM_c');
t = cdfread(fname,'VARIABLES','Epoch');

z = cat(1,cat(2,Z{:})');

%D = ts_slice(NAMES,[1992 10 4],[1992 10 4]);
D = ts_slice(NAMES,[2000 1 1],[2000 1 1]);
%[xx,D2] = ts_get(NAMES);

%a = 60*11+21;
a = 60*5;
t{1:5}
z(1:5,:)
D(a:a+5,:)

if( z(1,:) ~= D(a,:) )
  error('Error for CDAWeb_test test 6.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 6.1\n\n');
end

if( z(2,:) ~= D(a+1,:) )
  error('Error for CDAWeb_test test 6.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 6.2\n\n');
end
rm(fname);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NAMES    = {'GOES 8 X position (CDAWeb)','GOES 8 Y position (CDAWeb)',...
	    'GOES 8 Z position (CDAWeb)'};
fname    = 'g8_k0_mag_20000101_v04.cdf';
com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
	      'istp/goes/8_mag/2000/%s'],...
	      TSDS_WGET,TSDS_DATA_ORIG_HTTP,fname);
system(com);

I = cdfinfo(fname);
Z = cdfread(fname,'VARIABLES','SC_pos_sm');
t = cdfread(fname,'VARIABLES','Epoch');

z = cat(1,cat(2,Z{:})');

D = ts_slice(NAMES,[2000 1 1],[2000 1 1]);

t{1:2}
z(1:2,:)
D(1:2,:)

if( z(1,:) ~= D(1,:) )
  error('Error for CDAWeb_test test 6.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 6.1\n\n');
end

if( z(2,:) ~= D(2,:) )
  error('Error for CDAWeb_test test 6.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 6.2\n\n');
end
rm(fname);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NAMES    = {'GOES 10 X position (CDAWeb)','GOES 10 Y position (CDAWeb)',...
	    'GOES 10 Z position (CDAWeb)'};
fname    = 'g0_k0_mag_20040806_v03.cdf';
com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
	      'istp/goes/0_mag/2004/%s'],...
	      TSDS_WGET,TSDS_DATA_ORIG_HTTP,fname);
system(com);

I = cdfinfo(fname);
Z = cdfread(fname,'VARIABLES','SC_pos_sm');
t = cdfread(fname,'VARIABLES','Epoch');

z = cat(1,cat(2,Z{:})');

D = ts_slice(NAMES,[2004 08 06],[2004 08 06]);

t{1:2}
z(1:2,:)
D(1:2,:)

if( z(1,:) ~= D(1,:) )
  error('Error for CDAWeb_test test 5.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 5.1\n\n');
end

if( z(2,:) ~= D(2,:) )
  error('Error for CDAWeb_test test 5.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 5.2\n\n');
end
rm(fname);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NAMES    = {'Polar X position (CDAWeb)','Polar Y position (CDAWeb)',...
	    'Polar Z position (CDAWeb)'};
fname    = 'po_k0_mfe_19980101_v01.cdf';
com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
	      'istp/polar/mfe/1998/%s'],...
	      TSDS_WGET,TSDS_DATA_ORIG_HTTP,fname);
system(com);

I = cdfinfo(fname);
Z = cdfread(fname,'VARIABLES','POS_GSM');
t = cdfread(fname,'VARIABLES','Epoch');

z = cat(1,cat(2,Z{:})');

D = ts_slice(NAMES,[1998 1 1],[1998 1 1]);

t{1:2}
z(1:2,:)
D(1:2,:)/6378 
% /6378 because Polar position values were converted from Re (in file)
% to km (in TSDS).

if( z(1,:) ~= D(1,:)/6378 )
  error('Error for CDAWeb_test test 4.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 4.1\n\n');
end

if( z(2,:) ~= D(2,:)/6378 )
  error('Error for CDAWeb_test test 4.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 4.2\n\n');
end
rm(fname);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NAMES    = {'Ulysses Br (CDAWeb)'};

com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
	      'istp/ulysses/vhm_1min/1997/uy_1min_vhm_19971216_v01.cdf'],...
	      TSDS_WGET,TSDS_DATA_ORIG_HTTP);
system(com);

I = cdfinfo(sprintf('uy_1min_vhm_19971216_v01.cdf'));
Z = cdfread(sprintf('uy_1min_vhm_19971216_v01.cdf'),'VARIABLES','B_RTN');
t = cdfread(sprintf('uy_1min_vhm_19971216_v01.cdf'),'VARIABLES','Epoch');

z = cat(1,cat(2,Z{:})');

D = ts_slice(NAMES,[1997 12 16],[1997 12 16]);

t{1}
z(1:5,:)
D(1:5,:)

if( z(1,:) ~= D(1,:) )
  error('Error for CDAWeb_test test 2.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 2.1\n\n');
end

if( z(2,:) ~= D(2,:) )
  error('Error for CDAWeb_test test 2.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 2.2\n\n');
end

rm('uy_1min_vhm_19971216_v01.cdf');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NAMES    = {'Doublestar 1 Bx','Doublestar 1 By',...
	    'Doublestar 1 Bz'};
NAMES = NAMES{1};
fname    = 'T1_SP_FGM_20040325_V0.cdf';
com = sprintf(['%s %s/cdaweb.gsfc.nasa.gov/pub/'...
	      'istp/doublestar/d1/sp/aux/2004/%s'],...
	      TSDS_WGET,TSDS_DATA_ORIG_HTTP,fname);
system(com);

I = cdfinfo(fname);
Z = cdfread(fname,'VARIABLES','B_xyz_gse__T1_SP_FGM');
t = cdfread(fname,'VARIABLES','Epoch__T1_SP_FGM');

z = cat(1,cat(2,Z{:})');

%D = ts_slice(NAMES,[1992 10 4],[1992 10 4]);
D = ts_slice(NAMES,[2004 3 25],[2004 3 25]);
%[xx,D2] = ts_get(NAMES);

%a = 60*11+21;

t{1:4}
z(1:4,:)
D(1:4,:)

if( z(1,:) ~= D(1,:) )
  error('Error for CDAWeb_test test 8.1\n');
else
  fprintf('\nSuccess for CDAWeb_test test 8.1\n\n');
end

if( z(2,:) ~= D(2,:) )
  error('Error for CDAWeb_test test 8.2\n');
else
  fprintf('\nSuccess for CDAWeb_test test 8.2\n\n');
end
rm(fname);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear D Dg I Ig NAMES Z a fname t tempstr z
