function [V,ATTR] = ISGI_extract(DATA_DIR,var)

TSDS_GLOBALS; % Get global variables and path setting

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load the data after transforming original data to a matrix data file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
com = sprintf('cd %s ; %s %s/ima2matrix.pl',...
	      DATA_DIR,TSDS_PERL,TSDS_PERLFILES);
system(com);

X = load(sprintf('%s/data_cat.matrix',DATA_DIR));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix X has format
% Column 1   = MOYR (e.g., 12004 = January, 2004)
% Column 2   = CODE (18=aa, 2=am)
% Column 3   = Number of days in month
% Column 4   = Ave in 1st 3-hour interval of month
% ...
% Column 248 = Ave in 248th( = 8*31) 3-hour interval of month
%
% If month has less than 31 days, -1 is used as fill.

MO     = floor(X(:,1)/10000);
YR     = X(:,1)-10000*fix(X(:,1)/10000);
Year_o = YR(1);
Year_f = YR(end);

a   = X(:,4:size(X,2));
Nd  = X(:,3); % Number of days in month

for i = 1:size(a,1)
  a_new(i,:)          = NaN*ones(1,248); % 31 days of fill
  a_new(i,1:8*Nd(i))  = a(i,1:8*Nd(i));        % insert data 
end

a      = a_new';
a_new  = a_new(:);

I      = find(a==TSDS_FLAG); 
a      = a(I); % Removes nonexistent days in month

a = reflag(a,-1,NaN); % Removes any other flagged values

% put data on 1-hour time grid.
a = repmat(a',3,1);
V = a(:);

ATTR.Size    = size(V);
ATTR.Year_o  = num2str(Year_o);
ATTR.Year_f  = num2str(Year_f);
