function [V,ATTR] = ISGI_extract(DATA_DIR,var)

TSDS_GLOBALS; % Get global variables and path setting

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load the data after transforming original data to a matrix data file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
TEMPDIR = [TSDS_DATA_TEMP,'/isgi'];
com = sprintf('rm -f %s/*; mkdir -p %s;cd %s ; %s %s/ISGI_extract_ae.pl %s',...
	      TEMPDIR,TEMPDIR,DATA_DIR,TSDS_PERL,TSDS_PERLFILES,TEMPDIR);

system(com);

X = load(sprintf('%s/data_cat.matrix',TEMPDIR));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix X has format
% Column 1   = YEAR (last 2 digits, 82=1982)                        
% Column 2   = MONTH (01-12)
% Column 3   = ELEMENT (0=AE, 1=AL, 2=AO, or 3=AU)
% Column 4   = DAY OF MONTH (01-31)
% Column 5   = Tabular base, hundreds of nanoTeslas for the indice elements.
% Column 6-31 = Twenty-four 4-digit Hourly Values  for  the  day. A missing
%               value is identified by 9999.
%
% Note:  To compute absolute value multiply tabular base by 100 and
%        add tabular base to each indice hourly value and daily mean.

% Huh? Above should be: add TB*100 to each indice hourly value

for el = 0:3

  I     = find(X(:,3) == el);
  YR    = X(I,1);
  MO    = X(I,2);
  DOM   = X(I,4);
  TB    = X(I,5);
  DATAo = X(I,6:end);

  if (YR(end) > 1999)
    Year_f = YR(end)+2000;
  else
    Year_f = YR(end)+1900;
  end

  Year_o = YR(1)+1900;

  Dn = day_number(YR,MO,DOM);
  Dn = Dn - Dn(1);
  Hn = 1 + cumsum([24*Dn' ; ones(23,length(Dn))]);
  Hn = Hn(:);
  
  DATA     = NaN*[1:24*number_days(Year_o,Year_f)]';
  DATAo    = reflag(DATAo,9999,NaN);
  DATAo    = repmat(TB*100,1,24)+DATAo;
  DATAo    = DATAo';

  DATA(Hn) = DATAo(:);
  length(DATA)-24*number_days(Year_o,Year_f);

  V{el+1} = DATA;

  ATTR{el+1}.Size    = size(V{el+1});
  ATTR{el+1}.Year_o  = num2str(Year_o);
  ATTR{el+1}.Year_f  = num2str(Year_f);

end

