function [V,ATTR] = Kyoto_AE_1_min_extract(DATA_DIR)

% Get global variables and path setting
TSDS_GLOBALS;

TEMPDIR = [TSDS_DATA_TEMP,'/Kyoto_AE_1_min'];

com = sprintf('rm -f %s/*; mkdir -p %s;cd %s ; %s %s/Kyoto_AE_1_min_extract.pl %s',TEMPDIR,TEMPDIR,DATA_DIR,TSDS_PERL,TSDS_PERLFILES,TEMPDIR);

system(com);

fname = sprintf('%s/all_data.dat',TEMPDIR);
fprintf('Kyoto_AE_1_min_extract.m: Loading %s\n',fname);
load(fname);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I    = find(all_data(:,5) == 1); % Find AE rows
AE   = all_data(I,8:67);
AE_T = all_data(I,1:4);
Nhr  = 24*number_days(1997,2001);
T    = ymd([0:Nhr-1]',1997,'hour');

[X1,X2,T] = time_union2([AE_T , AE],T,99999,'hour');
AE        = X1';
AE        = AE(:);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I    = find(all_data(:,5) == 2); % Find AL rows
AL   = all_data(I,8:67);
AL_T = all_data(I,1:4);
Nhr  = 24*number_days(1997,2001);
T    = ymd([0:Nhr-1]',1997,'hour');

[X1,X2,T] = time_union2([AL_T , AL],T,99999,'hour');
AL        = X1';
AL        = AL(:);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I    = find(all_data(:,5) == 3); % Find AU rows
AU   = all_data(I,8:67);
AU_T = all_data(I,1:4);
Nhr  = 24*number_days(1997,2001);
T    = ymd([0:Nhr-1]',1997,'hour');

[X1,X2,T] = time_union2([AU_T , AU],T,99999,'hour');
AU        = X1';
AU        = AU(:);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

V{1} = reflag(AE,99999,NaN);
ATTR{1}.Year_o = '1997';
ATTR{1}.Year_f = '2001';
ATTR{1}.Size   = size(AL);

V{2} = reflag(AL,99999,NaN);
ATTR{2}.Year_o = '1997';
ATTR{2}.Year_f = '2001';
ATTR{2}.Size   = size(AL);

V{3} = reflag(AU,99999,NaN);
ATTR{3}.Year_o = '1997';
ATTR{3}.Year_f = '2001';
ATTR{3}.Size   = size(AU);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% columns 1-4:
% Year Month Day Hour 
%
% column 5 (1 = AE, 2=AL, 3=AU): 
% INDEX_CODE 
%
% column 6:
% 00 
%
% column 7:
% base line / 1000 (add this value*1000 to each minute values)
%
% columns 8-67:
% 60 minutes of data in given hour
% 
% column 68:
% mean of 60 minutes of data
%
% R.S. Weigel, 12/01/2004.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



