
TALL = ts_slice('Matrix to transform vector from GSM to GSE',...
	     [2000 1 1],[2000 1 1]);

T  = TALL(1,:); % First element is at UT=00:30.

V  = [10 10 10];

Vt(1) = T(1)*V(1)+T(4)*V(2)+T(7)*V(3);
Vt(2) = T(2)*V(1)+T(5)*V(2)+T(8)*V(3);
Vt(3) = T(3)*V(1)+T(6)*V(2)+T(9)*V(3);

% tmp1 = sptransform(4,5,[2000 1 1 0 0 0],V,1)
tmp1 = [10.00000000000000  7.00092246181954  12.28768019943515];
% tmp2 = sptransform(4,5,[2000 1 1 1 0 0],V,1)
tmp2 = [10.00000000000000  7.22684714917838  12.15617868749931];

% Check 1 (This is how time series was generated).
Vtc1 = (tmp1 + tmp2)/2;

% Check 2 using http://sscweb.gsfc.nasa.gov/cgi-bin/sscweb/CoordCalculator.cgi
Vtc3 = [10.00 7.09 12.23];

% Check 3
% Vtc2 = sptransform(4,5,[2000 1 1 0 29 59],V,1)
Vtc2 = [10.00000000000000  7.09319607784531  12.23464627201130];

magVt   = sqrt(sum(Vt.^2));
magVtc1 = sqrt(sum(Vtc1.^2));
magVtc2 = sqrt(sum(Vtc2.^2));
magVtc3 = sqrt(sum(Vtc3.^2));

E(1) = (magVt-magVtc1)/magVtc1;
E(2) = (magVt-magVtc2)/magVtc2;
E(3) = (magVt-magVtc3)/magVtc3;

if ( max(E) < 0.001 ) % .1 percent
  fprintf('\nModelWeb_test: Success for test 1.2\n');
else
  error('ModelWeb_test: Test 1.2 failed\n');  
end

TALL = ts_slice('Matrix to transform vector from GSM to GSE',...
	     [2000 1 1],[2000 1 1]);
T  = TALL(1,:); % First element is at UT=0.5.
V  = [1 0 0];
for i = 1:3
  Vt(1) = T(1)*V(1)+V(2)*T(2)+V(3)*T(3);
  Vt(2) = T(4)*V(1)+T(5)*V(2)+T(6)*V(3);
  Vt(3) = T(7)*V(1)+T(8)*V(2)+T(9)*V(3);
end

if ( max((Vt-V))<= eps ) % x axis is same in GSM and GSE
  fprintf('\nModelWeb_test: Success for test 1.1\n');
else
  error('ModelWeb_test: Test 1.1 failed\n');  
end
