function [V,Attr] = NGDC_F10_7_extract(DATA_DIR,var)

TSDS_GLOBALS; % Get global variables and path setting

if (var == 'adj')
  FILE = 'DAILYPLT.ADJ';
end
if (var == 'obs')
  FILE = 'DAILYPLT.OBS';
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load the data after transforming original data to a matrix data file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
TEMPDIR = [TSDS_DATA_TEMP,'/ngdc'];
com=sprintf(...
    'rm -f %s/*; mkdir -p %s;cd %s ; %s %s/NGDC_extract_F10_7.pl %s %s',...
    TEMPDIR,TEMPDIR,DATA_DIR,TSDS_PERL,TSDS_PERLFILES,TEMPDIR,FILE);

system(com);

X = load(sprintf('%s/%s.modified',TEMPDIR,FILE));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Yr  = X(:,1);
Mon = X(:,2);
Day = X(:,3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Check time stamps
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
YMDx      = [Yr Mon Day];
DN        = day_number(YMDx);        % Convert to day number
I         = find(diff(DN) ~= 1);

if (~isempty(I))
  % There is a typo in file at I = 16762.  Line says time is 19921111
  % but should read 19921121,
  if (length(I) > 2) % This ignores that problem
    YMDx(I,:)
    error('Problem with time vector near above dates.  Unexpected gap.');
  end
end

Year_o    = YMDx(1,1);
Year_f    = YMDx(end,1);

if (length(DN) ~= number_days(Year_o,Year_f))
  error('Problem with time vector.');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

V = reflag(X(:,4),99999,NaN); % The data in a character array

Attr.Year_o = num2str(Year_o);
Attr.Year_f = num2str(Year_f);
Attr.Size   = size(V);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



