function [V,ATTR] = NGDC_Kp_Ap_extract(DATA_DIR)

% Get global variables and path setting
TSDS_GLOBALS;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load the data after transforming original data to a matrix data file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
TEMPDIR = [TSDS_DATA_TEMP,'/ngdc'];
com=sprintf('rm -f %s/*; mkdir -p %s;cd %s ; %s %s/NGDC_extract_Kp_Ap.pl %s %s',...
	    TEMPDIR,TEMPDIR,DATA_DIR,TSDS_PERL,TSDS_PERLFILES,TEMPDIR,DATA_DIR);

system(com);

X = load(sprintf('%s/NGDC_extract_Kp_Ap.txt',TEMPDIR));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Yr   = X(:,1);
Mon  = X(:,2);
Day  = X(:,3);
DATA = X(:,4:end);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

YMDx = [Yr Mon Day];
DN   = day_number(YMDx);        % Convert to day number
I    = find(diff(DN) ~= 1);

if (~isempty(I))
  YMDx(I,:)
  error('Problem with time vector near above dates.  Unexpected gap.');
end

Year_o = YMDx(1,1);
Year_f = YMDx(end,1);

DOYf = doy(YMDx(end,:));
NDYf = number_days(Year_f);

DATA = [DATA ; repmat(99999,NDYf-DOYf,size(DATA,2))];

if (size(DATA,1) ~= number_days(Year_o,Year_f))
  error('Problem with time vector.');
end

BN = DATA(:,1);
BDN = DATA(:,2);

Kp = DATA(:,3:10)'; 
Kp = Kp(:);
Kp = repmat(Kp',3,1);
Kp = Kp(:);
Kps = DATA(:,11);

ap = DATA(:,12:19)'; 
ap = ap(:);
ap = repmat(ap',3,1);
ap = ap(:);
Ap = DATA(:,20);

Cp  = DATA(:,21);
C9  = DATA(:,22);
ISSN = DATA(:,23);
F107 = DATA(:,24);
FQ   = DATA(:,25);

V{1} = BN;
V{2} = BDN;
V{3} = Kp;
V{4} = Kps;
V{5} = ap;
V{6} = Ap;
V{7} = Cp;
V{8} = C9;
V{9} = ISSN;
V{10} = F107;
V{11} = FQ;

Attr.Year_o = num2str(Year_o);
Attr.Year_f = num2str(Year_f);
for i = 1:length(V)
  Attr.Size = size(V{i});
  ATTR{i}   = Attr;
  V{i} = reflag(V{i},99999,NaN);
end


