% Check 15-minute data files for Vostok and Thule

D = ts_slice('Vostok PC index (NGDC 15-min)',[1992 12 31],[1992 12 31]);

if all(D([61,1440])'==[0.3 -0.2]) & all(isnan(D([1,16,31,46])))
  fprintf('\nNGDC_PC test 1.1 success\n');
else
  error('NGDC_PC test 1.1 failed\n');
end

D = ts_slice('Vostok PC index (NGDC 15-min)',[1991 8 31],[1991 8 31]);

if ( D([1,15,16,1440])' == [1.6 1.6 1.2 3.7])
  fprintf('\nNGDC_PC test 1.2 success\n');
else
  error('NGDC_PC test 1.2 failed\n');
end

D = ts_slice('Vostok PC index (NGDC 15-min)',[1978 1 1],[1978 1 1]);

if ( D([1,15,16])' == [0.9 0.9 1.3])
  fprintf('\nNGDC_PC test 1.3 success\n');
else
  error('NGDC_PC test 1.3 failed\n');
end

D = ts_slice('Thule PC index (NGDC 15-min)',[2005 9 30],[2005 9 30]);
if ( D([1,16,31,46,1440])' == [0.4 0.6 0.5 0.6 1.6])
  fprintf('\nNGDC_PC test 2.1 success\n');
else
  error('NGDC_PC test 2.1 failed\n');
end

D = ts_slice('Thule PC index (NGDC 15-min)',[2005 1 1],[2005 1 1]);

if ( D([1,16,31,46,1440])' == [1.1 1.1 0.7 1.1 0.2])
  fprintf('\nNGDC_PC test 2.2 success\n');
else
  error('NGDC_PC test 2.2 failed\n');
end

D = ts_slice('Thule PC index (NGDC 15-min)',[2004 9 30],[2004 9 30]);

if ( D([1,16,31,46,1440])' == [0.5 0.7 0.8 0.5 0.0])
  fprintf('\nNGDC_PC test 2.3 success\n');
else
  error('NGDC_PC test 2.3 failed\n');
end

D = ts_slice('Thule PC index (NGDC 15-min)',[1978 1 1],[1978 1 1]);

if ( D([1,16,31,46,1440])' == [0.5 0.8 0.7 0.4 1.1])
  fprintf('\nNGDC_PC test 2.4 success\n');
else
  error('NGDC_PC test 2.4 failed\n');
end

D = ts_slice('Thule PC index (NGDC 15-min)',[1991 8 31],[1991 8 31]);

if ( D([1,15,16,1440])' == [1.2 1.2 0.9 2.9])
  fprintf('\nNGDC_PC test 2.5 success\n');
else
  error('NGDC_PC test 2.5 failed\n');
end

% Check 1-minute data files for Vostok
% File format changes between 1998 9 9 (1440 pts/line) and 1998 11 2 (60
% pts/line).  Make sure this was treated correctly.

D = ts_slice('Vostok PC index (NGDC 1-min)',[1998 1 1],[1998 1 1]);

if (D(1:10)' == [.1    .1    .1    .1    .1    .1    .1    .1    .1    .1])
  fprintf('\nNGDC_PC test 3.1 success\n');
else
  error('NGDC_PC test 3.1 failed\n');
end

D = ts_slice('Vostok PC index (NGDC 1-min)',[1998 9 9],[1998 9 9]);

if (D(1:10)' == [1.1  1.1   1.1   1.1   1.0   1.0   1.1   1.1   1.0   1.0])
  fprintf('\nNGDC_PC test 3.2 success\n');
else
  error('NGDC_PC test 3.2 failed\n');
end

D = ts_slice('Vostok PC index (NGDC 1-min)',[1998 9 10],[1998 9 10]);

if (all(isnan(D(1:10))))
  fprintf('\nNGDC_PC test 3.3 success\n');
else
  error('NGDC_PC test 3.3 failed\n');
end

D = ts_slice('Vostok PC index (NGDC 1-min)',[1998 11 1],[1998 11 1]);

if (all(isnan(D(1:10))))
  fprintf('\nNGDC_PC test 3.4 success\n');
else
  error('NGDC_PC test 3.4 failed\n');
end

D = ts_slice('Vostok PC index (NGDC 1-min)',[1998 11 2],[1998 11 2]);

if (D(1:10)' == [.7    .7   .7    .6    .6    .6    .6    .6    .7    .7 ])
  fprintf('\nNGDC_PC test 3.5 success\n');
else
  error('NGDC_PC test 3.5 failed\n');
end

D = ts_slice('Vostok PC index (NGDC 1-min)',[1997 6 5],[1997 6 5]);

if (D(1:10)' == [1.7   1.7 1.7   1.7   1.7   1.7   1.6   1.6   1.5   1.5] )
  fprintf('\nNGDC_PC test 3.6 success\n');
else
  error('NGDC_PC test 3.6 failed\n');
end

D = ts_slice('Vostok PC index (NGDC 1-min)',[1992 1 1],[1992 1 1]);

if (D(1:10)' == [0 0 0 0 0 -0.1 -0.1 -0.1 -0.1 -0.1] )
  fprintf('\nNGDC_PC test 3.7 success\n');
else
  error('NGDC_PC test 3.7 failed\n');
end

