CSYS = {'_','_','_','_','_',...
       '_','_','GSE','GSE','GSE',...
       'GSE','GSE','GSM','GSM','_',...
       '_','_','_','_','_',...
       '_','_','GSE','GSE','_',...
       '_','_','_','_','_',...
       '_','_','_','_','_',...
       '_','_','_','_','_'};
       
UNITS = {'','','','','',...
	 'nT','nT','degrees','degrees','nT',...
	 'nT','nT','nT','nT','nT',...
	 'nT','nT','nT','nT','Degrees Kelvin',...
	 'N/cm^3','km/s','degrees','degrees','Degrees Kelvin',...
	 'N/cm^3','km/s','degrees','degrees','',...
	 '','','nT','number/cmsq sec sr','number/cmsq sec sr',...
	 'number/cmsq sec sr','number/cmsq sec sr',...
	 'number/cmsq sec sr','number/cmsq sec sr',''};

NAMES = {'Bartels rotation number (OMNIWeb1 1-hour)',...
	  'ID for IMF spacecraft (OMNIWeb1 1-hour)',...
	  'ID for SW plasma spacecraft (OMNIWeb1 1-hour)',...
	  '# of points in the IMF averages (OMNIWeb1 1-hour)',...
	  '# of points in the plasma averages (OMNIWeb1 1-hour)',...
	  'Field Magnitude Average |B|, 1/N SUM |B| (OMNIWeb1 1-hour)',...
	  'Magnitude of Average Field Vector sqrt(Bx^2+By^2+Bz^2) (OMNIWeb1 1-hour)',...
	  'Lat.Angle of Aver. Field Vector (OMNIWeb1 1-hour)',...
	  'Long.Angle of Aver.Field Vector (OMNIWeb1 1-hour)',...
	  'Bx near Earth (GSE) (OMNIWeb1 1-hour)',...
	  'By near Earth (GSE) (OMNIWeb1 1-hour)',...
	  'Bz near Earth (GSE) (OMNIWeb1 1-hour)',...
	  'By near Earth (GSM) (OMNIWeb1 1-hour)',...
	  'Bz near Earth (GSM) (OMNIWeb1 1-hour)',...
	  'sigma|B| RMS Standard Deviation in average magnitude (OMNIWeb1 1-hour)',...
	  'sigma B RMS Standard Deviation in field vector (OMNIWeb1 1-hour)',...
	  'sigma Bx RMS Standard Deviation in GSE X-component average (OMNIWeb1 1-hour)',...
	  'sigma By RMS Standard Deviation in GSE Y-component average (OMNIWeb1 1-hour)',...
	  'sigma Bz RMS Standard Deviation in GSE Z-component average (OMNIWeb1 1-hour)',...
	  'Plasma temperature (OMNIWeb1 1-hour)',...
	  'Ion Density (OMNIWeb1 1-hour)',...
	  'Plasma (Bulk) speed (OMNIWeb1 1-hour)',...
	  'Plasma (Bulk) Flow Long. Angle (OMNIWeb1 1-hour), i.e. positive from from -X to Y or positive flow from the west limb of the Sun ',...
	  'Plasma (Bulk) Flow Lat. Angle (OMNIWeb1 1-hour) positive to the northern heliosphere '...
          'sigma T (OMNIWeb1 1-hour)',...
	  'sigma N (OMNIWeb1 1-hour)',...
	  'sigma V (OMNIWeb1 1-hour)',...
	  'sigma phi V (OMNIWeb1 1-hour)',...
	  'sigma theta V (OMNIWeb1 1-hour)',...
	  'Kp Planetary Geomagnetic Activity Index (OMNIWeb1 1-hour) (e.g. 3+ = 33, 6- = 57, 4 = 40, etc.)',...
	  'C9 Geomagnetic activity index (0 to 9) (OMNIWeb1 1-hour)',...
	  'R Sunspot number (OMNIWeb1 1-hour)',...
	  'DST Index (OMNIWeb1 1-hour)',...
	  'Proton flux >1 Mev (OMNIWeb1 1-hour)',...
	  'Proton flux >2 Mev (OMNIWeb1 1-hour)',...
	  'Proton flux >4 Mev (OMNIWeb1 1-hour)',...
	  'Proton flux >10 Mev (OMNIWeb1 1-hour)',...
	  'Proton flux >30 Mev (OMNIWeb1 1-hour)',...
	  'Proton flux >60 Mev (OMNIWeb1 1-hour)',...
	  'Proton flux flag (-1,0,1,2,3,4,5,6) (OMNIWeb1 1-hour)'};

NOTE{2} = 'IMP 1 (Expl 18)=18, IMP 3 (Expl 28)=28, IMP 4 (Expl 34)=34, IMP 5 (Expl 41)=41, IMP 6 (Expl 43)=43, IMP 7 (Expl 47)=47, IMP 8 (Expl 50)=50, IMP 1 (Expl 33)=33, IMP 2 (Expl 35)=35, HEOS 1 and HEOS 2=1, VELA 3=3, OGO 5=5, Merged LANL VELA Speed Data (July 1964 - March 1971)=99, Merged LANL IMP T,N,V (Including all IMP 8 LANL Plasma)=98, ISEE 1=11, ISEE 2=12, ISEE 3=13, PROGNOZ 10=10, WIND=51, ACE=71, No spacecraft=0';
NOTE{3} = NOTE{2};

NOTE{16} = 'sigma B is sqrt((sigma Bx)^2 + (sigma By)^2 +(sigma Bz)^2)';
NOTE{17} = 'The sigma B values were not provided with HEOS IMF data, i.e. for such records the words 21-23 contain sigma|B| (repeat word 19), sigma theta B and sigma phi B in degrees respectively.';
NOTE{18} = NOTE{17};
NOTE{18} = NOTE{17};
NOTE{18} = NOTE{17};
NOTE{18} = NOTE{17};

NOTE{34} = 'See Proton flux flag';
NOTE{35} = 'See Proton flux flag';
NOTE{36} = 'See Proton flux flag';
NOTE{37} = 'See Proton flux flag';
NOTE{38} = 'See Proton flux flag';
NOTE{39} = 'See Proton flux flag';
NOTE{40} = 'If the flag is 0 there are no Proton Flux data, or all of thea Proton Flux data are contaminated by the magnetospheric events. If the flag is 1 then the channels >1,>2,>4,>10,>30 Mev were judged to have magnetospheric "contamination". If the flag is 2 then the channels >1,>2,>4,>10 Mev were judged to have magnetospheric "contamination". If the flag is 3 then the channels>1,>2,>4 Mev were judged to have magnetospheric "contamination". If the flag is 4 then the channels >1,>2 Mev were judged to have magnetospheric "contamination". If the flag is 5 then the channels >1 Mev channels were judged to have magnetospheric "contamination". If the flag is 6 then no channel was judged to have magnetospheric "contamination". If the flag is -1 then not checked for M"sph c: relevant after 88/306.';
