#!/usr/bin/perl
#
#  Usage: octmail.pl Transform file index.html (from Octave mailing
#  list) into data file.  Output file is named octmail.dat.  If
#  octmail.dat exists, contents are concatenated.
# 
#  Usage: octmail.pl FNAME
#  Output file is named FNAME.dat.
#
#  Example page was taken from
#  http://velveeta.che.wisc.edu/octave/lists/help-octave/2006/index.html
#

if (not $ARGV[0] =~ m//) {
    $ARGV[0] = 'octmail'; # If not specified, use octmail as FNAME.
}

print "octmail.pl: parsing index.html and writing $ARGV[0].dat.\n";

open(DATAout,">>$ARGV[0].dat"); 
open(DATAin,"index.html");

while ($line = <DATAin>) {

    if ($line =~ m/<h4>/i) {
	chop($line);
	$time = $line;
	$time =~ s/.*>(.*)<.*/$1/;
	$time =~ s/Jan/1/;  $time =~ s/Feb/2/;
	$time =~ s/Mar/3/;  $time =~ s/Apr/4/;
	$time =~ s/May/5/;  $time =~ s/Jun/6/;
	$time =~ s/Jul/7/;  $time =~ s/Aug/8/;
	$time =~ s/Sep/9/;  $time =~ s/Oct/10/;
	$time =~ s/Nov/11/; $time =~ s/Dec/12/;
	$time =~ s/\-/ /g;
#	print $line;
#	print $time;
    } elsif ($line =~ m/li><a href/) {
	chop($line);
	$subject = $line;
	$subject =~ s/.*\">(.*)<\/a>.*/$1/; # Grab subject line text
	$subject =~ s/^Re: (.*)/$1/; # Remove Re: from start
	@tmp = unpack("C*", $subject); # Convert subject line to ASCII

        # Create array of 10 "-1"s
	$blnks = ' ';
	$blnks =~ s/ /'-1 'x10/e; 
	@Subject = split(/ /,$blnks);

	# Keep only first 10 ASCII values in subject line
	if ($#tmp > 8) {
	    @Subject = @tmp[0 .. 9];
	} else {
	    @Subject[0 .. $#tmp] = @tmp;
	}

#	print "$time @Subject\n";
	print DATAout "$time @Subject\n";

    }

}

close(DATAout);
close(DATAin);
