function [V,ATTR] = SEC_Ap_extract(DATADIR)

% R.S. Weigel 04/03/2004

% Get global variables and path setting
TSDS_GLOBALS;

ATTR{1} = ts_attr;

Year_o = 1932;
Year_f = 1996;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load the historical Ap data from SEC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fname = [DATADIR,'AP3296.DAT'];
ap    = load(fname);

% Grab Ap data to end of 1996 (not all data available for 1997)
If  = find(ap(:,1) == 97);
Ap  = ap(1:If(1)-1,:);
% The sixth column is the daily ap.
Ap  = Ap(:,6);

Attr.Year_o = num2str(Year_o);
Attr.Year_f = num2str(Year_f);
Attr.Size   = size(Ap);

ATTR{1} = Attr;
V{1}    = Ap;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

