function ATTR = WSA_Vsw_info(Attr,VER)

ATTR              = ts_attr;  
ATTR.Source       = 'C. Nick Arge';
ATTR.Created_With = ['WSA_Vsw.m'];
ATTR.Unit         = 'km/s';
ATTR.Version      = VER;
ATTR.TimeUnit     = 'hour';
ATTR.PPD          = 24;
ATTR.Year_o       = Attr.Year_o;
ATTR.Year_f       = Attr.Year_f;
ATTR.Size         = Attr.Size;

if (VER == '0')
  ATTR.Name         = 'WSA model Vsw predictions at L1 (Arge 1-hour)';
  ATTR.Warning     = 'Depreciated. Use v1 instead.';
  ATTR.README       = ['See README.txt ',...
		    'in original-s0/wsa/v0'];
  ATTR.Note         = 'Data extracted from prediction file mwopred4.dat';
end

if (VER == '1')
  ATTR.Name         = 'WSA model Vsw predictions at L1 (Arge 1-hour v1)';
  ATTR.Warning      = '';
  ATTR.Note         = 'Data extracted from prediction file mwopred4.dat';
  ATTR.README       = ['See README.txt ',...
		    'in original-s0/wsa/v1'];
end
