
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
X = ts_slice('WSA model Vsw predictions at L1 (Arge 1-hour)',...
	     [1994 12 5],[1994 12 5]);

% 9691.5 is noon on 1994-12-05
% 9692.0 is midnight on 1994-12-05

hrint = ceil(24*(mod(0.7717+0.5,1))); % Nearest hour interval
if (X(hrint)==598.8)
  fprintf('\nWSA_Vsw_test 1.1 success\n')
else
  error('\nWSA_Vsw_test 1.1 fail\n')
end

if isnan(X(hrint+1))
  fprintf('\nWSA_Vsw_test 1.2 success\n')
else
  error('\nWSA_Vsw_test 1.2 fail\n')
end

hrint = ceil(24*(mod(0.1505+0.5,1))); % Nearest hour interval
if (X(hrint)==671.0)
  fprintf('\nWSA_Vsw_test 1.3 success\n')
else
  error('\nWSA_Vsw_test 1.3 fail\n')
end

X = ts_slice('WSA model Vsw predictions at L1 (Arge 1-hour)',...
	     [1996 1 16],[1996 1 16]);

hrint = ceil(24*(mod(0.3149+0.5,1))); % Nearest hour interval
if (X(hrint)==378.6)
  fprintf('\nWSA_Vsw_test 1.4 success\n')
else
  error('\nWSA_Vsw_test 1.4 fail\n')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
X = ts_slice('WSA model Vsw predictions at L1 (Arge 1-hour v1)',...
	     [1994 12 5],[1994 12 5]);

% 9691.5 is noon on 1994-12-05
% 9692.0 is midnight on 1994-12-05

hrint = ceil(24*(mod(0.5293+0.5,1))); % Nearest hour interval
if (X(hrint)==430.5)
  fprintf('\nWSA_Vsw_test 2.1 success\n')
else
  error('\nWSA_Vsw_test 2.1 fail\n')
end

if isnan(X(hrint+1))
  fprintf('\nWSA_Vsw_test 2.2 success\n')
else
  error('\nWSA_Vsw_test 2.2 fail\n')
end

hrint = ceil(24*(mod(0.9082+0.5,1))); % Nearest hour interval
if (X(hrint)==474.8)
  fprintf('\nWSA_Vsw_test 2.3 success\n')
else
  error('\nWSA_Vsw_test 2.3 fail\n')
end

X = ts_slice('WSA model Vsw predictions at L1 (Arge 1-hour v1)',...
	     [2002 10 24],[2002 10 24]);

hrint = ceil(24*(mod(0.5015+0.5,1))); % Nearest hour interval
if (X(hrint)==434.5)
  fprintf('\nWSA_Vsw_test 2.4 success\n')
else
  error('\nWSA_Vsw_test 2.4 fail\n')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

