%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This code has been tested in Matlab 6.5 on RHEL 3.0
%
% Some edits were made to this after it was last run. (Re-named
% variables).  This latest version has not been tested.
%
% Data are extracted from files in measurements/original_data/FMI_1995_X/data
%
% R.S. Weigel 04/03/2004
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;

% Get global variables and path setting
TSDS_GLOBALS;


%Source = 'http://www.ava.fmi.fi/image/reqform/dataform.html';
%README = 'http://www.ava.fmi.fi/image/request.html';
%Ack = 'http://www.ava.fmi.fi/image/rulesofroad.html';

DATA_DIR      = [TSDS_DATA_LOCAL_WRITE,...
		 'measurements/original_data/FMI_1995_X/'];
SAVE_LOCATION = [TSDS_DATA_LOCAL_WRITE,...
		 'measurements/uniform_time_series/Ground_Magnetometers/FMI/'];
DEMO_LOCATION = [TSDS_DATA_ROOT,'demo_data/'];
end_year      = 2002;

% All possible magnetometers that may show up in a data file.
% If a new magnetometer shows up in a later year, add to list.
% If data for a magnetometer is missing on a given day, it is filled with
% FLAG.  This method should be changed.

MAGLIST = ['AND';'ABK';'BJN';'DOB';...
	   'HAN';'HOP';'HOR';'IVA';...
	   'KEV';'KIL';'KIR';'LOZ';...
	   'LEK';'LYR';'LYC';'MAS';...
	   'MUO';'NAL';'NUR';'OUJ';...
	   'PEL';'RVK';'SOD';'SOR';...
	   'TRO';'TAR';'UPS'];

FLAG_old = 99999.9;

cwd= pwd;
cd(DATA_DIR);

if (1)
!gunzip data.tar.gz
!tar -xvf data.tar
!./data/fix_fmi_file.pl
end

for year = 1995:2002

[jnk,Ndays] = dates(year);
doy         = 1;

% Put headers from each file into one file.  
com = sprintf('!head -1 -q ./data/%d*.dat > ./data/all_headers_%d',year,year);
      eval(com);
      
% Read in the all_headers file
REGEXP      = '=~ m/YYYY/';
header_name = sprintf('./data/all_headers_%d',year);
[I,A]       = perlop(header_name,REGEXP,[],[],'file');

% This should be re-written to use DATESTR and DATENUM.
day1        = ['01';'02';'03';'04';'05';'06';'07';'08';'09'];
day2        = num2str([10:1:31]');
day         = [day1;day2];
month       = day(1:12,:);

for m = 1:12
for d = 1:Ndays(m)
  % Dump the last 1440 minute of data to a temp file (first two lines are text)
  com1 = sprintf('!tail -q -n -1440 ./data/%d%s%s00.dat > temp',...
		 year,month(m,:),day(d,:));
  eval(com1);
  % Load the temp file
  com2 = sprintf('TEMP = load(''temp'');',month(m,:),day(d,:));
  eval(com2);
  
  fprintf('year = %4d month = %2d day = %2d minutes = %3d columns = %2d\n'...
	  ,year,m,d,size(TEMP,1),size(TEMP,2));
  
  % Fill in full matrix with FLAG
  Dx(:,doy,:) = FLAG*ones(1440,size(MAGLIST,1));
  Dy(:,doy,:) = FLAG*ones(1440,size(MAGLIST,1));
  Dz(:,doy,:) = FLAG*ones(1440,size(MAGLIST,1));

  % Every third column is X  
  X     = TEMP(:,[7:3:size(TEMP,2)]);
  Y     = TEMP(:,[8:3:size(TEMP,2)]);
  Z     = TEMP(:,[9:3:size(TEMP,2)]);
  t     = TEMP(:,1:6);

  % B will contain the list of magnetometers in the file  
  [I,B] = perlop(A(doy,21:end),'=~ s/  /\n/g');
  % Each magnetomer name shows up 3 times (one for each component).
  % This keeps only one.
  [I,B] = perlop(B,'=~ s/([A-Z][A-Z][A-Z]) X/$1/g');

  % See which magnetometers in B are in MAGLIST.
  [I,LOC]  = ismember(B(:,1:3),MAGLIST,'rows');
  % This tells us what columns to fill in D.

  Dx(:,doy,LOC)  = X;
  Dy(:,doy,LOC)  = Y;
  Dz(:,doy,LOC)  = Z;
  T(:,doy,:)     = t;
  
  doy = doy + 1;
  
end
end

for k = 1:size(MAGLIST,1)
  X = Dx(:,:,k);
  X = reflag(X(:),FLAG_old,FLAG,1);
  eval(sprintf('save %s%s_X_%d.mat X',SAVE_LOCATION,lower(MAGLIST(k,:)),year));
  Y = Dy(:,:,k);
  Y = reflag(Y(:),FLAG_old,FLAG,1);
  eval(sprintf('save %s%s_Y_%d.mat Y',SAVE_LOCATION,lower(MAGLIST(k,:)),year));
  Z = Dz(:,:,k);
  Z = reflag(Z(:),FLAG_old,FLAG,1);
  eval(sprintf('save %s%s_Z_%d.mat Z',SAVE_LOCATION,lower(MAGLIST(k,:)),year));
end

clear X Y Z Dx Dy Dz;

end

rm('./data/*.dat');
rm('temp');

if (1)
!gzip data.tar
!rm -rf ./data
end

cd(cwd);




