%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Tested on Matlab 6.5 only. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
more off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get global variables and path setting
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
TSDS_GLOBALS;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

MAT_LOCATION = [TSDS_DATA_LOCAL_WRITE,...
		 'measurements/uniform_time_series/'];

DAT_LOCATION = [TSDS_DATA_LOCAL_WRITE,...
		'measurements/original_data/Kyoto_AE_1957_X/AE_1997_X/data'];

% Uncomment this when updating database 
% get_Kyoto_QL;
% Note no QL data available after 2001.

com = [TSDS_PERL_PATH,' ',...
       TSDS_ROOT,'perlfiles/cat_Kyoto_QL.pl ',...
       DAT_LOCATION];
system(com);

% See below and cat_Kyoto_QL.{pl,txt} for info on file format
load all_data.dat

max(all_data(:,7)) % Should be zero

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I    = find(all_data(:,5) == 1); % Find AE rows
AE   = all_data(I,8:67);
AE_T = all_data(I,1:4);
Nhr  = 24*number_days(1997,2001);
T    = ymd([0:Nhr-1]',1997,'hour');

[X1,X2,T] = time_union2([AE_T , AE],T,FLAG,'hour');
AE        = X1';
AE        = AE(:);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I    = find(all_data(:,5) == 2); % Find AL rows
AL   = all_data(I,8:67);
AL_T = all_data(I,1:4);
Nhr  = 24*number_days(1997,2001);
T    = ymd([0:Nhr-1]',1997,'hour');

[X1,X2,T] = time_union2([AL_T , AL],T,FLAG,'hour');
AL        = X1';
AL        = AL(:);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I    = find(all_data(:,5) == 3); % Find AU rows
AU   = all_data(I,8:67);
AU_T = all_data(I,1:4);
Nhr  = 24*number_days(1997,2001);
T    = ymd([0:Nhr-1]',1997,'hour');

[X1,X2,T] = time_union2([AU_T , AU],T,FLAG,'hour');
AU        = X1';
AU        = AU(:);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

com = sprintf('save %smatfiles/Kyoto_QL_AE_1_min_1997_X.mat AL AE AU',...
		    MAT_LOCATION)
eval(com);
rm('all_data.dat');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% columns 1-4:
% Year Month Day Hour 
%
% column 5 (1 = AE, 2=AL, 3=AU): 
% INDEX_CODE 
%
% column 6:
% 00 
%
% column 7:
% base line / 1000 (add this value*1000 to each minute values)
%
% columns 8-67:
% 60 minutes of data in given hour
% 
% column 68:
% mean of 60 minutes of data
%
% R.S. Weigel, 12/01/2004.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



