%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Tested on Matlab 6.5 only.  I have only cleaned data from 1978 to 1983 for
% AL (RSW).  See README file for information on what files were modified.
% This program needs to include AE and AU in data files.
% This program will not run in Octave because it lacks the CAT function.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
more off;

end_year = 1983;

% Get global variables and path setting
TSDS_GLOBALS;

SAVE_LOCATION = [TSDS_DATA_LOCAL_WRITE,'measurements/uniform_time_series/'];

DIR    = [TSDS_DATA_LOCAL_WRITE,...
	  'measurements/original_data/AE_1957_X/AE_1978_1988/DATA_fixed/'];
FLAG   = 99999;
month  = ['01';'02';'03';'04';'05';'06';'07';'08';'09';'10';'11';'12'];
year   = ['1978';'1979';'1980';'1981';'1982';'1983'];
index  = ['AL';'AE';'AU'];

for ind = 1:1

for y = 1:length(year)
for m = 1:12
  fname = sprintf('%sdata=%s%s%s.dat',...
		  DIR,lower(index(ind,:)),year(y,:),month(m,:));
  fprintf('Loading %s\n',fname);
  al{m,y}  = load(fname);
end
end

for y = 1:6
for m = 1:12
  Time         = al{m,y}(:,1:2);
  yrmody_str   = num2str(Time(:,1));
  yr           = 1900+repmat(str2num(yrmody_str(:,1:2)),1,60)';
  mo           = repmat(str2num(yrmody_str(:,3:4)),1,60)';
  dy           = repmat(str2num(yrmody_str(:,5:6)),1,60)';
  hr           = repmat(Time(:,2),1,60)';
  min          = repmat([1:60],size(Time,1),1)';
  TT{m,y}      = datenum(yr(:),mo(:),dy(:),hr(:),min(:),0);
  temp         = al{m,y}(:,3:62)';
  Y{m,y}       = temp(:);
end
Z{y,1}  = cat(1,Y{:,y});
Tt{y,1} = cat(1,TT{:,y});
end

X(:,ind) = cat(1,Z{:});
T(:,ind) = cat(1,Tt{:});

end
T         = T - floor(T(1));
Tmin      = round(T*24*60);
T         = [1:1440*number_days(1978,1983)]';
AL        = FLAG*ones(1440*number_days(1978,1983),1);
AL(Tmin)  = X;

AE        = FLAG*ones(length(AL),1);
AU        = AE;
Z         = [AE AL AU];

com=sprintf('save %smatfiles/Kyoto_Final_AE_AL_AU_1_min_1978_%d.dat AE AL AU',SAVE_LOCATION,end_year);
eval(com);





