# Usage: perl Augsburg_ULF_extract.pl DIR
# 
# Output file has columns 
# YR MO DD HH Tgr Sgr Rgr Tgeo Sgeo Rgeo Timf Simf Rimf V N Bz Dst
#
# R.S. Weigel, 03/10/2005

use File::Find;

system("rm -f $ARGV[0]/Augsburg_ULF_extract.dat");

@directory = ('./');

find(\&wanted, @directory);

$chunk_end = 0;

sub wanted {

    $k = 1;
    $k_bad = 0;
    $DATA_OUT = "Augsburg_ULF_extract.dat";
	
    if ($_ =~ m/.*\.asc/){

	print "Augsburg_ULF_extract.pl is reading $_ ... ";
	open(DATA_in,"$_");

	# Determine month from filename
	$MO = $_;
	$MO = substr($MO,6,2);
	# Determine year from filename
	$YR = $_;
	$YR = substr($YR,4,2);

	# Ignore Y3K problem ...
	if ( ($YR > 93) ) {
	    $YR = $YR + 1900; 
	}
	else {
	    $YR = $YR + 2000; 
	}

	$line1 = <DATA_in>;
	$line2 = <DATA_in>;
	open(DATA_out,">>$ARGV[0]/$DATA_OUT");	    

	while ($line = <DATA_in>) {
	    $line =~ s/\*\*\*\*/NaN/g;
	    print DATA_out "$YR $MO $line";
	}

	print "Done.\n";

	$k = $k + 1;

    }

    close(DATA_out);
    close(DATA_in);
    
    if ($k > 1) {
	print "  Wrote (or appended to) $ARGV[0]/Augsburg_ULF_extract.dat\n";
    }

}

