################################################################
# Usage: perl cat_Kyoto_QL.pl DATADIR
# where DATADIR is directory that contains files with
# names in the form data=YYYYMMDD.qae.
#
# This script removes all non-numbers in each file and
# concatanates all files in a single output file named
# all_data.dat.  Format of all_data.dat is as follows.
#
# columns 1-4:
# Year Month Day Hour 
#
# column 5 (1 = AE, 2=AL, 3=AU): 
# INDEX_CODE 
#
# column 6:
# 00 
#
# column 7:
# base line / 1000 (add this value*1000 to each minute values)
#
# columns 8-67:
# 60 minutes of data in given hour
# 
# column 68:
# mean of 60 minutes of data
#
# R.S. Weigel, 12/01/2004.
################################################################

$dirname = "./";
open(OUTFILE,">$ARGV[0]/all_data.dat");

opendir(DIR, $dirname) or die "can't opendir $dirname: $!";

print "Kyoto_AE_1_min_extract.pl: Reading files.\n";

while (defined($file = readdir(DIR))) {
    if ($file =~ /data=/) {
	open(INFILE,"$dirname/$file");
	$k   = 0;
	while ($line = <INFILE>) {
		$name[0] = [split(/^.*KYOT/, $line)];
		$name[0][1] =~ s/AE/ 1/;
		$name[0][1] =~ s/AL/ 2/;
		$name[0][1] =~ s/AU/ 3/;
		$name[0][1] =~ s/[A-Z]/ /g;
		$name[0][1] =~ s/-/ -/g;
		$name[0][1] =~ s/^(....)(..)(..)/$1 $2 $3/g;
		printf(OUTFILE "%s %s",$name[0][0],$name[0][1]);
	}
	$k = $k + 1;
	close(INFILE);
    }
}
close(OUTFILE);
print "Kyoto_AE_1_min_extract.pl: Wrote $ARGV[0]/all_data.dat\n";

