#!/bin/perl
#  Usage: NGDC_extract_Kp_Ap.pl TEMPDIR DATA_DIR
#  
#  R.S. Weigel 04/07/2004.

use File::Find;
use Cwd;

$DATA_OUT = $ARGV[0] . "/" . "NGDC_extract_Kp_Ap.txt";
open(DATA_out,">$DATA_OUT");

find(\&wanted, $ARGV[1]);

close(DATA_out);

print "NGDC_extract_Kp_Ap.pl wrote $DATA_OUT\n";

sub wanted {

    if ($_ =~ m/[0-9][0-9][0-9][0-9]/){
	print "NGDC_extract_Kp_Ap.pl is operating on file: $_ ... ";

	open(DATA_in,"$_");

	$_ =~ s/([0-9][0-9][0-9][0-9])\..*/$1/;
	
	while ($line = <DATA_in>) {

#	    $YR   = substr($line1,0,2);
	    $YR   = $_; # Get year from filename
	    $MO   = substr($line,2,2);
	    $DY   = substr($line,4,2);
	    $BRN  = substr($line,6,4);
	    $BRDN = substr($line,10,2);
	    $Kp   = substr($line,12,16);
	    $Kps  = substr($line,28,3);
	    $apAp = substr($line,31,27);
	    $Cp   = substr($line,58,3);
	    $C9   = substr($line,61,1);
	    $ISS  = substr($line,62,3);
	    $F10  = substr($line,65,5);
	    $FQ   = substr($line,70,1);

	    $Kp   =~ s/(..)/$1 /g;
	    $apAp =~ s/(...)/$1 /g;
#	    print "$line";
#	    print "$YR $MO $DY $BRN $BRDN $Kp $Kps $apAp $Cp $C9 $ISS $F10 $FQ\n";
	    print(DATA_out "$YR $MO $DY $BRN $BRDN $Kp $Kps $apAp $Cp $C9 $ISS $F10 $FQ\n");

	}

	close(DATA_in);

	print "Done.\n";
    }

}
