# Usage: NSSDC_mpause_crossing_files.pl STEM TMPDIR
#
# Concatenates all files in the current directory with STEM_
# in filename.  Output file STEM_all.dat has columns
# 3-40 that are the same columns 2-39 in aareadme.txt.  columns 1-2
# are the ascii code of the space craft id.  Note that file is not
# sorted with respect to time.
#
#  R.S. Weigel 06/08/2005.

$dirname = './';

opendir(DIR, $dirname) or die "can't opendir $dirname: $!";

open(OUTFILE,">$ARGV[1]/allsats_allyrs.dat");

while (defined($file = readdir(DIR))) {

    if ($file =~ /[0-9].txt/) {

	open(INFILE,"$file");

	while ($line = <INFILE>) {

	    if ($line =~ /A1/){$sc_id = 1;}
	    if ($line =~ /A2/){$sc_id = 2;}
	    if ($line =~ /E3/){$sc_id = 3}
	    if ($line =~ /GE/){$sc_id = 4;}
	    if ($line =~ /HW/){$sc_id = 5;}
	    if ($line =~ /H2/){$sc_id = 6;}
	    if ($line =~ /I1/){$sc_id = 7;}
	    if ($line =~ /I3/){$sc_id = 8;}
	    if ($line =~ /I4/){$sc_id = 9;}
	    if ($line =~ /I6/){$sc_id = 10;}
	    if ($line =~ /I8/){$sc_id = 11;}
	    if ($line =~ /IS/){$sc_id = 12;}
	    if ($line =~ /O5/){$sc_id = 13;}
	    if ($line =~ /P7/){$sc_id = 14;}
	    if ($line =~ /P8/){$sc_id = 15;}
	    if ($line =~ /P1/){$sc_id = 16;}

            # Split $line into array at whitespace
	    @Line  = split(/ /,$line); 

            # SC ID in ascii
#	    @Sc_id = unpack("C*", $Line[0]); 

            # Remove the first element of @Line array
	    shift(@Line); 

	    # print the result to screen
	    #print "@Sc_id @Line"; 

	    # print the result to file
	    printf(OUTFILE "$sc_id @Line");

	    }
    }

    close(INFILE);

}

close(OUTFILE);
print "NSSDC_mpause_cross_extract.pl: Wrote $ARGV[1]/allsats_allyrs.dat\n";



