#  Usage: qd2matrix.pl
#
#  Transforms all data from ISGI quiet day files in current directory into
#  a single file.  Replaces Jan, Feb, ... with 01, 02, ...
#  Replaces A with .1, K with .2, and * with .3.
#  
#  R.S. Weigel 07/13/2004.

$DATA_OUT = 'data_cat.matrix';
open(DATA_out,">$DATA_OUT");

$dirname = './';

opendir(DIR, $dirname) or die "can't opendir $dirname: $!";

while (defined($file = readdir(DIR))) {
    if ($file =~ m/qd[0-9].*\.txt/) {

	open(DATA_in,"$file");
	print "qd2matrix.pl is operating on file: $file ... ";

	while ( $temp = <DATA_in> ){
	    if ($temp =~ m/^\s[A-Z]/){
		chomp($temp);
		$temp =~ s/Jan/01/; $temp =~ s/Feb/02/; $temp =~ s/Mar/03/;
		$temp =~ s/Apr/04/; $temp =~ s/May/05/; $temp =~ s/Jun/06/;
		$temp =~ s/Jul/07/; $temp =~ s/Aug/08/; $temp =~ s/Sep/09/; 
		$temp =~ s/Oct/10/; $temp =~ s/Nov/11/; $temp =~ s/Dec/12/;
		$temp =~ s/A/.1/g;
		$temp =~ s/K/.2/g;
		$temp =~ s/\*/.3/g;
		print(DATA_out "$temp\n");
	    }

	}

	close(INFILE);
	print "Done.\n";
    }
}
print "Output file is data_cat.matrix\n";
close(DATA_out);
