function data = ts_dfread(Attr,Index)
%TS_DFREAD Read data from time series data file
%
%    data = TS_DFREAD(Attr,Index)
%
%    

TSDS_GLOBALS;

Filename = Attr.Filename;

if (is_unix == 1)
  J  = findstr(Filename,'/');
  slash = '/';
end
if (is_unix == 0)
  slash = '\\'; % Octave does not like a lone forward slash.
  J     = findstr(Filename,slash(1));
end

fname_full = Filename;
Filename   = [TSDS_DATA_LOCAL_WRITE,slash(1),fname_full(J(end)+1:end)];


was_gzipped = 0;
if ~exist(Filename)
  if exist([Filename,'.gz']);
    was_gzipped = 1;
    fprintf80(sprintf('ts_dfread     : Unzipping file %s',[Filename,'.gz']));
    gunzip([Filename,'.gz'],TSDS_GZIP);
  end
end

FILE = load(Filename);
data = FILE.Var_cell{Attr.Index};

if (nargin > 1)

  START  = Index{1};
  STRIDE = Index{2};
  EDGE   = Index{3};
  if isempty(STRIDE)
    STRIDE = [1 1];
  end

  data = data(START(1):STRIDE(1):START(1) - 1 + EDGE(1),:);

end

